#!/bin/bash
config_path=/home/sah5056/ws_w1/config/REL/2013-12-06_V8.3.0
workspace_path="/home/sah5056/ws_w1_build /home/sah5056/ws_n1_build"
config_list=`find $config_path -name project.list | sed 's/\/project\.list//g'`
tar_path=/home/sah5056/APP
del_list="/home/sah5056/ws_w1_build/ext/lib/rvmtf"

mkdir -p $tar_path

for config in $config_list
do
	config_name=${config//\//_}
	echo "Name $config_name"
	echo "Fetching $config"
	rm -rf /home/sah5056/ws_w1_build/build
	cleanws 1
	./build.sh $config nobuild

	echo "Appending Component.lic to the list"
	lic_list=""
	for ws in $workspace_path
	do
		echo "Workspace $ws"
		tmp_list=`find $ws -name Component.lic`
		lic_list="$lic_list $tmp_list"
	done

	echo "Looking for sah:proprietary"
	for cp in $lic_list
	do
		grep sah:proprietary $cp > /dev/null
		if [ $? -eq 1 ]
		then
			cp_dir=`dirname $cp`
			echo "Removing $cp_dir"
			rm -rf $cp_dir
		else
			echo "Keeping $cp"
		fi
	done

	echo "Removing special components"
	for i in $del_list
	do
		echo "Removing $i"
		rm -rf $i
	done

	to=${tar_path}/${config_name//_home_sah5056_ws_w1_config_/}.tar.bz
	echo "Backing up $workspace_path to $to"
	tar -cjf $to $workspace_path
done
