# Makefile.global

export GLOBALMAKEFILE=__CWD__/Makefile.global
export STAGINGDIR=__CWD__/output/staging
export RELEASEDIR=__CWD__/output/release
export ROOT_FS_DIR=__CWD__/output/release/root_fs
export PKG_CONFIG_LIBDIR=__CWD__/output/staging/build/pkg-config
export PKG_CONFIG_TOP_BUILD_DIR=__CWD__/output/staging
export PKG_CONFIG_SYSROOT_DIR=__CWD__/output/staging
export PKG_CONFIG_PATH=
export OUTPUTDIR=__CWD__/output

quote := "
empty :=

export CROSS_COMPILE=$(subst $(quote),$(empty),$(CONFIG_CROSS_COMPILE))
SYSROOT = $(addprefix $(empty) ,$(if $(subst $(quote),$(empty),$(CONFIG_BUILD_CROSS_COMPILE_SYSROOT)), --sysroot $(CONFIG_BUILD_CROSS_COMPILE_SYSROOT)))
CC_OPTIONS  = $(addprefix $(empty) ,$(subst $(quote),$(empty),$(CONFIG_BUILD_CC_OPTIONS)))
CXX_OPTIONS = $(addprefix $(empty) ,$(subst $(quote),$(empty),$(CONFIG_BUILD_CXX_OPTIONS)))
USER_CROSS_COMPILE_CPPFLAGS  = $(addprefix $(empty) ,$(subst $(quote),$(empty),$(CONFIG_USER_CROSS_COMPILE_CPPFLAGS)))
USER_CROSS_COMPILE_CFLAGS    = $(addprefix $(empty) ,$(subst $(quote),$(empty),$(CONFIG_USER_CROSS_COMPILE_CFLAGS)))
USER_CROSS_COMPILE_CXXFLAGS  = $(addprefix $(empty) ,$(subst $(quote),$(empty),$(CONFIG_USER_CROSS_COMPILE_CXXFLAGS)))
USER_CROSS_COMPILE_LDFLAGS   = $(addprefix $(empty) ,$(subst $(quote),$(empty),$(CONFIG_USER_CROSS_COMPILE_LDFLAGS)))
CROSS_COMPILE_CPPFLAGS       = $(addprefix $(empty) ,$(subst $(quote),$(empty),$(CONFIG_BUILD_CROSS_COMPILE_CPPFLAGS)))
CROSS_COMPILE_CFLAGS         = $(addprefix $(empty) ,$(subst $(quote),$(empty),$(CONFIG_BUILD_CROSS_COMPILE_CFLAGS)))
CROSS_COMPILE_CXXFLAGS       = $(addprefix $(empty) ,$(subst $(quote),$(empty),$(CONFIG_BUILD_CROSS_COMPILE_CXXFLAGS)))
CROSS_COMPILE_LDFLAGS        = $(addprefix $(empty) ,$(subst $(quote),$(empty),$(CONFIG_BUILD_CROSS_COMPILE_LDFLAGS)))
CROSS_COMPILE_OPTIMIZE_FLAGS = $(subst $(quote),$(empty),$(if $(filter y,$(CONFIG_BUILD_MODE_RELWITHDBGINFO)),$(CONFIG_BUILD_CROSS_COMPILE_OPTIMIZE_FLAGS_RELWITHDBGINFO))$(if $(filter y,$(CONFIG_BUILD_MODE_RELEASE)),$(CONFIG_BUILD_CROSS_COMPILE_OPTIMIZE_FLAGS_RELEASE))$(if $(filter y,$(CONFIG_BUILD_MODE_DEBUG)),$(CONFIG_BUILD_CROSS_COMPILE_OPTIMIZE_FLAGS_DEBUG)))
AUTOCONF_HOST  = $(shell $(CROSS_COMPILE)gcc -dumpmachine)
AUTOCONF_BUILD = $(shell gcc -dumpmachine)
# legacy DEV/STB build compat
CONFIG_DEBUG = $(CONFIG_BUILD_MODE_DEBUG)

export AS            = $(CROSS_COMPILE)as
export LD            = $(CROSS_COMPILE)ld$(SYSROOT)
export CC            = $(CROSS_COMPILE)gcc$(CC_OPTIONS)$(SYSROOT)
export CXX           = $(CROSS_COMPILE)g++$(CXX_OPTIONS)$(SYSROOT)
export C++           = $(CROSS_COMPILE)c++$(CXX_OPTIONS)$(SYSROOT)
export G++           = $(CROSS_COMPILE)g++$(CXX_OPTIONS)$(SYSROOT)
export REAL_CC       = $(CROSS_COMPILE)gcc$(CC_OPTIONS)$(SYSROOT)
export REAL_CXX      = $(CROSS_COMPILE)g++$(CXX_OPTIONS)$(SYSROOT)
export REAL_C++      = $(CROSS_COMPILE)c++$(CXX_OPTIONS)$(SYSROOT)
export REAL_G++      = $(CROSS_COMPILE)g++$(CXX_OPTIONS)$(SYSROOT)
export NASM          = $(CROSS_COMPILE)nasm
export AR            = $(CROSS_COMPILE)ar
export NM            = $(CROSS_COMPILE)nm
export STRIP         = $(CROSS_COMPILE)strip
export OBJCOPY       = $(CROSS_COMPILE)objcopy
export OBJDUMP       = $(CROSS_COMPILE)objdump
export RANLIB        = $(CROSS_COMPILE)ranlib
export READELF       = $(CROSS_COMPILE)readelf
export CC_NOCCACHE   = $(CROSS_COMPILE)gcc$(CC_OPTIONS)$(SYSROOT)
export CXX_NOCCACHE  = $(CROSS_COMPILE)g++$(CXX_OPTIONS)$(SYSROOT)
export INSTALL       = /usr/bin/install
export VFSL_INSTALL  = $(OUTPUTDIR)/../scripts/install/vfsl_install.sh
export CPPFLAGS      = $(CROSS_COMPILE_CPPFLAGS) $(USER_CROSS_COMPILE_CPPFLAGS)
export CFLAGS        = $(CROSS_COMPILE_CFLAGS) $(CROSS_COMPILE_OPTIMIZE_FLAGS) $(USER_CROSS_COMPILE_CFLAGS)
export CXXFLAGS      = $(CROSS_COMPILE_CXXFLAGS) $(CROSS_COMPILE_OPTIMIZE_FLAGS) $(USER_CROSS_COMPILE_CXXFLAGS)
export LDFLAGS       = $(CROSS_COMPILE_LDFLAGS) $(USER_CROSS_COMPILE_LDFLAGS)
export AUTOCONF_HOST
export AUTOCONF_BUILD
export BINARY_PACKAGE_CREATION = y

export HARDCO_HAL_DIR=
export HARDCO_KERNEL_DIR=__CWD__/../../../sah/kernel/IKANOS/GEN/R_LRG_8.1/PROJ/SAGEM_PROV3/REL/2014-12-03_V2.13.0
export HARDCO_TOOLCHAIN_DIR=

include $(STAGINGDIR)/components.config

ifndef MAKEFILE_GLOBAL_EVALUATED
export MAKEFILE_GLOBAL_EVALUATED = 1
# The ifndef avoids evaluating these lines in recursive makefiles
# We must still use immediate evaluation for shell commands, else they would get evaluated on each recipe execution in the top level makefile

export PATH               := $(STAGINGDIR)/utils:$(PATH)

export COMPRESSOR         := $(shell which yui-compressor)

export DUMP_CMD           := $(shell $(CC) -dumpmachine | awk '{split($$0,array,"-")} END{print array[1]}' | tr [:upper:] [:lower:] )
export TARGET_MACHINE_CMD := case "$(DUMP_CMD)" in "arm") echo "ARM" ;; "mips") echo "MIPS" ;; "i486") echo "INTEL" ;; "i686") echo "INTEL" ;; *) echo "UNKNOWN" ;; esac
export TARGET_MACHINE     := $(shell $(TARGET_MACHINE_CMD))

endif
