#!/bin/sh
# the next line restarts using tclsh \
    exec tclsh "$0" "$@"

set scriptdir [file dirname [info script]]
set libDirectory [file join $scriptdir lib]
set auto_path [linsert $auto_path 0 $libDirectory]

package require buildsystem
namespace import buildsystem::*

#parse commandline options
buildsystem::parseGetSourceArgs $::argv
array set globaloptions [buildsystem::getGlobalOptions]
buildsystem::parse_defconfig $globaloptions("defconfig")

if { $globaloptions("buildPackage") == 1 } {
    set buildPackage 1
    puts "##-# ----> (getsource.tcl) : buildpackage"
} else {
    set buildPackage 0
    puts "##-# ----> (getsource.tcl) : build normal"
}
#read the server.cfg
array set globalbuildcfg [buildsystem::read_servers $globaloptions("buildconfigfile")]

# read opensource include list
# this is for forcefully including none opensource components in a opensource build
buildsystem::parse_include_list $globaloptions("opensource_include")

# read the component exclude list
buildsystem::parse_component_exclude_list $globaloptions("component_exclude")

#read componentlist
array set globalcomponentlst [buildsystem::read_components "$scriptdir/component.lst"]

#compute root pathlist
buildsystem::compute_rootpathlst

# we directly read out a dependency file which acts more as a meta package
set cnames [buildsystem::read_componentdeps $globaloptions("projectdependenciesfile")]
buildsystem::read_gs_deps $cnames
buildsystem::check_deps
buildsystem::writeRootPathFile "rootpath.cfg"

if { $globaloptions("fullclean") == 1 } {
    buildsystem::cleanFully
} else { 
    buildsystem::getSource
}

buildsystem::writeCurProjectList $scriptdir
buildsystem::write_defconfig $scriptdir/rebuild_defconfig
