package provide buildsystem 1.0

namespace eval buildsystem {
    variable component_exclude_lst
    set component_exclude_lst ""
}

proc buildsystem::parse_component_exclude_list {fileName} {
    variable component_exclude_lst

    if {![file exists $fileName]} {
        puts "\033\[33mWarning: file not found $fileName\033\[0m"
        return 0
    }
    set fd [open $fileName "r"]
    while {[gets $fd line] >= 0} {
        set name    [lindex $line 0]
        lappend component_exclude_lst $name
    }
    close $fd
    puts "Component exclude list:"
    puts $component_exclude_lst
    return 1
}

proc buildsystem::is_component_excluded {name} {
    variable component_exclude_lst

    foreach cmp $component_exclude_lst {
        if {![string compare $cmp $name]} {
            return 1
        }
    }
    return 0
}
