package provide buildsystem 1.0

namespace eval buildsystem {
    variable opensrc_include_lst
    set opensrc_include_lst ""
    set opensrc_exclude_lst ""
}

proc buildsystem::parse_include_list {fileName} {
    variable opensrc_include_lst
    variable opensrc_exclude_lst

    if {![file exists $fileName]} {
        puts "\033\[33mWarning: file not found $fileName\033\[0m"
        return 0
    }
    set fd [open $fileName "r"]
    while {[gets $fd line] >= 0} {
        set l [split $line ":"]
        set name    [lindex $l 0]
        set enabled [lindex $l 1]
        if {$enabled} {
            lappend opensrc_include_lst $name
        } else {
            lappend opensrc_exclude_lst $name
        }
    }
    close $fd
    puts $opensrc_include_lst
    return 1
}

proc buildsystem::opensrc_is_included {name} {
    variable opensrc_include_lst

    foreach cmp $opensrc_include_lst {
        if {![string compare $cmp $name]} {
            return 1
        }
    }
    return 0
}

proc buildsystem::opensrc_is_excluded {name} {
    variable opensrc_exclude_lst

    foreach cmp $opensrc_exclude_lst {
        if {![string compare $cmp $name]} {
            return 1
        }
    }
    return 0
}
