#!/bin/bash

# Script to install the correct script to $STAGINGDIR/install_scripts.mk
# based on config flags

STAGINGDIR=$1

function check_config_parameter() {
	_value="CONFIG_$1=y"
	grep $_value $STAGINGDIR/components.config 2>/dev/null >/dev/null
	echo $?
}

TYPE=$(check_config_parameter "STARTUP_ETC_RC_BASED")
if [ "$TYPE" == "0" ]; then
	echo "Startup /etc/rcS based"
	ETC_READONLY=$(check_config_parameter "ETC_READONLY")
	if [ "$ETC_READONLY" == "0" ]; then
		echo "Startup system used is /etc/rcS, /etc is read-only."
		install -m 644 ./scripts/install_scripts/etc_rc_based/etc_readonly/install_scripts.mk $STAGINGDIR/install_scripts.mk
		exit 0
	else
		echo "Startup system used is /etc/rcS, /etc is writeable."
		install -m 644 ./scripts/install_scripts/etc_rc_based/etc_writeable/install_scripts.mk $STAGINGDIR/install_scripts.mk
		exit 0
	fi
	exit 0
fi

TYPE=$(check_config_parameter "STARTUP_ETC_RCD_RCS_BASED")
if [ "$TYPE" == "0" ]; then
    install -m 644 ./scripts/install_scripts/etc_rcd_rcs_based/install_scripts.mk $STAGINGDIR/install_scripts.mk
fi

# if nothing is set, use STB script
install -m 644 ./scripts/install_scripts/etc_rcd_rcs_based/install_scripts.mk $STAGINGDIR/install_scripts.mk
exit 0
