BUILDDIR=$(OUTPUTDIR)/..
RUI=$(STAGINGDIR)/build/bin/rui
MKSQUASHFS=$(STAGINGDIR)/build/bin/mksquashfs
PACKAGEPATH=$(OUTPUTDIR)/packages/$(PACKAGENAME)
PACKAGECONTENT=$(PACKAGEPATH)/content

MODPKG_DEPENDENCIES=$(shell cat $(STAGINGDIR)/modpkg_dependencies)

# preventing modpkg_all to be the default target
build_all_first: all

modpkg_all: $(addprefix modpkg_,$(MODPKG_DEPENDENCIES))
ifeq ("$(wildcard $(RUI))","")
	@echo "'rui' executable not found, unable to create package!"
	@exit 1
endif
ifeq ("$(wildcard $(MKSQUASHFS))","")
	@echo "'mksquashfs' executable not found, unable to create package!"
	@exit 1
endif
	$(INSTALL) -d $(PACKAGEPATH)/content

modpkg_install: custom_install
	$(MKSQUASHFS) $(PACKAGEPATH)/content $(PACKAGEPATH)/content.img -noappend -be -b 65536 -lzmadic 65536
	$(RUI) create \
		-r $(PACKAGEPATH)/$(PACKAGENAME).rui -i $(PACKAGEPATH)/content.img \
		-p $(CONFIG_VERSION_BUILDNAMEPFX) -h $(CONFIG_HARDWARE) -c $(CONFIG_VERSION_BUILDVARIANT) \
		-v "$(CONFIG_VERSION_NAME_MAJOR).$(CONFIG_VERSION_NAME_MINOR)" -t "application" \
		-n "$(PACKAGENAME)" -V $(PACKAGEVERSION)

$(addprefix modpkg_,$(MODPKG_DEPENDENCIES)):
	fakeroot -- $(MAKE) -C $(BUILDDIR) -f Makefile.components $(subst modpkg_,,$@)_component_release ROOT_FS_DIR=$(PACKAGEPATH)/content
