our $cplst      = {};
our $excplst    = {};
our $cached_cp  = {};

sub getReleaseStringFromP4Uri {
    my $line    = shift;
    my $path    = "";
    my $rel     = "";
    if ($line =~ /^(.*)\/REL\/(.*)$/) {
        $path = $1;
        $rel  = $2;
        return($path, $rel);
    }
    return($path, $rel);
}

sub parseComponentLst {
    my  $file   = shift;
    our $cplst;
    my  $cp;
    my  $location;
    my  $server;

    my @lines = readFile($file);
    foreach my $line (@lines) {
        if ($line =~ /^(.*)=(.*):(.*)$/) {
            $cp         = $1; 
            $server     = $2; 
            $location   = $3; 
            $cplst->{$cp}->{"server"}   = $server;
            $cplst->{$cp}->{"location"} = $location;
        }
    }   
}

sub getComponentServer {
    our $cplst;
    my $cp = shift;
    return $cplst->{$cp}->{"server"};
}

sub getComponentLocation {
    our $cplst;
    my $cp = shift;
    return $cplst->{$cp}->{"location"};
}

sub existsComponent {
    our $cplst;
    my $cp = shift;
    my $tst = exists($cplst->{$cp}->{"location"}) ? 1 : 0;
    return $tst;
}

sub addCPToExcludeList {
    my $cur_rel     = shift;
    my $cp;
    our $excplst;
    if ($cur_rel =~ /^(.*)=.*$/) {
        $cp             = $1;
        $excplst->{$cp} = 1;
    }
}

sub cpIsExcluded {
    my $cp  = shift;
    our $excplst;

    if (exists($excplst->{$cp})) {
        return 1;
    }
    return 0;
}

sub cp_cache_exist {
    our $cached_cp;
    my $server      = shift;
    my $location    = shift;

    my $version     = $cached_cp->{$server}->{$location};
    my $tst         = exists($cached_cp->{$server}->{$location}) ? 1 : 0;


#   print "DEBUG tsssst $server $location $version\n";
#   print "DEBUG exist $server $location $tst\n";
    return $tst;
}

sub cp_cache_get {
    our $cached_cp;
    my $server      = shift;
    my $location    = shift;
    my $version     = $cached_cp->{$server}->{$location};

#   print "DEBUG get $server $location $version\n";

    return $version;
}

sub cp_cache_add {
    our $cached_cp;
    my $server      = shift;
    my $location    = shift;
    my $version     = shift;

    $cached_cp->{$server}->{$location} = $version;
    $version = $cached_cp->{$server}->{$location};
#print "DEBUG adding $server $location $version\n";
    return;
}

1;
