use strict;
use Git::Repository;
use Git::Repository::Command;

sub gitExistsRepo {
    my $path   = shift;

    if (-d "$path/.git") {
        return 1;
    } else {
        return 0;
    }
}

sub gitUpdateRepo {
    my $repo_path   = shift;
    my $repo_name   = shift;
    my $repo_tag    = shift;
    my $r;

    $r = Git::Repository->new(work_tree => $repo_path );
    $r->run( add => '.' );
    $r->run( commit => '-m', 'Updating repo for component' . $repo_name . ' release ' . $repo_tag);
}

sub gitCreateRepo {
    my $repo_path   = shift;
    my $repo_name   = shift;
    my $repo_tag    = shift;
    my $r;

    Git::Repository->run(init => $repo_path);
    $r = Git::Repository->new(work_tree => $repo_path );
    $r->run( add => '.' );
    $r->run( commit => '-m', 'Creating repo for component' . $repo_name . ' release ' . $repo_tag);
}

sub gitTagRepo {
    my $repo_path   = shift;
    my $repo_name   = shift;
    my $repo_tag    = shift;
    my $r;

    $r = Git::Repository->new(work_tree => $repo_path );
    $r->run( tag => '-m', 'Updating repo for component'. $repo_name . ' release ' . $repo_tag, $repo_tag );
}

sub gitTagExistsRepo {
    my $repo_path   = shift;
    my $repo_tag    = shift;
    my $r;

    $r = Git::Repository->new(work_tree => $repo_path );
    my $cmd = $r->run( tag => '-l');

    my @tags = split '\n', $cmd;
    foreach my $tag (@tags) {
        if ($tag eq $repo_tag) {
            return 1;
        }
    }
    return 0;
}

sub gitListTagsRepo {
    my $repo_path   = shift;
    my $r;

    $r = Git::Repository->new(work_tree => $repo_path);
    my $cmd = $r->run( tag => '-l');

    my @tags = split '\n', $cmd;
    return @tags;
}

1;
