ifeq ($(shell echo "int main(){return 0;}" | $(CC) -xc --sysroot=$(STAGINGDIR) - -o/dev/null 2>&1),)
export LDFLAGS="--sysroot=$(STAGINGDIR)"
endif

ifdef STAGINGDIR
include $(STAGINGDIR)/components.config
endif

AUTO_ARCHIVE=ffmpeg-0.6.1.tar.bz2
AUTO_SRCPATH=ffmpeg-0.6.1
AUTO_PATCHES= \
        patches/netgem/libavformat/avidec.c.netgem.patch \
        patches/netgem/libavformat/utils.c.netgem.patch \
        patches/sah/libavformat/aviobuf.c.sah.patch \
        patches/sah/libavformat/avformat.h.sah.patch \
        patches/sah/libavformat/mov.c.sah.patch \
        patches/sah/libavformat/matroskadec.c.sah.patch \
        patches/sah/libavformat/matroska.h.sah.patch \
        patches/sah/libavformat/utils.c.sah.patch \
        patches/sah/libavformat/metadata.c.sah.patch \
        patches/sah/libavcodec/h264.c.sah.patch \
        patches/sah/libavcodec/h264_mp4toannexb_bsf.c.sah.patch \
        patches/sah/libavutil/libm.h.sah.patch \
        patches/sah/configure.sah.patch \
        patches/sah/libavcodec/fix-ARM-build.patch

ifeq ($(CONFIG_SAGEMCOM_ITSAD88_LOT3),y)
# ffmpeg 0.6.1 does not build with _FORTIFY_SOURCE on STLinux 2.3
# without this because of a toolchain bug
AUTO_PATCHES+=patches/sah/configure-no-error-missing-prototypes.sah.patch
endif

AUTO_CONF= \
    --prefix=/usr \
	--disable-symver \
	--disable-ffserver \
	--disable-ffmpeg \
	--disable-ffplay \
	--disable-protocols \
	--disable-network \
	--disable-bsfs \
	--disable-static \
	--disable-indevs \
	--disable-outdevs \
	--disable-filters \
	--disable-zlib \
	--disable-bzlib \
	--disable-encoders \
	--disable-muxers \
	--disable-demuxers \
	--disable-parsers \
	--disable-decoders \
	--enable-protocol=file \
	--enable-demuxer=avi \
	--enable-demuxer=mov \
	--enable-demuxer=mp3 \
	--enable-demuxer=mpegps \
	--enable-demuxer=mpegvideo \
	--enable-demuxer=wav \
	--enable-demuxer=ac3 \
	--enable-demuxer=aac \
	--enable-demuxer=aiff \
	--enable-demuxer=amr \
	--enable-demuxer=avisynth \
	--enable-demuxer=dts \
	--enable-demuxer=eac3 \
	--enable-demuxer=flac \
	--enable-demuxer=flv \
	--enable-demuxer=gsm \
	--enable-demuxer=h264 \
	--enable-demuxer=msmpeg4v2 \
	--enable-demuxer=mpeg4v2 \
	--enable-demuxer=mpeg4 \
	--enable-demuxer=m4v \
	--enable-demuxer=matroska \
	--enable-demuxer=mov \
	--enable-demuxer=mpegts \
	--enable-demuxer=mpegtsraw \
	--enable-demuxer=ogg \
	--enable-demuxer=swf \
	--enable-bsf=h264_mp4toannexb \
	--enable-shared \
	--cross-prefix=$(CROSS_COMPILE) \
	--target-os=linux \
	--arch="$(firstword $(subst -, ,$(shell $(CC) -dumpmachine)))"

# Define the configuration depending on the configuration
ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_PARSER_MPEGVIDEO),y)
AUTO_CONF+=--enable-parser=mpegvideo
endif

ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_PARSER_MPEGAUDIO),y)
AUTO_CONF+=--enable-parser=mpegaudio
endif

ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_PARSER_AC3),y)
AUTO_CONF+=--enable-parser=ac3
ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_PARSER_AC3),y)
AUTO_CONF+=--enable-decoder=ac3
endif
endif

ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_PARSER_EAC3),y)
AUTO_CONF+=--enable-parser=eac3
ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_PARSER_EAC3),y)
AUTO_CONF+=--enable-decoder=eac3
endif
endif

ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_ENCODER_PCMS16BE),y)
AUTO_CONF+=--enable-encoder=pcm_s16be
endif

ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_DECODER_H264),y)
AUTO_CONF+=--enable-decoder=h264
endif
ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_DECODER_MPEG2VIDEO),y)
AUTO_CONF+=--enable-decoder=mpeg2video
endif

ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_DECODER_MPEG4),y)
AUTO_CONF+=--enable-decoder=mpeg4
endif

ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_DECODER_MP1),y)
AUTO_CONF+=--enable-decoder=mp1
endif

ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_DECODER_MP2),y)
AUTO_CONF+=--enable-decoder=mp2
endif

ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_DECODER_MP3),y)
AUTO_CONF+=--enable-decoder=mp3
endif

ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_DECODER_AAC),y)
AUTO_CONF+=--enable-decoder=aac
endif

ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_PARSER_H264),y)
AUTO_CONF+=--enable-parser=h264
endif

ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_ENABLE_PCM_BE_DECODERS),y)
AUTO_CONF+=--enable-decoder=pcm_s16be
AUTO_CONF+=--enable-demuxer=pcm_s16be
AUTO_CONF+=--enable-decoder=pcm_u16be
AUTO_CONF+=--enable-demuxer=pcm_u16be
endif

ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_ENABLE_FLAC_DECODER),y)
AUTO_CONF+=--enable-parser=flac
AUTO_CONF+=--enable-decoder=flac
endif

ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_ENABLE_VORBIS_DECODER),y)
AUTO_CONF+=--enable-decoder=vorbis
AUTO_CONF+=--enable-demuxer=ogg
endif

ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_ENABLE_ASF_DEMUXER),y)
AUTO_CONF+=--enable-demuxer=asf
endif

ifeq ($(CONFIG_ST_ORLY),y)
CONFIG_CC_OPTIONS+=-mfpu=vfpv3-d16
endif

# ffmpeg custom configure script tries to quote its arguments, so --with-cc="gcc -m32" would not be parsed properly
# pass the compiler argument as cflags and ldflags
CC_OPTIONS=$(CONFIG_CC_OPTIONS)$(CONFIG_BUILD_CC_OPTIONS)
ifneq ($(CC_OPTIONS),)
AUTO_CONF+=--extra-cflags=$(CC_OPTIONS) --extra-ldflags=$(CC_OPTIONS)
endif

ifneq ($(CONFIG_DEBUG)$(CONFIG_BUILD_MODE_DEBUG)$(CONFIG_BUILD_MODE_RELWITHDBGINFO),)
AUTO_CONF+= \
	--enable-debug=2 \
	--disable-optimizations \
	--disable-stripping
ifneq ($(CONFIG_INTEL_GROVELAND)$(CONFIG_X86_32),)
# not enough registers with IntelCE and i586 toolchain
AUTO_CONF+=--disable-asm
endif
else
AUTO_CONF+= \
	--disable-debug \
	--enable-small
endif

AUTO_RELEASE=usr/lib/libav*
ifeq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_SWSCALE),y)
AUTO_RELEASE+=usr/lib/libswscale.so.*
endif

# ffmpeg does not support autoreconf & standard options
AUTO_RECONF=n
AUTO_ISAUTOCONF=n

all: auto_all

install: auto_install
ifneq ($(CONFIG_OPENSOURCE_LIB_FFMPEG_SWSCALE),y)
	rm -f $(STAGINGDIR)/usr/lib/libswscale.so*
	rm -f $(STAGINGDIR)/usr/lib/pkgconfig/libswscale.pc
endif

release: auto_release
clean: auto_clean

ifdef STAGINGDIR
include $(STAGINGDIR)/buildutils/auto.mk
endif

