ifdef $(STAGINGDIR)
include $(STAGINGDIR)/sahcommon.mk
endif

ifeq ($(strip $BUILDDIR)),)
BUILDDIR := $(shell pwd)
endif

ifneq ($(HARDCO_KERNEL_DIR),)
export KERNELDIR=$(HARDCO_KERNEL_DIR)
endif

all: $(BUILDDIR)/krtpproxy.ko

$(BUILDDIR)/krtpproxy.ko:
	$(MAKE) modules

install:
	$(MAKE) modules_install INSTALL_MOD_PATH=$(STAGINGDIR)
	$(call install_init,fdproxy,80,)

release:
	$(MAKE) modules_install INSTALL_MOD_PATH=$(ROOT_FS_DIR)
	$(call install_init_release,fdproxy,80,)

clean:
	$(MAKE) clean

build_package:
	make -f Component.mk release ROOT_FS_DIR=$(COMP_PACKAGE_DIR)

release_package:
	cp -af $(COMP_PACKAGE_DIR)/* $(ROOT_FS_DIR)

.PHONY: all install release clean build_package release_package

