include $(STAGINGDIR)/components.config

all: Makefile
	make

USBDROPDIR := /lib/pcsc/drivers

Makefile:
	./configure --host=$(AUTOCONF_HOST) \
 	  --enable-usbdropdir=$(USBDROPDIR) \
    --with-gnu-ld          \
    --enable-shared        \
    --disable-static       \
    --disable-multi-thread \
    --disable-twinserial   \
    --enable-libudev       \
	  PCSC_CFLAGS="-I$(STAGINGDIR)/include/PCSC/" \
	  PCSC_LIBS="-L$(STAGINGDIR)/lib -lpcsclite -lpthread" \
    LIBUSB_CFLAGS="-I$(STAGINGDIR)/include/libusb-1.0/ -pthread" \
    LIBUSB_LIBS="-L$(STAGINGDIR)/lib -lusb-1.0 -ludev" \
    LDFLAGS="$(LDFLAGS)"

clean:
	if [ -f Makefile ]; then make distclean; fi

install: Makefile
	make install
	$(INSTALL) -d $(STAGINGDIR)/$(USBDROPDIR)/ifd-ccid.bundle/Contents/Linux/
	$(INSTALL) -d $(STAGINGDIR)/lib/pcsc/readers/
	$(INSTALL) -m 644 src/Info.plist $(STAGINGDIR)/$(USBDROPDIR)/ifd-ccid.bundle/Contents/
	$(INSTALL) -m 644 src/.libs/libccid.so $(STAGINGDIR)/$(USBDROPDIR)/ifd-ccid.bundle/Contents/Linux/
	$(INSTALL) -m 444 readers/supported_readers.txt $(STAGINGDIR)/lib/pcsc/readers/

release:
	$(INSTALL) -d $(ROOT_FS_DIR)/$(USBDROPDIR)/ifd-ccid.bundle/Contents/Linux/
	$(INSTALL) -m 644 $(STAGINGDIR)/$(USBDROPDIR)/ifd-ccid.bundle/Contents/Info.plist $(ROOT_FS_DIR)/$(USBDROPDIR)/ifd-ccid.bundle/Contents/
	$(INSTALL) -m 644 $(STAGINGDIR)/$(USBDROPDIR)/ifd-ccid.bundle/Contents/Linux/libccid.so $(ROOT_FS_DIR)/$(USBDROPDIR)/ifd-ccid.bundle/Contents/Linux/
	$(STRIP) $(ROOT_FS_DIR)/$(USBDROPDIR)/ifd-ccid.bundle/Contents/Linux/libccid.so

.PHONY: clean install release
