VERSION=0.14
PROGRAM=libdaemon.so.$(VERSION)

ifeq ($(notdir $(CC)),gcc)
	CFG:=--host=i386-linux --enable-shared --with-gnu-ld
else
	CFG:=--build=i386-linux --host=mips-linux
endif

all: libdaemon/libdaemon.la

libdaemon/libdaemon.la:
	INSTALL="$(INSTALL) -p" ./configure $(CFG) --prefix=/ --disable-lynx --disable-examples ac_cv_func_setpgrp_void=y
	make

clean:
	-make clean
	rm -f Makefile config.h config.log config.status libtool stamp-h1
	rm -f doc/Makefile doc/README.html doc/doxygen.conf
	rm -f examples/Makefile
	rm -rf examples/.deps
	rm -rf libdaemon/.deps
	rm -f libdaemon/Makefile
	rm -f pkgconfig/libdaemon-uninstalled.pc pkgconfig/libdaemon.pc

install:
	@echo " ##   Installing $(PROGRAM)"
	make DESTDIR=$(STAGINGDIR) install

release:
	@echo " ##   Releasing $(PROGRAM)"
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 755 ${STAGINGDIR}/lib/libdaemon.so.0.5.0 $(ROOT_FS_DIR)/lib/
	${STRIP} $(ROOT_FS_DIR)/lib/libdaemon.so.0.5.0
	cd $(ROOT_FS_DIR)/lib ; ln -sf libdaemon.so.0.5.0 libdaemon.so.0
	cd $(ROOT_FS_DIR)/lib ; ln -sf libdaemon.so.0.5.0 libdaemon.so

doc:

.PHONY: all install release clean doc Makefile
