include $(STAGINGDIR)/components.config

CONFIGURE_CPPFLAGS := -I$(STAGINGDIR)/include
ifeq ($(CONFIG_SAH_LIB_GTOP11DOTNET_DEBUG), y)
	CONFIGURE_CPPFLAGS := -g -O0 $(CONFIGURE_CPPFLAGS)
endif

all: Makefile
	make

gtop11dotnet.pc: gtop11dotnet.pc.m4 $(STAGINGDIR)/components.config
	m4 -I$(STAGINGDIR) -DSTAGINGDIR=$(STAGINGDIR) $< > $@

Makefile:
	./configure --host=$(AUTOCONF_HOST) \
	--prefix=$(STAGINGDIR) \
	PCSC_CFLAGS="-I$(STAGINGDIR)/include/PCSC" \
	PCSC_LDLIBS="-L$(STAGINGDIR)/lib -lpcsclite -lusb -ludev -lpthread" \
	CPPFLAGS="$(CONFIGURE_CPPFLAGS)" \
	LDFLAGS="-L$(STAGINGDIR)/lib -lpthread"

clean:
	if [ -f Makefile ]; then make distclean; fi
	rm -f gtop11dotnet.pc

install: Makefile gtop11dotnet.pc
	make install
	$(INSTALL) -d $(STAGINGDIR)/include/gtop11dotnet/
	$(INSTALL) -m 444 cryptoki.h pkcs11.h pkcs11f.h pkcs11t.h pkcs-11v2-20a3.h $(STAGINGDIR)/include/gtop11dotnet/
	$(INSTALL) -D -m 0644 gtop11dotnet.pc $(PKG_CONFIG_LIBDIR)/

release:
	$(INSTALL) -d $(ROOT_FS_DIR)/$(USBDROPDIR)/ifd-ccid.bundle/Contents/Linux/
	$(INSTALL) -m 644 $(STAGINGDIR)/lib/libgtop11dotnet.so.0.0.0 $(ROOT_FS_DIR)/lib/libgtop11dotnet.so
ifneq ($(CONFIG_SAH_LIB_GTOP11DOTNET_DEBUG), y)
	$(STRIP) $(ROOT_FS_DIR)/lib/libgtop11dotnet.so
endif

.PHONY: clean install release

