include $(STAGINGDIR)/sahcommon.mk

CFLAGS += -fPIC -g -O2 -Wall -Wextra -I. -I./include -I$(STAGINGDIR)/include $(shell pkg-config --cflags sahtrace pcb) \
	-DCONFIG_PCB_USE_INLINE_FUNCS
LDFLAGS += -L$(STAGINGDIR)/lib $(shell pkg-config --libs sahtrace pcb)

LIBS = libnemo_client.so

OBJS-libnemo_client.so = client/csi.o client/util.o client/common_api.o client/dhcp-api.o client/wlan.o client/netdev.o client/ra-api.o

OBJS = $(OBJS-libnemo_client.so)

INSTALL-lib=/lib/libnemo_client.so
INSTALL-header=/include/nemo/client.h /include/nemo/common_api.h \
	/include/nemo/client/csi.h /include/nemo/client/dhcp.h \
	/include/nemo/client/netdev.h /include/nemo/client/wlan.h /include/netdev/common_api.h /include/nemo/client/ra.h
INSTALL-pkg-config=nemo_client.pc netdev_client.pc

INSTALL-all = $(INSTALL-lib) $(INSTALL-header)
RELEASE-all = $(INSTALL-lib)

all: $(LIBS)

libnemo_client.so: $(OBJS-libnemo_client.so)

clean:
	rm -f $(LIBS) $(OBJS) $(OBJS:.o=.d)

install: all  $(addprefix $(STAGINGDIR),$(INSTALL-all)) $(addprefix $(PKG_CONFIG_LIBDIR)/,$(INSTALL-pkg-config))

release: $(addprefix $(ROOT_FS_DIR),$(RELEASE-all))

$(OBJS): %.o: %.c Component.mk $(STAGINGDIR)/components.config
	$(CC) $(CFLAGS) $(CFLAGS-$@) -o $@ -c $<
	$(CC) $(CFLAGS) $(CFLAGS-$@) -MM -MP -MT '$(@) $(@:.o=.d)' -MF $(@:.o=.d) $<

-include $(OBJS:.o=.d)

$(LIBS):
	$(CC) $(CFLAGS) -Wl,-soname,$@ -shared -o $@ $(OBJS-$@) $(LDFLAGS) $(LDFLAGS-$@)

$(addprefix $(STAGINGDIR),$(INSTALL-lib)):
	$(INSTALL) -p -D -m 0750 $(notdir $@) $@

$(addprefix $(STAGINGDIR),$(INSTALL-header)):
	$(INSTALL) -p -D -m 0640 $(subst $(STAGINGDIR)/,,$@) $@

$(addprefix $(PKG_CONFIG_LIBDIR)/,$(INSTALL-pkg-config)):
	$(INSTALL) -p -D -m 0640 $(subst $(PKG_CONFIG_LIBDIR)/,,$@) $@

$(addprefix $(ROOT_FS_DIR),$(INSTALL-lib)):
	$(INSTALL) -p -D -m 0750 $(subst $(ROOT_FS_DIR),$(STAGINGDIR),$@) $@
	$(STRIP) $@

$(addprefix $(STAGINGDIR),$(INSTALL-all)) $(addprefix $(ROOT_FS_DIR),$(RELEASE-all)) all clean install release: FORCE
$(addprefix $(PKG_CONFIG_LIBDIR)/,$(INSTALL-pkg-config)): FORCE

FORCE:
