all:
	@echo "-------------------------------------------------------------"
	@echo "- building libneon.so"
	@echo "-------------------------------------------------------------"
	./configure --prefix=/usr --host=mips-linux-uclibc --build=i386-linux --enable-shared --disable-static --with-gnu-ld --with-expat --with-ssl=openssl \
CFLAGS="-DSTREAM_FILE -DCONFIG_SAH_SERVICES_FUSEPLUGINS_WDFS_WRITECACHESIZE=$(CONFIG_SAH_SERVICES_FUSEPLUGINS_WDFS_WRITECACHESIZE) -I$(STAGINGDIR)/usr/include -I$(STAGINGDIR)/include/expat -I$(STAGINGDIR)/include/" \
CPPFLAGS="-I$(STAGINGDIR)/include/expat -I$(STAGINGDIR)/usr/include -I$(STAGINGDIR)/include/" \
LDFLAGS="-L$(STAGINGDIR)/lib -L$(STAGINGDIR)/usr/lib"
	make all

clean:
	@echo "-------------------------------------------------------------"
	@echo "- cleaning libneon.so"
	@echo "-------------------------------------------------------------"
	test ! -e Makefile || make clean
	test ! -e Makefile || make distclean


install:
	@echo "-------------------------------------------------------------"
	@echo "- installing libneon headers to: " $(STAGINGDIR)
	@echo "-------------------------------------------------------------"
	$(INSTALL) -d $(STAGINGDIR)/include/libneon
	$(INSTALL) -p ./src/ne_*h $(STAGINGDIR)/include/libneon
	@echo "-------------------------------------------------------------"
	@echo "- installing libneon.so to: " $(STAGINGDIR)
	@echo "-------------------------------------------------------------"
	$(INSTALL) -d $(STAGINGDIR)/lib
	$(INSTALL) -m 755 ./src/.libs/libneon.so $(STAGINGDIR)/lib/
	$(INSTALL) -m 644 ./neon.pc $(STAGINGDIR)/build/pkg-config/
	ln -sf libneon.so $(STAGINGDIR)/lib/libneon.so.27
	ln -sf libneon.so $(STAGINGDIR)/lib/libneon.so.27.1.5

release:
	@echo "-------------------------------------------------------------"
	@echo "- make a libneon.so release in: " $(ROOT_FS_DIR)
	@echo "-------------------------------------------------------------"
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	cp -dp $(STAGINGDIR)/lib/libneon.so $(ROOT_FS_DIR)/lib
	$(STRIP) $(ROOT_FS_DIR)/lib/libneon.so
	ln -sf libneon.so $(ROOT_FS_DIR)/lib/libneon.so.27
	ln -sf libneon.so $(ROOT_FS_DIR)/lib/libneon.so.27.1.5

.PHONY: clean all install release
