include $(STAGINGDIR)/components.config

CONCURRENCY_LEVEL ?= $(shell /bin/grep ^processor /proc/cpuinfo | /usr/bin/wc -l)

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS), y)

APPS_CFLAGS =

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_NOENGINE), y)
APPS_CFLAGS += -DOPENSSL_NO_ENGINE
endif

APPS_E_EXE =

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_VERIFY), y)
APPS_E_EXE += verify
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_ASN1PARS), y)
APPS_E_EXE += asn1pars
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_REQ), y)
APPS_E_EXE += req
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_DGST), y)
APPS_E_EXE += dgst
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_DH), y)
APPS_E_EXE += dh
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_DHPARAM), y)
APPS_E_EXE += dhparam
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_ENC), y)
APPS_E_EXE += enc
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_PASSWD), y)
APPS_E_EXE += passwd
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_GENDH), y)
APPS_E_EXE += gendh
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_ERRSTR), y)
APPS_E_EXE += errstr
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_CA), y)
APPS_E_EXE += ca
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_CRL), y)
APPS_E_EXE += crl
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_RSA), y)
APPS_E_EXE += rsa
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_RSAUTL), y)
APPS_E_EXE += rsautl
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_DSA), y)
APPS_E_EXE += dsa
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_DSAPARAM), y)
APPS_E_EXE += dsaparam
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_EC), y)
APPS_E_EXE += ec
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_ECPARAM), y)
APPS_E_EXE += ecparam
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_X509), y)
APPS_E_EXE += x509
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_GENRSA), y)
APPS_E_EXE += genrsa
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_GENDSA), y)
APPS_E_EXE += gendsa
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_SSERVER), y)
APPS_E_EXE += s_server
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_SCLIENT), y)
APPS_E_EXE += s_client
endif


ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_SPEED), y)
APPS_E_EXE += speed
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_STIME), y)
APPS_E_EXE += s_time
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_VERSION), y)
APPS_E_EXE += version
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_PKCS7), y)
APPS_E_EXE += pkcs7
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_CRL2PKCS7), y)
APPS_E_EXE += crl2pkcs7
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_SESSID), y)
APPS_E_EXE += sess_id
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_CIPHERS), y)
APPS_E_EXE += ciphers
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_NSEQ), y)
APPS_E_EXE += nseq
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_PKCS12), y)
APPS_E_EXE += pkcs12
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_PKCS8), y)
APPS_E_EXE += pkcs8
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_SPKAC), y)
APPS_E_EXE += spkac
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_SMIME), y)
APPS_E_EXE += smime
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_RAND), y)
APPS_E_EXE += rand
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_ENGINE), y)
APPS_E_EXE += engine
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_OCSP), y)
APPS_E_EXE += ocsp
endif

ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS_PRIME), y)
APPS_E_EXE += prime
endif

endif

all:
	@echo "-------------------------------------------------------------"
	@echo "- building libcrypto"
	@echo "-------------------------------------------------------------"
	make -j$(CONCURRENCY_LEVEL) -C ./crypto -f ./Makefile libcrypto.so
	@echo "-------------------------------------------------------------"
	@echo "- building libssl"
	@echo "-------------------------------------------------------------"
	make -j$(CONCURRENCY_LEVEL) -C ./ssl -f ./Makefile libssl.so
	@echo "-------------------------------------------------------------"
ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS), y)
	@echo "- building openssl application"
	@echo "-------------------------------------------------------------"
	make -j$(CONCURRENCY_LEVEL) -C ./apps -f ./Makefile exe APPS_CFLAGS="$(APPS_CFLAGS)" APPS_E_EXE="$(APPS_E_EXE)"
endif

clean:
	@echo "-------------------------------------------------------------"
	@echo "- cleaning libcrypto"
	@echo "-------------------------------------------------------------"
	make -C ./crypto -f ./Makefile clean
	@echo "-------------------------------------------------------------"
	@echo "- cleaning libssl"
	@echo "-------------------------------------------------------------"
	make -C ./ssl -f ./Makefile clean
	@echo "-------------------------------------------------------------"
	@echo "- cleaning openssl application"
	@echo "-------------------------------------------------------------"
	make -C ./apps -f ./Makefile clean

install:
	@echo "-------------------------------------------------------------"
	@echo "- installing openssl headers to: " $(STAGINGDIR)
	@echo "-------------------------------------------------------------"
	$(INSTALL) -d $(STAGINGDIR)/include/openssl
	$(INSTALL) -p ./include/openssl/*h $(STAGINGDIR)/include/openssl
	@echo "-------------------------------------------------------------"
	@echo "- installing libcrypto to: " $(STAGINGDIR)
	@echo "-------------------------------------------------------------"
	$(INSTALL) -d $(STAGINGDIR)/lib
	$(INSTALL) -m 755 ./crypto/libcrypto.so $(STAGINGDIR)/lib
	ln -sf libcrypto.so $(STAGINGDIR)/lib/libcrypto.so.0.9.8	
	$(INSTALL) -m 755 ./crypto/libcrypto.a $(STAGINGDIR)/lib
	#ln -sf libcrypto.a $(STAGINGDIR)/lib/libcrypto_pic.a # see bug 15138
	@echo "-------------------------------------------------------------"
	@echo "- installing libssl to: " $(STAGINGDIR)
	@echo "-------------------------------------------------------------"
	$(INSTALL) -d $(STAGINGDIR)/lib
	$(INSTALL) -m 755 ./ssl/libssl.so $(STAGINGDIR)/lib	
	$(INSTALL) -m 755 ./ssl/libssl.a $(STAGINGDIR)/lib
	#ln -sf libssl.a $(STAGINGDIR)/lib/libssl_pic.a # see bug 15138
	$(INSTALL) -D -m 0644 pkg-config.pc $(PKG_CONFIG_LIBDIR)/openssl.pc
	$(INSTALL) -D -m 0644 pkg-config-crypto.pc $(PKG_CONFIG_LIBDIR)/libcrypto.pc
ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS), y)
	@echo "-------------------------------------------------------------"
	@echo "- installing openssl application to: " $(STAGINGDIR)
	@echo "-------------------------------------------------------------"
	$(INSTALL) -d $(STAGINGDIR)/bin
	$(INSTALL) -m 755 ./apps/openssl $(STAGINGDIR)/bin	
endif

release:
	@echo "-------------------------------------------------------------"
	@echo "- make a libcrypto release in: " $(ROOT_FS_DIR)
	@echo "-------------------------------------------------------------"
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	cp -dp $(STAGINGDIR)/lib/libcrypto.so* $(ROOT_FS_DIR)/lib
	$(STRIP) $(ROOT_FS_DIR)/lib/libcrypto.so	
	@echo "-------------------------------------------------------------"
	@echo "- make a libssl release in: " $(ROOT_FS_DIR)
	@echo "-------------------------------------------------------------"
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	cp -dp $(STAGINGDIR)/lib/libssl.so* $(ROOT_FS_DIR)/lib
	$(STRIP) $(ROOT_FS_DIR)/lib/libssl.so
ifeq ($(CONFIG_SAH_LIB_OPENSSL_APPS), y)
	@echo "-------------------------------------------------------------"
	@echo "- installing openssl application to: " $(STAGINGDIR)
	@echo "-------------------------------------------------------------"
	$(INSTALL) -d $(ROOT_FS_DIR)/bin
	$(INSTALL) -m 755 $(STAGINGDIR)/bin/openssl $(ROOT_FS_DIR)/bin	
	$(STRIP) $(ROOT_FS_DIR)/bin/openssl
endif

.PHONY: clean all install release
