/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#if !defined(PCB_REPLY_PRIV_H)
#define PCB_REPLY_PRIV_H

#ifdef __cplusplus
extern "C"
{
#endif

#include <pcb/core/reply.h>
#include <pcb/utils/linked_list.h>
#include <pcb/utils/string.h>
#include <pcb/utils/variant.h>

struct _reply_item {
    reply_item_type_t type;
    llist_iterator_t it;
    llist_iterator_t reply_it;
};

typedef struct _item_object {
    reply_item_t item;
    object_t *object;
} item_object_t;

typedef struct _item_notification {
    reply_item_t item;
    notification_t *notification;
} item_notification_t;

typedef struct _item_error {
    reply_item_t item;
    llist_iterator_t it;
    uint32_t error;
    string_t description;
    string_t info;
} item_error_t;

typedef struct _item_function_return {
    reply_item_t item;
    variant_t retval;
    argument_value_list_t returnArguments;
} item_function_return_t;

struct _reply {
    llist_t items;
    llist_t errors;
    bool completed;
};

#ifdef __cplusplus
}
#endif

#endif
