/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#include <sahtest/sahtest.h>
#include <pcb/core/datamodel.h>
#include "datamodel_priv.h"

int dm_set_namespace_null() {
    datamodel_t dm;

    assert_bool(datamodel_initialize(&dm) == true);
    assert_bool(datamodel_setNamespace(&dm,NULL) == true);
    assert_string_equals(datamodel_namespace(&dm),"");

    datamodel_cleanup(&dm);
    sahtest_success();
}

int dm_set_namespace_null_datamodel() {
    assert_bool(datamodel_setNamespace(NULL,"sah") == false);
    assert_null(datamodel_namespace(NULL));
    sahtest_success();
}

int dm_set_namespace() {
    datamodel_t dm;

    assert_bool(datamodel_initialize(&dm) == true);
    assert_bool(datamodel_setNamespace(&dm,"sah") == true);
    assert_string_equals(datamodel_namespace(&dm),"sah");

    assert_bool(datamodel_setNamespace(&dm,NULL) == true);
    assert_string_equals(datamodel_namespace(&dm),"");

    sahtest_success();
}
