/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef DM_NOTIFY_HANDLERS_H
#define DM_NOTIFY_HANDLERS_H

void dm_notify_handlers_add_setup();
void dm_notify_handlers_add_teardown();

void dm_notify_handlers_remove_setup();
void dm_notify_handlers_remove_teardown();

int dm_notify_handlers_add_null();
int dm_notify_handlers_add_null_fn();
int dm_notify_handlers_add();
int dm_notify_handlers_add_same_handler_twice();
int dm_notify_handlers_add_two_handlers();

int dm_notify_handlers_remove_null();
int dm_notify_handlers_remove_null_fn();
int dm_notify_handlers_remove();
int dm_notify_handlers_remove_same_handler_twice();
int dm_notify_handlers_remove_two_handlers();

sahtest_group_begin(dm_handlers_add,dm_notify_handlers_add_setup,dm_notify_handlers_add_teardown)
    sahtest_add_test(dm_notify_handlers_add_null,"Add notify handler to null data model")
    sahtest_add_test(dm_notify_handlers_add_null_fn,"Add null fn notify handler to data model")
    sahtest_add_test(dm_notify_handlers_add,"Add notify handler to data model")
    sahtest_add_test(dm_notify_handlers_add_same_handler_twice,"Add notify handler to data model twice")
    sahtest_add_test(dm_notify_handlers_add_two_handlers,"Add two notify handlers")
sahtest_group_end()

sahtest_group_begin(dm_handlers_remove,dm_notify_handlers_remove_setup,dm_notify_handlers_remove_teardown)
    sahtest_add_test(dm_notify_handlers_remove_null,"Remove notify handler from null data model")
    sahtest_add_test(dm_notify_handlers_remove_null_fn,"Remove null fn notify handler from data model")
    sahtest_add_test(dm_notify_handlers_remove,"Remove notify handler from data model")
    sahtest_add_test(dm_notify_handlers_remove_same_handler_twice,"Remove notify handler from data model twice")
    sahtest_add_test(dm_notify_handlers_remove_two_handlers,"Remove two notify handlers")
sahtest_group_end()

sahtest_group_begin(dm_notify_handlers,NULL,NULL)
    sahtest_add_group(dm_handlers_add,"Test adding notify handlers")
    sahtest_add_group(dm_handlers_remove,"Test removing notify handlers")
sahtest_group_end()

#endif // DM_NOTIFY_HANDLERS_H
