/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef TEST_DATAMODEL_H
#define TEST_DATAMODEL_H

#include "datamodel/dm_init_cleanup.h"
#include "datamodel/dm_namespace.h"
#include "datamodel/dm_load_save.h"
#include "datamodel/dm_notify_handlers.h"
#include "datamodel/dm_userdata.h"
#include "datamodel/dm_attributes.h"

sahtest_group_begin(datamodel,NULL,NULL)
    sahtest_add_group(dm_init_cleanup,"Test data model functions")
    sahtest_add_group(dm_namespace,"Test setting/getting datamodel namespace")
    sahtest_add_group(dm_load_save,"Test loading/saving datamodel")
    sahtest_add_group(dm_notify_handlers,"Test adding and removing of notify handlers")
    sahtest_add_group(dm_userdata,"Test setting and getting userdata to and from a datamodel")
    sahtest_add_group(dm_attributes,"Test datamodel attributes")
sahtest_group_end()

#endif // TEST_DATAMODEL_H
