/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef MOCK_H
#define MOCK_H

#include <sahtest/sahtest.h>
#include <pcb/core/object.h>
#include <pcb/utils/string_list.h>
#include <pcb/utils/variant_map.h>

mock_struct_begin(getenv)
    mock_struct_add(const char *varname)
    mock_struct_add(const char *value)
mock_struct_end(getenv)

mock_struct_begin(open)
    mock_struct_add(const char *pathname)
    mock_struct_add(int flags)
    mock_struct_add(int fd)
mock_struct_end(open)

mock_struct_begin(rename)
    mock_struct_add(const char *oldpath)
    mock_struct_add(const char *newpath)
    mock_struct_add(int retval)
mock_struct_end(rename)

mock_struct_begin(dirname)
    mock_struct_add(char *path)
    mock_struct_add(char *dirname)
mock_struct_end(dirname)

mock_struct_begin(fsync)
    mock_struct_add(int fd)
    mock_struct_add(int retval)
mock_struct_end(fsync)

mock_struct_begin(close)
    mock_struct_add(int fd)
    mock_struct_add(int retval)
mock_struct_end(close)

mock_struct_begin(test_load)
    mock_struct_add(int fd)
    mock_struct_add(object_t *object)
    mock_struct_add(const char *filename)
    mock_struct_add(bool retval)
mock_struct_end(test_load)

mock_struct_begin(test_verify)
    mock_struct_add(int fd)
    mock_struct_add(const char *filename)
    mock_struct_add(variant_map_t *info)
    mock_struct_add(bool *hasDefinition)
    mock_struct_add(bool retval)
mock_struct_end(test_verify)

mock_struct_begin(test_save)
    mock_struct_add(int fd)
    mock_struct_add(object_t *object)
    mock_struct_add(uint32_t depth)
    mock_struct_add(const char *filename)
    mock_struct_add(bool retval)
mock_struct_end(test_save)

#endif // MOCK_H
