/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef OBJ_CREATE_DELETE_H
#define OBJ_CREATE_DELETE_H

void obj_create_setup();
void obj_create_teardown();

int obj_create();
int obj_create_null_parent();
int obj_create_null_name_empty_name();
int obj_create_invalid_name();
int obj_create_two_object_same_name_same_parent();

void obj_create_instance_setup();
void obj_create_instance_teardown();

int obj_create_instance();
int obj_create_instance_null();
int obj_create_instance_not_template();
int obj_create_instance_deleted_template();
int obj_create_instance_duplicate_index();
int obj_create_instance_duplicate_key();

void obj_delete_setup();
void obj_delete_teardown();

int obj_delete();
int obj_delete_twice();
int obj_delete_null();
int obj_delete_wrong_state();

sahtest_group_begin(obj_create_gr,obj_create_setup,obj_create_teardown)
    sahtest_add_test(obj_create,"Create an object")
    sahtest_add_test(obj_create_null_parent,"Create an object using a null parent")
    sahtest_add_test(obj_create_null_name_empty_name,"Create an object using a null name or empty name")
    sahtest_add_test(obj_create_invalid_name,"Create an object using a invalid name")
    sahtest_add_test(obj_create_two_object_same_name_same_parent,"Create two objects with same name and add to the same parent")
sahtest_group_end()

sahtest_group_begin(obj_create_instance_gr,obj_create_instance_setup,obj_create_instance_teardown)
    sahtest_add_test(obj_create_instance,"Create an instance of a template object")
    sahtest_add_test(obj_create_instance_null,"Create an instance of a null object")
    sahtest_add_test(obj_create_instance_not_template,"Create an instance of a not template object")
    sahtest_add_test(obj_create_instance_deleted_template,"Create an instance of a deleted template object")
    sahtest_add_test(obj_create_instance_duplicate_index,"Create an instance with an already exisiting index")
    sahtest_add_test(obj_create_instance_duplicate_key,"Create an instance with an already exisiting key")
sahtest_group_end()

sahtest_group_begin(obj_delete_gr,obj_delete_setup,obj_delete_teardown)
    sahtest_add_test(obj_delete,"Delete an object")
    sahtest_add_test(obj_delete_twice,"Delete an object twice")
    sahtest_add_test(obj_delete_null,"Delete a null object")
    sahtest_add_test(obj_delete_wrong_state,"Delete an object in a wrong state")
sahtest_group_end()

sahtest_group_begin(obj_create_delete,NULL,NULL)
    sahtest_add_group(obj_create_gr,"Creating objects")
    sahtest_add_group(obj_create_instance_gr,"Creating instances")
    sahtest_add_group(obj_delete_gr,"Deleting objects")
sahtest_group_end()

#endif // OBJ_CREATE_DELETE_H
