/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef OBJ_GET_FIND_H
#define OBJ_GET_FIND_H

void obj_get_find_setup();
void obj_get_find_teardown();

int obj_get_index_path();
int obj_get_key_path();
int obj_get_index_slash_path();
int obj_get_key_slash_path();
int obj_get_partial_match();
int obj_get_empty_path();
int obj_get_null_path();
int obj_get_null_object();
int obj_get_invalid_path();
int obj_get_use_path_type_modifiers();
int obj_get_by_key();

int obj_find_index_path();
int obj_find_key_path();
int obj_find_slash_path();
int obj_find_null_object();
int obj_find_different_depths();

sahtest_group_begin(obj_get,obj_get_find_setup,obj_get_find_teardown)
    sahtest_add_test(obj_get_index_path,"Get an object using an index path")
    sahtest_add_test(obj_get_key_path,"Get an object using a key path")
    sahtest_add_test(obj_get_index_slash_path,"Get an object using an index slash path")
    sahtest_add_test(obj_get_key_slash_path,"Get an object using a key slash path")
    sahtest_add_test(obj_get_partial_match,"Get an object using a path that can be matched partial")
    sahtest_add_test(obj_get_empty_path,"Get the object itself, using empty path")
    sahtest_add_test(obj_get_null_path,"Get the object itself, using null path")
    sahtest_add_test(obj_get_null_object,"Get an object starting from null object")
    sahtest_add_test(obj_get_invalid_path,"Get an object using a not existing path")
    sahtest_add_test(obj_get_use_path_type_modifiers,"Get an object using a path containing modifiers % or $")
    sahtest_add_test(obj_get_by_key,"Get an object using key path and format")
sahtest_group_end()

sahtest_group_begin(obj_find,obj_get_find_setup,obj_get_find_teardown)
    sahtest_add_test(obj_find_index_path,"Find objects using index path")
    sahtest_add_test(obj_find_key_path,"Find a objects using key path")
    sahtest_add_test(obj_find_slash_path,"Find a objects using slash path")
    sahtest_add_test(obj_find_null_object,"Find a objects using null object as start")
    sahtest_add_test(obj_find_different_depths,"Find a objects using different depths")
sahtest_group_end()

sahtest_group_begin(obj_get_find,NULL,NULL)
    sahtest_add_group(obj_get,"Getting objects")
    sahtest_add_group(obj_find,"Searching objects")
sahtest_group_end()

#endif // OBJ_GET_FIND_H
