/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef OBJ_NAVIGATION_H
#define OBJ_NAVIGATION_H

void obj_navigation_setup();
void obj_navigation_teardown();

int obj_root();
int obj_root_null();
int obj_datamodel();
int obj_datamodel_null();
int obj_parent();
int obj_parent_null();
int obj_first_child();
int obj_first_child_null();
int obj_last_child();
int obj_last_child_null();
int obj_next_sibling();
int obj_next_sibling_null();
int obj_prev_sibling();
int obj_prev_sibling_null();
int obj_has_children();
int obj_has_children_null();
int obj_child_count();
int obj_child_count_null();
int obj_first_instance();
int obj_first_instance_null();
int obj_last_instance();
int obj_last_instance_null();
int obj_next_instance();
int obj_next_instance_null();
int obj_prev_instance();
int obj_prev_instance_null();
int obj_has_instances();
int obj_has_instances_null();
int obj_instance_count();
int obj_instance_count_null();

sahtest_group_begin(obj_navigation,obj_navigation_setup,obj_navigation_teardown)
    sahtest_add_test(obj_root,"Get the root object from different levels")
    sahtest_add_test(obj_root_null,"Get the root object from a null object")
    sahtest_add_test(obj_datamodel,"Get the datamodel pointer from objects at different levels")
    sahtest_add_test(obj_datamodel_null,"Get the datamodel pointer from a null object")
    sahtest_add_test(obj_parent,"Get the parent object from an object")
    sahtest_add_test(obj_parent_null,"Get the parent object from a null object")
    sahtest_add_test(obj_first_child,"Get the first child of an object")
    sahtest_add_test(obj_first_child_null,"Get the the first child of a null object")
    sahtest_add_test(obj_last_child,"Get the last child of an object")
    sahtest_add_test(obj_last_child_null,"Get the last child of a null object")
    sahtest_add_test(obj_next_sibling,"Get the next sibling of an object")
    sahtest_add_test(obj_next_sibling_null,"Get the next sibling of a null object")
    sahtest_add_test(obj_prev_sibling,"Get the prev sibling of an object")
    sahtest_add_test(obj_prev_sibling_null,"Get the prev sibling of a null object")
    sahtest_add_test(obj_has_children,"Does an object have children ?")
    sahtest_add_test(obj_has_children_null,"Does a null object has children ?")
    sahtest_add_test(obj_child_count,"Get the child count of an object")
    sahtest_add_test(obj_child_count_null,"Get the child count of the null object")
    sahtest_add_test(obj_first_instance,"Get the first instance of an object")
    sahtest_add_test(obj_first_instance_null,"Get the the first instance of a null object")
    sahtest_add_test(obj_last_instance,"Get the last instance of an object")
    sahtest_add_test(obj_last_instance_null,"Get the last instance of a null object")
    sahtest_add_test(obj_next_instance,"Get the next instance of an object")
    sahtest_add_test(obj_next_instance_null,"Get the next instance of a null object")
    sahtest_add_test(obj_prev_instance,"Get the prev instance of an object")
    sahtest_add_test(obj_prev_instance_null,"Get the prev instance of a null object")
    sahtest_add_test(obj_has_instances,"Does an object has instances ?")
    sahtest_add_test(obj_has_instances_null,"Does a null object has instances ?")
    sahtest_add_test(obj_instance_count,"Get the instance count of an object")
    sahtest_add_test(obj_instance_count_null,"Get the instance count of the null object")
sahtest_group_end()

#endif // OBJ_NAVIGATION_H
