/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef OBJ_PATH_NAME_H
#define OBJ_PATH_NAME_H

void obj_path_name_setup();
void obj_path_name_teardown();

int obj_path_index();
int obj_path_key();
int obj_path_index_slash();
int obj_path_key_slash();
int obj_path_include_namespace();
int obj_path_parent();
int obj_path_null();

int obj_name_index();
int obj_name_key();
int obj_name_null();

sahtest_group_begin(obj_path,obj_path_name_setup,obj_path_name_teardown)
    sahtest_add_test(obj_path_index,"Return index path of an object")
    sahtest_add_test(obj_path_key,"Return key path of an object")
    sahtest_add_test(obj_path_index_slash,"Return index path of an object with slash separator")
    sahtest_add_test(obj_path_key_slash,"Return key path of an object with slash separator")
    sahtest_add_test(obj_path_include_namespace,"Return path including namespace")
    sahtest_add_test(obj_path_parent,"Return parent path of an object")
    sahtest_add_test(obj_path_null,"Return path of a null object or using null string")
sahtest_group_end()

sahtest_group_begin(obj_name,obj_path_name_setup,obj_path_name_teardown)
    sahtest_add_test(obj_name_index,"Return index name of an object")
    sahtest_add_test(obj_name_key,"Return key name of an object")
    sahtest_add_test(obj_name_null,"Return path of a null object or using null string")
sahtest_group_end()

sahtest_group_begin(obj_path_name,NULL,NULL)
    sahtest_add_group(obj_path,"Test getting the path of an object")
    sahtest_add_group(obj_name,"Test getting the name of an object")
sahtest_group_end()

#endif // OBJ_PATH_NAME_H
