/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef PARAM_CREATE_DELETE_H
#define PARAM_CREATE_DELETE_H

void param_create_setup();
void param_create_teardown();

int param_create();
int param_create_null_object();
int param_create_empty_name();
int param_create_invalid_name();
int param_create_null_name();
int param_create_duplicate_name();
int param_create_template_only_param();
int param_copy();
int param_copy_parameter_name_already_used();
int param_copy_null_source();
int param_copy_null_dest();

void param_delete_setup();
void param_delete_teardown();

int param_delete();
int param_delete_wrong_state();
int param_delete_twice();
int param_delete_null();

sahtest_group_begin(param_create_gr,param_create_setup,param_create_teardown)
    sahtest_add_test(param_create,"Create a parameter")
    sahtest_add_test(param_create_null_object,"Create a parameter on a null object")
    sahtest_add_test(param_create_empty_name,"Create a parameter with an empty name")
    sahtest_add_test(param_create_invalid_name,"Create a parameter with an invalid name")
    sahtest_add_test(param_create_null_name,"Create a parameter with a null name")
    sahtest_add_test(param_create_duplicate_name,"Create a parameters with the same name")
    sahtest_add_test(param_create_template_only_param,"Create a template only parameter")
    sahtest_add_test(param_copy,"Copy parameter")
    sahtest_add_test(param_copy_parameter_name_already_used,"Copy parameter")
    sahtest_add_test(param_copy_null_source,"Copy null parameter")
    sahtest_add_test(param_copy_null_dest,"Copy to a null destination")
sahtest_group_end()

sahtest_group_begin(param_delete_gr,param_delete_setup,param_delete_teardown)
    sahtest_add_test(param_delete,"Delete a parameter")
    sahtest_add_test(param_delete_wrong_state,"Delete a parameter which is in the wrong state")
    sahtest_add_test(param_delete_twice,"Delete a parameter twice")
    sahtest_add_test(param_delete_null,"Delete a null parameter")
sahtest_group_end()

sahtest_group_begin(param_create_delete,NULL,NULL)
    sahtest_add_group(param_create_gr,"Creating parameters")
    sahtest_add_group(param_delete_gr,"Deleting parameters")
sahtest_group_end()

#endif // PARAM_CREATE_DELETE_H
