/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef PARAM_ITERATING_H
#define PARAM_ITERATING_H

void param_iterating_setup();
void param_iterating_teardown();

int obj_first_parameter();
int obj_last_parameter();
int obj_next_parameter();
int obj_prev_parameter();
int obj_has_parameters();
int obj_parameter_count();
int obj_get_parameter();

sahtest_group_begin(param_iterating,param_iterating_setup,param_iterating_teardown)
    sahtest_add_test(obj_first_parameter,"Get the first parameter of an object")
    sahtest_add_test(obj_last_parameter,"Get the last parameter of an object")
    sahtest_add_test(obj_next_parameter,"Get the next parameter of an object")
    sahtest_add_test(obj_prev_parameter,"Get the next parameter of an object")
    sahtest_add_test(obj_has_parameters,"Does an object contains parameters")
    sahtest_add_test(obj_parameter_count,"Count the parameters of an object")
    sahtest_add_test(obj_get_parameter,"Get a parameter by name")
sahtest_group_end()

#endif // PARAM_ITERATING_H
