/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef PARAM_RENAME_CAST_H
#define PARAM_RENAME_CAST_H

void param_rename_cast_setup();
void param_rename_cast_teardown();

int param_rename();
int param_rename_null();
int param_rename_invalid_name();
int param_rename_same_name();
int param_rename_longer_name();
int param_cast();
int param_cast_null();

sahtest_group_begin(param_rename_cast,param_rename_cast_setup,param_rename_cast_teardown)
    sahtest_add_test(param_rename,"Rename a parameter")
    sahtest_add_test(param_rename_null,"Rename a null parameter, set an empty name or null name")
    sahtest_add_test(param_rename_invalid_name,"Rename a parameter to an invalid name")
    sahtest_add_test(param_rename_same_name,"Rename a parameter, set the same name")
    sahtest_add_test(param_rename_longer_name,"Rename a parameter, set a longer name")
    sahtest_add_test(param_cast,"Change parameter type")
    sahtest_add_test(param_cast_null,"Change parameter type of a null parameter")
sahtest_group_end()

#endif // PARAM_RENAME_CAST_H
