/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef PARAM_VALUES_H
#define PARAM_VALUES_H

void param_values_setup();
void param_values_teardown();

int obj_param_value_string_type();
int obj_param_value_int8_type();
int obj_param_value_int16_type();
int obj_param_value_int32_type();
int obj_param_value_int64_type();
int obj_param_value_uint8_type();
int obj_param_value_uint16_type();
int obj_param_value_uint32_type();
int obj_param_value_uint64_type();
int obj_param_value_bool_type();
int obj_param_value_date_time_type();
int obj_param_value_object_null();
int obj_param_value_parameter_null();

sahtest_group_begin(param_values,param_values_setup,param_values_teardown)
    sahtest_add_test(obj_param_value_string_type,"Object parameter get value from a string parameter")
    sahtest_add_test(obj_param_value_int8_type,"Object parameter get value from an int8 parameter")
    sahtest_add_test(obj_param_value_int16_type,"Object parameter get value from an int16 parameter")
    sahtest_add_test(obj_param_value_int32_type,"Object parameter get value from an int32 parameter")
    sahtest_add_test(obj_param_value_int64_type,"Object parameter get value from an int64 parameter")
    sahtest_add_test(obj_param_value_uint8_type,"Object parameter get value from an uint8 parameter")
    sahtest_add_test(obj_param_value_uint16_type,"Object parameter get value from an uint16 parameter")
    sahtest_add_test(obj_param_value_uint32_type,"Object parameter get value from an uint32 parameter")
    sahtest_add_test(obj_param_value_uint64_type,"Object parameter get value from an uint64 parameter")
    sahtest_add_test(obj_param_value_bool_type,"Object parameter get value from a bool parameter")
    sahtest_add_test(obj_param_value_date_time_type,"Object parameter get value from a date time parameter")
    sahtest_add_test(obj_param_value_object_null,"Object parameter get value from a null object")
    sahtest_add_test(obj_param_value_parameter_null,"Object parameter get value using null parameter or empty name")
sahtest_group_end()

#endif // PARAM_VALUES_H
