/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef CIRCBUF_H
#define CIRCBUF_H

void test_circular_buffer_setup();
void test_circular_buffer_teardown();

int test_open_close();
int test_rw();
int test_write_off_by_one_bug();
int test_reset();
int test_rw_over_boundary();
int test_rw_cornercase();
int test_direct_api();
int test_eof();
int test_rw_increase_size();
int test_resize_with_read_after_write();
//int test_under_constraint();
int test_seek();

sahtest_group_begin(circular_buffer,test_circular_buffer_setup,test_circular_buffer_teardown)
    sahtest_add_test(test_open_close, "Test opening and closing of a circular buffer")
    sahtest_add_test(test_rw, "Test read and write operation on a circular buffer")
    sahtest_add_test(test_write_off_by_one_bug, "Test the fix for the write off by one bug")
    sahtest_add_test(test_reset, "Test reset of circular buffer")
    sahtest_add_test(test_rw_over_boundary, "Test read and write operations over buffer boundary")
    sahtest_add_test(test_rw_cornercase, "Test special cases")
    sahtest_add_test(test_direct_api, "Test circular buffer direct C API")
    sahtest_add_test(test_eof, "Test eof conditions")
    sahtest_add_test(test_rw_increase_size, "Test automatic increasing of buffer size")
    sahtest_add_test(test_resize_with_read_after_write, "Test automatic increasing of buffer size after reading")
//    sahtest_add_test(test_under_constraint, "Test circular buffer under memory constraints (can not be run when valgrind is active)")
    sahtest_add_test(test_seek, "Test circular buffer seek functionality")
sahtest_group_end()

#endif // CIRCBUF_H
