/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef LLIST_EMPTY_SIZE_H
#define LLIST_EMPTY_SIZE_H

void llist_empty_size_setup();
void llist_empty_size_teardown();

int llist_isEmpty_null_list();
int llist_isEmpty_empty_list();
int llist_isEmpty_list();
int llist_size_null_list();
int llist_size_empty_list();
int llist_size_list();

sahtest_group_begin(empty_size,llist_empty_size_setup,llist_empty_size_teardown)
    sahtest_add_test(llist_isEmpty_null_list,"Test isEmpty on null pointer list")
    sahtest_add_test(llist_isEmpty_empty_list,"Test isEmpty on empty list")
    sahtest_add_test(llist_isEmpty_list,"Test isEmpty on list")
    sahtest_add_test(llist_size_null_list,"Test size on null pointer list")
    sahtest_add_test(llist_size_empty_list,"Test size on empty list")
    sahtest_add_test(llist_size_list,"Test size on list")
sahtest_group_end()

#endif // LLIST_EMPTY_SIZE_H
