/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#include <sahtest/sahtest.h>
#include <pcb/utils/linked_list.h>

int llist_init_cleanup() {
    llist_t list;
    T_VERIFY(llist_initialize(&list));
    T_VERIFY(!llist_first(&list));
    T_VERIFY(!llist_last(&list));
    llist_cleanup(&list);

    return 0;
}

int llist_init_null() {
    T_VERIFY(!llist_initialize(NULL));

    return 0;
}

int llist_cleanup_null() {
    llist_cleanup(NULL);

    return 0;
}

int llist_iterator_init() {
    llist_iterator_t it;
    T_VERIFY(llist_iterator_initialize(&it));
    T_VERIFY(!llist_iterator_prev(&it));
    T_VERIFY(!llist_iterator_next(&it));

    return 0;
}

int llist_iterator_init_null() {
    T_VERIFY(!llist_iterator_initialize(NULL));

    return 0;
}

int llist_init_fill_cleanup() {
    llist_t list;
    llist_iterator_t it[5];
    int i;
    T_VERIFY(llist_initialize(&list));
    for(i = 0; i < 5; i++) {
        T_VERIFY(llist_iterator_initialize(&it[i]));
        T_VERIFY(llist_append(&list,&it[i]));
    }
    T_VERIFY(llist_size(&list) == 5);
    llist_cleanup(&list);
    T_VERIFY(llist_size(&list) == 0);

    return 0;
}
