/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef LLIST_INIT_CLEANUP_H
#define LLIST_INIT_CLEANUP_H

int llist_init_cleanup();
int llist_init_null();
int llist_cleanup_null();
int llist_iterator_init();
int llist_iterator_init_null();
int llist_init_fill_cleanup();

sahtest_group_begin(ll_init_cleanup,NULL,NULL)
    sahtest_add_test(llist_init_cleanup,"Test initializing linked list and cleanup")
    sahtest_add_test(llist_init_null,"Test initializing linked list with null pointer")
    sahtest_add_test(llist_cleanup_null,"Test cleanup linked list with null pointer")
    sahtest_add_test(llist_iterator_init,"Test initilaizing linked list iterator")
    sahtest_add_test(llist_iterator_init_null,"Test initilaizing linked list iterator with null pointer")
    sahtest_add_test(llist_init_fill_cleanup,"Test initializing, filling and cleanup of linked list")
sahtest_group_end()

#endif // LLIST_INIT_CLEANUP_H
