/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef LLIST_ITERATING_H
#define LLIST_ITERATING_H

void llist_iterating_setup();
void llist_iterating_teardown();

int llist_iterating_first_null();
int llist_iterating_last_null();
int llist_iterating_next_null();
int llist_iterating_prev_null();
int llist_iterating_first();
int llist_iterating_last();
int llist_iterating_first_prev();
int llist_iterating_last_next();
int llist_iterating_first_next();
int llist_iterating_last_prev();
int llist_iterating_orphan_next();
int llist_iterating_orphan_prev();
int llist_iterating_loop_forward();
int llist_iterating_loop_reverse();

sahtest_group_begin(iterating,llist_iterating_setup,llist_iterating_teardown)
    sahtest_add_test(llist_iterating_first_null,"Test getting first item from null pointer list")
    sahtest_add_test(llist_iterating_last_null,"Test getting last item from null pointer list")
    sahtest_add_test(llist_iterating_next_null,"Test getting next item with null pointer as reference")
    sahtest_add_test(llist_iterating_prev_null,"Test getting prev item with null pointer as reference")
    sahtest_add_test(llist_iterating_first,"Test getting first item")
    sahtest_add_test(llist_iterating_last,"Test getting last item")
    sahtest_add_test(llist_iterating_first_prev,"Test getting the item before the first")
    sahtest_add_test(llist_iterating_last_next,"Test getting the item after the last")
    sahtest_add_test(llist_iterating_first_next,"Iterate to the next item after the first")
    sahtest_add_test(llist_iterating_last_prev,"Iterate to the prev element before last")
    sahtest_add_test(llist_iterating_orphan_next,"Iterate to the next element using orphan iterator")
    sahtest_add_test(llist_iterating_orphan_prev,"Iterate to the prev element using orphan iterator ")
    sahtest_add_test(llist_iterating_loop_forward,"Iterate over full list (forward) using for_each macro")
    sahtest_add_test(llist_iterating_loop_reverse,"Iterate over full list (backward) using for_each macro")
sahtest_group_end()

#endif // LLIST_ITERATING_H
