/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef STRING_APPEND_H
#define STRING_APPEND_H

void test_string_append_setup();
void test_string_append_teardown();

int test_append_to_null_string();
int test_append_null_to_string();
int test_append_empty_const_char_to_string();
int test_empty_string_append_char();
int test_string_append_char();
int test_string_append_string();
int test_string_append_string_null();
int test_string_append_format();
int test_string_append_format_using_null_format();
int test_string_append_format_using_empty_dest();
int test_string_append_format_using_null_dest();
int test_string_append_format_using_empty_dest_initialized_buffer();

sahtest_group_begin(str_append,test_string_append_setup,test_string_append_teardown)
    sahtest_add_test(test_append_to_null_string, "Test appending const char to NULL string")
    sahtest_add_test(test_append_null_to_string, "Test appending NULL pointer to string")
    sahtest_add_test(test_append_empty_const_char_to_string, "Test appending empty const char to string")
    sahtest_add_test(test_empty_string_append_char, "Test appending const char to empty string")
    sahtest_add_test(test_string_append_char, "Test appending const char to a string")
    sahtest_add_test(test_string_append_string, "Test appending a string to a string")
    sahtest_add_test(test_string_append_string_null, "Test appending a null string to a string")
    sahtest_add_test(test_string_append_format, "Test appending to string using a format sprintf like")
    sahtest_add_test(test_string_append_format_using_null_format, "Test appending to string using a null format")
    sahtest_add_test(test_string_append_format_using_empty_dest, "Test appending to empty string using a format")
    sahtest_add_test(test_string_append_format_using_null_dest, "Test appending to null string using a format")
    sahtest_add_test(test_string_append_format_using_empty_dest_initialized_buffer, "Test appending to null string using a format with empty destination initialized buffer")
sahtest_group_end()

#endif // STRING_APPEND_H
