/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#define _XOPEN_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include <pcb/utils/string.h>
#include <sahtest/sahtest.h>

static string_t haystack;
static string_t needle;
static string_t gold;
static string_t empty_sized;
static string_t empty_0;


void test_string_contains_setup() {
    //                         1234567890123456789012345678901234567890123456
    string_fromChar(&haystack,"HaystackHaystackHaystackNeedleHaystackHaystack");
    string_fromChar(&needle,"Needle");
    string_fromChar(&gold,"Gold");
    string_initialize(&empty_sized,10);
    string_initialize(&empty_0,0);
}

void test_string_contains_teardown() {
    string_cleanup(&haystack);
    string_cleanup(&needle);
    string_cleanup(&gold);
    string_cleanup(&empty_sized);
    string_cleanup(&empty_0);
}

int test_contains() {
    T_VERIFY(string_contains(&haystack,&needle,string_case_sensitive) == true);
    T_VERIFY(string_contains(&haystack,&gold,string_case_sensitive) == false);

    return 0;
}

int test_contains_needle_empty_string_initialized_size() {
    T_VERIFY(string_contains(&haystack,&empty_sized,string_case_sensitive) == true);

    return 0;
}

int test_contains_needle_empty_string_initialized_0() {
    T_VERIFY(string_contains(&haystack,&empty_0,string_case_sensitive) == true);

    return 0;
}

int test_contains_using_null_needle() {
    T_VERIFY(string_contains(&haystack,NULL,string_case_sensitive) == true);

    return 0;
}

int test_contains_char() {
    T_VERIFY(string_containsChar(&haystack,"Needle",string_case_sensitive) == true);
    T_VERIFY(string_containsChar(&haystack,"Gold",string_case_sensitive) == false);

    return 0;
}

int test_contains_char_null() {
    T_VERIFY(string_containsChar(&haystack,NULL,string_case_sensitive) == true);

    return 0;
}
