/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef STRING_CONTAINS_H
#define STRING_CONTAINS_H

void test_string_contains_setup();
void test_string_contains_teardown();

int test_contains();
int test_contains_needle_empty_string_initialized_size();
int test_contains_needle_empty_string_initialized_0();
int test_contains_using_null_needle();
int test_contains_char();
int test_contains_char_null();

sahtest_group_begin(contains,test_string_contains_setup,test_string_contains_teardown)
    sahtest_add_test(test_contains, "Check that a string contains a substring")
    sahtest_add_test(test_contains_needle_empty_string_initialized_size, "Check that an empty string is in a string")
    sahtest_add_test(test_contains_needle_empty_string_initialized_0, "Check that an empty string (null buffer) is in a string")
    sahtest_add_test(test_contains_using_null_needle, "Check that a null needle is in a string")
    sahtest_add_test(test_contains_char, "Check that a char pointer needle is in a string")
    sahtest_add_test(test_contains_char_null, "Check that a null pointer needle is in a string")
sahtest_group_end()

#endif // STRING_CONTAINS_H
