/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef STRING_FIND_H
#define STRING_FIND_H

void test_string_find_setup();
void test_string_find_teardown();

int test_find_casesensitive();
int test_find_caseinsensitive();
int test_find_start_out_of_boundery();
int test_find_not_available();
int test_find_needle_null();
int test_find_haystack_null_string();
int test_find_haystack_empty_string_initialized_size();
int test_find_haystack_empty_string_initialized_0();
int test_find_needle_empty_string_initialized_size();
int test_find_needle_empty_string_initialized_0();
int test_find_char_needle_null();

sahtest_group_begin(find,test_string_find_setup,test_string_find_teardown)
    sahtest_add_test(test_find_casesensitive, "Search substring with case sensitive matching")
    sahtest_add_test(test_find_caseinsensitive, "Search substring with case insensitive matching")
    sahtest_add_test(test_find_start_out_of_boundery, "Search substring with start posistion out of boundery")
    sahtest_add_test(test_find_not_available, "Search not available substring")
    sahtest_add_test(test_find_needle_null, "Search with needle a null pointer")
    sahtest_add_test(test_find_haystack_null_string, "Search with haystack a null pointer")
    sahtest_add_test(test_find_haystack_empty_string_initialized_size, "Search in an empty initialized string, size > 0")
    sahtest_add_test(test_find_haystack_empty_string_initialized_0, "Search in an empty intialized string size == 0")
    sahtest_add_test(test_find_needle_empty_string_initialized_size, "Search an empty needle initialized string, size > 0")
    sahtest_add_test(test_find_needle_empty_string_initialized_0, "Search in an empty needle intialized string size == 0")
    sahtest_add_test(test_find_char_needle_null, "Search using a char pointer needle = NULL")
sahtest_group_end()

#endif // STRING_FIND_H
