/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef STRING_FROMTYPE_H
#define STRING_FROMTYPE_H

void test_string_from_type_setup();
void test_string_from_type_teardown();

int test_string_from_bool();
int test_NULL_string_from_bool();
int test_string_from_char();
int test_NULL_string_from_char();
int test_string_from_NULL_char();
int test_string_from_int8();
int test_NULL_string_from_int8();
int test_string_from_int16();
int test_NULL_string_from_int16();
int test_string_from_int32();
int test_NULL_string_from_int32();
int test_string_from_int64();
int test_NULL_string_from_int64();
int test_string_from_uint8();
int test_NULL_string_from_uint8();
int test_string_from_uint16();
int test_NULL_string_from_uint16();
int test_string_from_uint32();
int test_NULL_string_from_uint32();
int test_string_from_uint64();
int test_NULL_string_from_uint64();
int test_string_from_double();
int test_NULL_string_from_double();
int test_string_from_time();

sahtest_group_begin(from_type,test_string_from_type_setup,test_string_from_type_teardown)
    sahtest_add_test(test_string_from_bool, "Test string creation from bool type")
    sahtest_add_test(test_NULL_string_from_bool, "Test string creation from bool type into NULL pointer string")
    sahtest_add_test(test_string_from_char, "Test string creation from const char type")
    sahtest_add_test(test_NULL_string_from_char, "Test string creation from const char type into NULL pointer string")
    sahtest_add_test(test_string_from_NULL_char, "Test string creation from const char *NULL")
    sahtest_add_test(test_string_from_int8, "Test string creation from int8")
    sahtest_add_test(test_NULL_string_from_int8, "Test string creation from int8 type into NULL pointer string")
    sahtest_add_test(test_string_from_int16, "Test string creation from int16")
    sahtest_add_test(test_NULL_string_from_int16, "Test string creation from int16 type into NULL pointer string")
    sahtest_add_test(test_string_from_int32, "Test string creation from int32")
    sahtest_add_test(test_NULL_string_from_int32, "Test string creation from int32 type into NULL pointer string")
    sahtest_add_test(test_string_from_int64, "Test string creation from int64")
    sahtest_add_test(test_NULL_string_from_int64, "Test string creation from int64 type into NULL pointer string")
    sahtest_add_test(test_string_from_uint8, "Test string creation from uint8")
    sahtest_add_test(test_NULL_string_from_uint8, "Test string creation from uint8 type into NULL pointer string")
    sahtest_add_test(test_string_from_uint16, "Test string creation from uint16")
    sahtest_add_test(test_NULL_string_from_uint16, "Test string creation from uint16 type into NULL pointer string")
    sahtest_add_test(test_string_from_uint32, "Test string creation from uint32")
    sahtest_add_test(test_NULL_string_from_uint32, "Test string creation from uint32 type into NULL pointer string")
    sahtest_add_test(test_string_from_uint64, "Test string creation from uint64")
    sahtest_add_test(test_NULL_string_from_uint64, "Test string creation from uint64 type into NULL pointer string")
    sahtest_add_test(test_string_from_double, "Test string creation from double")
    sahtest_add_test(test_NULL_string_from_double, "Test string creation from double type into NULL pointer string")
    sahtest_add_test(test_string_from_time, "Test string creation from time")
sahtest_group_end()


#endif // STRING_FROMTYPE_H
