/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#define _XOPEN_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include <pcb/utils/string.h>
#include <sahtest/sahtest.h>

static string_t string_dest;
static string_t string_source;

void test_string_mid_setup() {
    string_initialize(&string_dest,10);
    //                              1234567890123456789012345678901234567
    string_fromChar(&string_source,"A wooden woodpecker pecks in the wood");
}

void test_string_mid_teardown() {
    string_cleanup(&string_dest);
    string_cleanup(&string_source);
}

int test_mid_from_0_with_length_maxint() {
    T_VERIFY(string_mid(&string_dest,&string_source,0,-1) == 37);
    T_VERIFY(strcmp(string_buffer(&string_dest),"A wooden woodpecker pecks in the wood") == 0);

    return 0;
}

int test_mid_from_index_20_length_5() {
    T_VERIFY(string_mid(&string_dest,&string_source,20,5) == 5);
    T_VERIFY(strcmp(string_buffer(&string_dest),"pecks") == 0);

    return 0;
}

int test_mid_start_out_of_boundery() {
    T_VERIFY(string_mid(&string_dest,&string_source,40,5) == 0);
    T_VERIFY(string_buffer(&string_dest) == NULL);

    return 0;
}

int test_mid_length_out_of_boundery() {
    T_VERIFY(string_mid(&string_dest,&string_source,20,30) == 17);
    T_VERIFY(strcmp(string_buffer(&string_dest),"pecks in the wood") == 0);

    return 0;
}

int test_mid_source_null_string() {
    T_VERIFY(string_mid(&string_dest,NULL,20,30) == 0);
    T_VERIFY(string_buffer(&string_dest) == NULL);

    return 0;
}

int test_mid_dest_null_string() {
    T_VERIFY(string_mid(NULL,&string_source,10,10) == 0);

    return 0;
}
