/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef STRING_MID_H
#define STRING_MID_H

void test_string_mid_setup();
void test_string_mid_teardown();

int test_mid_from_0_with_length_maxint();
int test_mid_from_index_20_length_5();
int test_mid_start_out_of_boundery();
int test_mid_length_out_of_boundery();
int test_mid_source_null_string();
int test_mid_dest_null_string();

sahtest_group_begin(mid,test_string_mid_setup,test_string_mid_teardown)
    sahtest_add_test(test_mid_from_0_with_length_maxint, "Taking substring from index 0 with length -1")
    sahtest_add_test(test_mid_from_index_20_length_5, "Taking substring from index 20 with length 5")
    sahtest_add_test(test_mid_start_out_of_boundery, "Taking substring using start index out of boundery")
    sahtest_add_test(test_mid_length_out_of_boundery, "Taking substring using length out of boundery")
    sahtest_add_test(test_mid_source_null_string, "Taking substring using null string source")
    sahtest_add_test(test_mid_dest_null_string, "Taking substring using null string destination")
sahtest_group_end()

#endif // STRING_TOLOWER_H
