/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef STRING_PREPEND_H
#define STRING_PREPEND_H

void test_string_prepend_setup();
void test_string_prepend_teardown();

int test_prepend_to_null_string();
int test_prepend_null_to_string();
int test_prepend_empty_const_char_to_string();
int test_empty_string_prepend_char();
int test_string_prepend_char();
int test_string_prepend_string();
int test_string_prepend_string_null();

sahtest_group_begin(str_prepend,test_string_prepend_setup,test_string_prepend_teardown)
    sahtest_add_test(test_prepend_to_null_string, "Test prepending const char to NULL string")
    sahtest_add_test(test_prepend_null_to_string, "Test prepending NULL pointer to string")
    sahtest_add_test(test_prepend_empty_const_char_to_string, "Test prepending empty const char to string")
    sahtest_add_test(test_empty_string_prepend_char, "Test prepending const char to empty string")
    sahtest_add_test(test_string_prepend_char, "Test prepending const char to empty string")
    sahtest_add_test(test_string_prepend_string, "Test prepending const char to empty string")
    sahtest_add_test(test_string_prepend_string_null, "Test prepending a null string to a string")
sahtest_group_end()

#endif // STRING_PREPEND_H
