/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef STRING_REPLACE_H
#define STRING_REPLACE_H

void test_string_replace_setup();
void test_string_replace_teardown();

int test_replace_smaller();
int test_replace_bigger();
int test_replace_not_found();
int test_replace_using_null_replacement();
int test_replace_using_null_search();
int test_replace_using_empty_replacement_size_0();
int test_replace_using_empty_original_size_0();

sahtest_group_begin(replace,test_string_replace_setup,test_string_replace_teardown)
    sahtest_add_test(test_replace_smaller, "Test replacing a substring within a string with a smaller string")
    sahtest_add_test(test_replace_bigger, "Test replacing a substring within a string with a bigger string")
    sahtest_add_test(test_replace_not_found, "Test replacing a search string not in the string")
    sahtest_add_test(test_replace_using_null_replacement, "Test replacing a search string with a null pointer replacement")
    sahtest_add_test(test_replace_using_null_search, "Test replacing a search string which is a null pointer")
    sahtest_add_test(test_replace_using_empty_replacement_size_0, "Test replacing a search string which is a 0 sized string")
    sahtest_add_test(test_replace_using_empty_original_size_0, "Test replacing a search string in an empty string, 0 sized")
sahtest_group_end()


#endif // STRING_REPLACE_H
