/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef STRING_RESOLVE_ENV_H
#define STRING_RESOLVE_ENV_H

void test_string_resolve_env_setup();
void test_string_resolve_env_teardown();

int test_resolve_env();
int test_resolve_env_not_available();
int test_resolve_env_invalid_format();
int test_resolve_env_char();
int test_resolve_env_char_not_available();
int test_resolve_env_char_invalid_format();

sahtest_group_begin(resolve_env,test_string_resolve_env_setup,test_string_resolve_env_teardown)
    sahtest_add_test(test_resolve_env, "Test resolve env in a string")
    sahtest_add_test(test_resolve_env_not_available, "Test resolve env in a string, env not exported")
    sahtest_add_test(test_resolve_env_invalid_format, "Test resolve env in a string, string contains invalid format")
    sahtest_add_test(test_resolve_env_char, "Test resolve env in a const char *string, returing a new char")
    sahtest_add_test(test_resolve_env_char_not_available, "Test resolve env in a const cahr * string, env not exported")
    sahtest_add_test(test_resolve_env_char_invalid_format, "Test resolve env in a const char * string, string contains invalid format")
sahtest_group_end()

#endif // STRING_RESOLVE_ENV_H
