/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef STRING_TOTYPE_H
#define STRING_TOTYPE_H

void test_string_to_type_setup();
void test_string_to_type_teardown();

int test_string_to_bool();
int test_NULL_string_to_bool();
int test_string_to_char();
int test_NULL_string_to_char();
int test_string_to_int8();
int test_NULL_string_to_int8();
int test_string_to_int16();
int test_NULL_string_to_int16();
int test_string_to_int32();
int test_NULL_string_to_int32();
int test_string_to_int64();
int test_NULL_string_to_int64();
int test_string_to_uint8();
int test_NULL_string_to_uint8();
int test_string_to_uint16();
int test_NULL_string_to_uint16();
int test_string_to_uint32();
int test_NULL_string_to_uint32();
int test_string_to_uint64();
int test_NULL_string_to_uint64();
int test_string_to_time();
int test_NULL_string_to_time();

sahtest_group_begin(to_type,test_string_to_type_setup,test_string_to_type_teardown)
    sahtest_add_test(test_string_to_bool, "Test string conversion to bool")
    sahtest_add_test(test_NULL_string_to_bool, "Test NULL string conversion to bool")
    sahtest_add_test(test_string_to_char, "Test string conversion to char")
    sahtest_add_test(test_NULL_string_to_char, "Test NULL string conversion to char")
    sahtest_add_test(test_string_to_int8, "Test string conversion to int8")
    sahtest_add_test(test_NULL_string_to_int8, "Test NULL string conversion to int8")
    sahtest_add_test(test_string_to_int16, "Test string conversion to int16")
    sahtest_add_test(test_NULL_string_to_int16, "Test NULL string conversion to int16")
    sahtest_add_test(test_string_to_int32, "Test string conversion to int32")
    sahtest_add_test(test_NULL_string_to_int32, "Test NULL string conversion to int32")
    sahtest_add_test(test_string_to_int64, "Test string conversion to int64")
    sahtest_add_test(test_NULL_string_to_int64, "Test NULL string conversion to int64")
    sahtest_add_test(test_string_to_uint8, "Test string conversion to uint8")
    sahtest_add_test(test_NULL_string_to_uint8, "Test NULL string conversion to uint8")
    sahtest_add_test(test_string_to_uint16, "Test string conversion to uint16")
    sahtest_add_test(test_NULL_string_to_uint16, "Test NULL string conversion to uint16")
    sahtest_add_test(test_string_to_uint32, "Test string conversion to uint32")
    sahtest_add_test(test_NULL_string_to_uint32, "Test NULL string conversion to uint32")
    sahtest_add_test(test_string_to_uint64, "Test string conversion to uint64")
    sahtest_add_test(test_NULL_string_to_uint64, "Test NULL string conversion to uint64")
    sahtest_add_test(test_string_to_time, "Test string conversion to time struct")
    sahtest_add_test(test_NULL_string_to_time, "Test NULL string conversion to time struct")
sahtest_group_end()

#endif // STRING_TOTYPE_H
