/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#define _XOPEN_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include <pcb/utils/string.h>
#include <sahtest/sahtest.h>

static string_t string_allupper;
static string_t string_alllower;
static string_t string_mixed;
static string_t string_special;

void test_string_toUpper_setup() {
    string_initialize(&string_allupper,0);
    string_initialize(&string_alllower,0);
    string_initialize(&string_mixed,0);
    string_initialize(&string_special,0);

    string_fromChar(&string_allupper,"HALLO WORLD");
    string_fromChar(&string_alllower,"hallo world");
    string_fromChar(&string_mixed,"HaLlO wOrLd");
    string_fromChar(&string_special,"00:10:18:35:87:3f");
}

void test_string_toUpper_teardown() {
    string_cleanup(&string_allupper);
    string_cleanup(&string_alllower);
    string_cleanup(&string_mixed);
    string_cleanup(&string_special);
}

int test_toUpper_all_lowercase() {
    string_toUpper(&string_alllower);

    T_CMP(string_alllower.buffer,"HALLO WORLD");

    return 0;
}

int test_toUpper_all_uppercase() {
    string_toUpper(&string_allupper);

    T_CMP(string_allupper.buffer,"HALLO WORLD");

    return 0;
}

int test_toUpper_mixed_case() {
    string_toUpper(&string_mixed);

    T_CMP(string_mixed.buffer,"HALLO WORLD");

    return 0;
}

int test_toUpper_special() {
    string_toUpper(&string_special);

    printf("[%s]\n",string_buffer(&string_special));
    T_CMP(string_special.buffer,"00:10:18:35:87:3F");

    return 0;
}
