/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef TEST_STRING_H
#define TEST_STRING_H

#include "string/string_init.h"
#include "string/string_clear.h"
#include "string/string_fromtype.h"
#include "string/string_totype.h"
#include "string/string_copy.h"
#include "string/string_append.h"
#include "string/string_prepend.h"
#include "string/string_toupper.h"
#include "string/string_tolower.h"
#include "string/string_mid.h"
#include "string/string_left.h"
#include "string/string_right.h"
#include "string/string_find.h"
#include "string/string_contains.h"
#include "string/string_replace.h"
#include "string/string_trim.h"
#include "string/string_resolve_env.h"
#include "string/string_compare.h"
#include "string/string_numeric.h"

sahtest_group_begin(string,NULL,NULL)
    sahtest_add_group(init_cleanup, "Test string appending and prepending")
    sahtest_add_group(clear_func, "Test clearing a string")
    sahtest_add_group(from_type,"Test string creation from different types")
    sahtest_add_group(copy_func, "Test copying a string")
    sahtest_add_group(to_type,"Test string coversion to different types")
    sahtest_add_group(to_upper,"Test string coversion to all upper case")
    sahtest_add_group(to_lower,"Test string coversion to all lowers case")
    sahtest_add_group(str_append, "Test string appending")
    sahtest_add_group(str_prepend, "Test string prepending")
    sahtest_add_group(mid, "Test string taking substrings")
    sahtest_add_group(left, "Test string taking left string")
    sahtest_add_group(right, "Test string taking right string")
    sahtest_add_group(find, "Test string searching")
    sahtest_add_group(contains, "Test string checking for substring")
    sahtest_add_group(replace, "Test replacing a substring in a string")
    sahtest_add_group(trim, "Test string trim functions")
    sahtest_add_group(resolve_env, "Test resolving of env variables")
    sahtest_add_group(compare, "Test comparing strings")
    sahtest_add_group(numeric, "Test is numeric string")
sahtest_group_end()

#endif // TEST_STRING_H
