/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef STRING_LIST_CONTAINS_H
#define STRING_LIST_CONTAINS_H

void string_list_contains_setup();
void string_list_contains_teardown();

int string_list_contains_search_valid_item();
int string_list_contains_search_invalid_item();
int string_list_contains_null_string();
int string_list_contains_null_char();
int string_list_contains_using_null_list();

sahtest_group_begin(sl_contains,string_list_contains_setup,string_list_contains_teardown)
    sahtest_add_test(string_list_contains_search_valid_item,"Search an value in the string list that is available in the list")
    sahtest_add_test(string_list_contains_search_invalid_item,"Search an value in the string list that is not available in the list")
    sahtest_add_test(string_list_contains_null_string,"Search a null key in a string list")
    sahtest_add_test(string_list_contains_null_char,"Search a null char in a string list")
    sahtest_add_test(string_list_contains_using_null_list,"Search in a null string list")
sahtest_group_end()

#endif // STRING_LIST_CONTAINS_H
