/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef STRING_LIST_INSERT_INDEXED_H
#define STRING_LIST_INSERT_INDEXED_H

void string_list_insert_build_list_setup();
void string_list_insert_build_list_teardown();

int string_list_insert_indexed_null_list();
int string_list_insert_indexed_empty_list_index_0();
int string_list_insert_indexed_empty_list_index_2();
int string_list_insert_indexed_list_index_out_of_boundry();
int string_list_insert_indexed_list_index_0();
int string_list_insert_indexed_list_index_2();
int string_list_insert_indexed_list_index_last();

sahtest_group_begin(sl_insert_indexed,string_list_insert_build_list_setup,string_list_insert_build_list_teardown)
    sahtest_add_test(string_list_insert_indexed_null_list,"Test inserting in a null list using index")
    sahtest_add_test(string_list_insert_indexed_empty_list_index_0,"Test inserting in a empty list with index 0")
    sahtest_add_test(string_list_insert_indexed_empty_list_index_2,"Test inserting in a empty list with index 2")
    sahtest_add_test(string_list_insert_indexed_list_index_out_of_boundry,"Test inserting in a list with index higher then size of list")
    sahtest_add_test(string_list_insert_indexed_list_index_0,"Test inserting in a list with index 0")
    sahtest_add_test(string_list_insert_indexed_list_index_2,"Test inserting with index set to 2")
    sahtest_add_test(string_list_insert_indexed_list_index_last,"Test inserting with index set to last item")
sahtest_group_end()


#endif // STRING_LIST_INSERT_INDEXED_H
