/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef STRING_SPLIT_H
#define STRING_SPLIT_H

int string_list_split_empty_string();
int string_list_split_null_string();
int string_list_split_null_list();
int string_list_split_null_separator();
int string_list_split_case_sensitive();
int string_list_split_case_insensitive();
int string_list_split_keep_empty();
int string_list_split_skip_empty();

int string_list_split_empty_char();
int string_list_split_null_char();
int string_list_split_char_null_list();
int string_list_split_char_null_separator();
int string_list_split_char();

sahtest_group_begin(sl_split,NULL,NULL)
    sahtest_add_test(string_list_split_empty_string,"Test splitting an empty string")
    sahtest_add_test(string_list_split_null_string,"Test splitting a null string")
    sahtest_add_test(string_list_split_null_list,"Test splitting a string into a null list")
    sahtest_add_test(string_list_split_null_separator,"Test splitting a string using a null separator")
    sahtest_add_test(string_list_split_case_sensitive,"Test splitting using a case sensitive separator")
    sahtest_add_test(string_list_split_case_insensitive,"Test splitting using a case insensitive separator")
    sahtest_add_test(string_list_split_keep_empty,"Test splitting and keep empty parts")
    sahtest_add_test(string_list_split_skip_empty,"Test splitting and skip empty parts")

    sahtest_add_test(string_list_split_empty_char,"Test splitting an empty char")
    sahtest_add_test(string_list_split_null_char,"Test splitting a null char")
    sahtest_add_test(string_list_split_char_null_list,"Test splitting a char into a null list")
    sahtest_add_test(string_list_split_char_null_separator,"Test splitting a char using a null separator")
    sahtest_add_test(string_list_split_char,"Test splitting a char string")
sahtest_group_end()

#endif // STRING_SPLIT_H
