/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef TEST_STRING_LIST_H
#define TEST_STRING_LIST_H

#include "string_list/sl_init_cleanup.h"
#include "string_list/string_list_append.h"
#include "string_list/string_list_prepend.h"
#include "string_list/string_list_insert_indexed.h"
#include "string_list/string_split.h"
#include "string_list/string_join.h"
#include "string_list/string_list_empty_size.h"
#include "string_list/string_list_iterating.h"
#include "string_list/string_list_remove.h"
#include "string_list/string_list_contains.h"

sahtest_group_begin(string_list,NULL,NULL)
    sahtest_add_group(sl_init_cleanup,"Test initialization and cleanup")
    sahtest_add_group(sl_append, "Test appending to a string list")
    sahtest_add_group(sl_prepend, "Test prepending to a string list")
    sahtest_add_group(sl_insert_indexed, "Test inserting using an index")
    sahtest_add_group(sl_split,"Test splitting a string into a string list")
    sahtest_add_group(sl_join,"Test joining a string list into a string")
    sahtest_add_group(sl_empty_size,"Test string list enpty and size functions")
    sahtest_add_group(sl_iterating,"Test string list iterating")
    sahtest_add_group(sl_remove,"Test string list removing")
    sahtest_add_group(sl_contains,"Test string list contains functions")
sahtest_group_end()

#endif // TEST_STRING_LIST_H
