/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#include <sahtest/sahtest.h>

#include "llist/test_llist.h"
#include "tree/test_tree.h"
#include "url_parser/url_parsing.h"
#include "circbuf/circbuf.h"
#include "string/test_string.h"
#include "string_list/test_string_list.h"
#include "variant/test_variant.h"
#include "variant_list/test_variant_list.h"
#include "variant_map/test_variant_map.h"
#include "timer/test_timer.h"

sahtest_group_begin(sah_lib_pcb_utils,NULL,NULL)
    sahtest_add_group(llist,"Test linked list")
    sahtest_add_group(tree,"Test tree")
    sahtest_add_group(url_parser,"Test uri parsing")
    sahtest_add_group(circular_buffer,"Test circular buffer")
    sahtest_add_group(string,"Test string handling functions")
    sahtest_add_group(string_list,"Test string list handling functions")
    sahtest_add_group(variant,"Test variant functions")
    sahtest_add_group(var_list,"Test variant list functions")
    sahtest_add_group(var_map,"Test variant list functions")
    sahtest_add_group(timer,"Test timer functions")
sahtest_group_end()

int main(int argc, char *argv[]) {
    return sahtest_run(argc,argv,sahtest_group(sah_lib_pcb_utils));
}
