/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef TREE_EMPTY_SIZE_H
#define TREE_EMPTY_SIZE_H

void tree_empty_size_setup();
void tree_empty_size_teardown();

int tree_hasChilderen_null_tree();
int tree_hasChilderen_empty_tree();
int tree_hasChilderen_tree();
int tree_child_count_null_tree();
int tree_child_count_empty_tree();
int tree_child_count_tree();

sahtest_group_begin(tree_empty_size,tree_empty_size_setup,tree_empty_size_teardown)
    sahtest_add_test(tree_hasChilderen_null_tree,"Test hasChilderen on null pointer tree")
    sahtest_add_test(tree_hasChilderen_empty_tree,"Test hasChilderen on empty tree")
    sahtest_add_test(tree_hasChilderen_tree,"Test hasChilderen on tree")
    sahtest_add_test(tree_child_count_null_tree,"Test child count on null pointer tree")
    sahtest_add_test(tree_child_count_empty_tree,"Test child count on empty tree")
    sahtest_add_test(tree_child_count_tree,"Test child count on tree")
sahtest_group_end()

#endif // TREE_EMPTY_SIZE_H
