/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#include <sahtest/sahtest.h>
#include <pcb/utils/tree.h>

int tree_init_cleanup() {
    tree_t tree;
    T_VERIFY(tree_initialize(&tree));
    T_VERIFY(tree_root(&tree));
    tree_cleanup(&tree);

    return 0;
}

int tree_init_null() {
    T_VERIFY(!tree_initialize(NULL));
    T_VERIFY(tree_root(NULL) == NULL);

    return 0;
}

int tree_cleanup_null() {
    tree_cleanup(NULL);

    return 0;
}

int tree_item_init_cleanup() {
    tree_item_t tree_item;
    T_VERIFY(tree_item_initialize(&tree_item));
    T_VERIFY(tree_item.listItem.next == NULL);
    T_VERIFY(tree_item.listItem.prev == NULL);
    tree_item_cleanup(&tree_item);

    return 0;
}

int tree_item_init_null() {
    T_VERIFY(!tree_item_initialize(NULL));

    return 0;
}

int tree_item_cleanup_null() {
    tree_item_cleanup(NULL);

    return 0;
}
