/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef TREE_INSERT_H
#define TREE_INSERT_H

void tree_inserting_setup();
void tree_inserting_teardown();

void tree_insert_build_tree_setup();
void tree_insert_build_tree_teardown();

int tree_append_child_null_tree();
int tree_append_child_null_item();
int tree_append_child_orphan_item();
int tree_append_child_item_twice();
int tree_append_multiple_childeren();

int tree_prepend_child_null_tree();
int tree_prepend_child_null_item();
int tree_prepend_child_orphan_item();
int tree_prepend_child_item_twice();
int tree_prepend_multiple_childeren();

int tree_insert_at_null_tree();
int tree_insert_at_empty_tree_index_0();
int tree_insert_at_empty_tree_index_2();
int tree_insert_at_index_out_of_boundry();
int tree_insert_at_index_0();
int tree_insert_at_index_2();
int tree_insert_at_index_last();
int tree_insert_at_null_child();

sahtest_group_begin(tree_append,tree_inserting_setup,tree_inserting_teardown)
    sahtest_add_test(tree_append_child_null_tree,"Test appending item to null tree")
    sahtest_add_test(tree_append_child_null_item,"Test appending null item to tree")
    sahtest_add_test(tree_append_child_orphan_item,"Test appending a valid item")
    sahtest_add_test(tree_append_child_item_twice,"Test appending the same item twice")
    sahtest_add_test(tree_append_multiple_childeren,"Test appending multiple items after each other")
sahtest_group_end()

sahtest_group_begin(tree_prepend,tree_inserting_setup,tree_inserting_teardown)
    sahtest_add_test(tree_prepend_child_null_tree,"Test prepending item to null tree")
    sahtest_add_test(tree_prepend_child_null_item,"Test prepending null item to tree")
    sahtest_add_test(tree_prepend_child_orphan_item,"Test prepending a valid item")
    sahtest_add_test(tree_prepend_child_item_twice,"Test prepending the same item twice")
    sahtest_add_test(tree_prepend_multiple_childeren,"Test prepending multiple items before each other")
sahtest_group_end()

sahtest_group_begin(tree_insert_at,tree_insert_build_tree_setup,tree_insert_build_tree_teardown)
    sahtest_add_test(tree_insert_at_null_tree,"Test inserting in a null tree using index")
    sahtest_add_test(tree_insert_at_empty_tree_index_0,"Test inserting in a empty tree with index 0")
    sahtest_add_test(tree_insert_at_empty_tree_index_2,"Test inserting in a empty tree with index 2")
    sahtest_add_test(tree_insert_at_index_out_of_boundry,"Test inserting in a tree with index higher then child count")
    sahtest_add_test(tree_insert_at_index_0,"Test inserting in a tree with index 0")
    sahtest_add_test(tree_insert_at_index_2,"Test inserting with tree set to 2")
    sahtest_add_test(tree_insert_at_index_last,"Test inserting with index set to last item")
    sahtest_add_test(tree_insert_at_null_child,"Test inserting null child")
sahtest_group_end()

sahtest_group_begin(tree_inserting,NULL,NULL)
    sahtest_add_group(tree_append,"Test appending items")
    sahtest_add_group(tree_prepend,"Test prepending items")
    sahtest_add_group(tree_insert_at,"Test inserting at an indexp")
sahtest_group_end()

#endif // TREE_INSERT_H
