/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef TREE_ITERATING_H
#define TREE_ITERATING_H

void tree_iterating_setup();
void tree_iterating_teardown();

int tree_parent_null();
int tree_parent_root();
int tree_iterating_first_null();
int tree_iterating_last_null();
int tree_iterating_next_null();
int tree_iterating_prev_null();
int tree_iterating_first_empty();
int tree_iterating_first();
int tree_iterating_last_empty();
int tree_iterating_last();
int tree_iterating_first_prev();
int tree_iterating_last_next();
int tree_iterating_first_next();
int tree_iterating_last_prev();
int tree_iterating_orphan_next();
int tree_iterating_orphan_prev();
int tree_iterating_loop_forward();
int tree_iterating_loop_reverse();
int tree_iterating_indexed();
int tree_iterating_indexed_null();

sahtest_group_begin(tree_iterating,tree_iterating_setup,tree_iterating_teardown)
    sahtest_add_test(tree_parent_null,"Get parent of null tree item")
    sahtest_add_test(tree_parent_root,"Get parent of root tree item")
    sahtest_add_test(tree_iterating_first_null,"Test getting first child item from null pointer tree")
    sahtest_add_test(tree_iterating_last_null,"Test getting last child item from null pointer tree")
    sahtest_add_test(tree_iterating_next_null,"Test getting next child item with null pointer as reference")
    sahtest_add_test(tree_iterating_prev_null,"Test getting prev child item with null pointer as reference")
    sahtest_add_test(tree_iterating_first_empty,"Test getting first child item from empty tree item")
    sahtest_add_test(tree_iterating_first,"Test getting first child item")
    sahtest_add_test(tree_iterating_last_empty,"Test getting last child item from empty tree item")
    sahtest_add_test(tree_iterating_last,"Test getting last child item")
    sahtest_add_test(tree_iterating_first_prev,"Test getting the child item before the first")
    sahtest_add_test(tree_iterating_last_next,"Test getting the child item after the last")
    sahtest_add_test(tree_iterating_first_next,"Iterate to the next child item after the first")
    sahtest_add_test(tree_iterating_last_prev,"Iterate to the prev child item before last")
    sahtest_add_test(tree_iterating_orphan_next,"Iterate to the next child item using orphan iterator")
    sahtest_add_test(tree_iterating_orphan_prev,"Iterate to the prev child item using orphan iterator ")
    sahtest_add_test(tree_iterating_loop_forward,"Iterate over full tree (forward) using for_each macro")
    sahtest_add_test(tree_iterating_loop_reverse,"Iterate over full tree (backward) using for_each macro")
    sahtest_add_test(tree_iterating_indexed,"Fetch childeren from a tree item using an index")
    sahtest_add_test(tree_iterating_indexed_null,"Fetch childeren using an index from a null tree item")
sahtest_group_end()

#endif // TREE_ITERATING_H
