/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef TREE_REMOVE_H
#define TREE_REMOVE_H

void tree_remove_setup();
void tree_remove_teardown();

int tree_remove_take_first_null();
int tree_remove_take_last_null();
int tree_remove_take_first_empty_tree();
int tree_remove_take_last_empty_tree();
int tree_remove_take_first();
int tree_remove_take_last();
int tree_remove_item_null();
int tree_remove_item();

sahtest_group_begin(tree_remove,tree_remove_setup,tree_remove_teardown)
    sahtest_add_test(tree_remove_take_first_null,"Test removing first item from null pointer tree")
    sahtest_add_test(tree_remove_take_last_null,"Test removing last item from null pointer tree")
    sahtest_add_test(tree_remove_take_first_empty_tree,"Test removing first item from empty tree")
    sahtest_add_test(tree_remove_take_last_empty_tree,"Test removing last item from null pointer tree")
    sahtest_add_test(tree_remove_take_first,"Test removing first item from tree")
    sahtest_add_test(tree_remove_take_last,"Test removing last item from tree")
    sahtest_add_test(tree_remove_item_null,"Test removing a null item")
    sahtest_add_test(tree_remove_item,"Test removing an item from tree")
sahtest_group_end()

#endif // TREE_REMOVE_H
