/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef URL_PARSEING_H
#define URL_PARSEING_H

int test_parse_null();
int test_parse_empty_string();
int test_parse_scheme_only();
int test_parse_authority_no_host();
int test_parse_simple_authority();
int test_parse_authority_with_port();
int test_parse_authority_with_user();
int test_parse_authority_with_user_password();
int test_parse_authority_full();
int test_parse_authority_full_with_curly_braces();
int test_parse_authority_full_with_curly_braces_special_chars();
int test_parse_authority_full_with_braces();
int test_parse_authority_full_with_braces_special_chars();
int test_parse_authority_full_with_host_ipv6();
int test_parse_authority_full_with_port_path();
int test_parse_authority_path();
int test_parse_authority_path_with_parameters();
int test_parse_and_build_string();
int test_parse_empty_authority_path();

sahtest_group_begin(url_parser,NULL,NULL)
    sahtest_add_test(test_parse_null,"Test parse null pointer")
    sahtest_add_test(test_parse_empty_string,"Test parse empty string")
    sahtest_add_test(test_parse_scheme_only,"Test parse string containing only scheme")
    sahtest_add_test(test_parse_authority_no_host,"Test parse string containing authority without host")
    sahtest_add_test(test_parse_simple_authority,"Test parse string containing simple authotity (host only)")
    sahtest_add_test(test_parse_authority_with_port,"Test parse string containing simple authotity with port")
    sahtest_add_test(test_parse_authority_with_user,"Test parse string containing simple authotity, with user name")
    sahtest_add_test(test_parse_authority_with_user_password,"Test parse string containing simple authotity, with user name and password")
    sahtest_add_test(test_parse_authority_full,"Test parse string containing full authority")
    sahtest_add_test(test_parse_authority_full_with_curly_braces,"Test parse string containing full authority, host and port are in curly braces")
    sahtest_add_test(test_parse_authority_full_with_curly_braces_special_chars,"Test parse string containing full authority, host and port are in curly braces and contains special chars")
    sahtest_add_test(test_parse_authority_full_with_braces,"Test parse string containing full authority, host and port are in braces")
    sahtest_add_test(test_parse_authority_full_with_braces_special_chars,"Test parse string containing full authority, host and port are in braces and contains special chars")
    sahtest_add_test(test_parse_authority_full_with_host_ipv6,"Test parse string containing full authority, host is in ipv6 notation")
    sahtest_add_test(test_parse_authority_full_with_port_path,"Test parse string containing full authority, port is linux path notation")
    sahtest_add_test(test_parse_authority_path,"Test parsing path")
    sahtest_add_test(test_parse_authority_path_with_parameters,"Test parsing path containing parameters")
    sahtest_add_test(test_parse_and_build_string,"Test building uri string")
    sahtest_add_test(test_parse_empty_authority_path,"Test parse an uri with empty authority and a path")
sahtest_group_end()

#endif // URL_PARSEING_H
