/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef BOOL_VARIANT_CONVERSION_H
#define BOOL_VARIANT_CONVERSION_H

void variant_bool_conversion_setup();
void variant_bool_conversion_teardown();

int variant_bool_tostring();
int variant_bool_tojson();
int variant_bool_toChar();
int variant_bool_toInt8();
int variant_bool_toInt16();
int variant_bool_toInt32();
int variant_bool_toInt64();
int variant_bool_toUInt8();
int variant_bool_toUInt16();
int variant_bool_toUInt32();
int variant_bool_toUInt64();
int variant_bool_toBool();
int variant_bool_toFd();
int variant_bool_toDouble();
int variant_bool_toList();
int variant_bool_toMap();

sahtest_group_begin(bool_conversion,variant_bool_conversion_setup,variant_bool_conversion_teardown)
    sahtest_add_test(variant_bool_tostring,"Test converting a bool variant to a string")
    sahtest_add_test(variant_bool_tojson,"Test converting a bool variant to a json string")
    sahtest_add_test(variant_bool_toChar,"Test converting a bool variant to a char pointer")
    sahtest_add_test(variant_bool_toInt8,"Test converting a bool variant to an int8")
    sahtest_add_test(variant_bool_toInt16,"Test converting a bool variant to an int16")
    sahtest_add_test(variant_bool_toInt32,"Test converting a bool variant to an int32")
    sahtest_add_test(variant_bool_toInt64,"Test converting a bool variant to an int64")
    sahtest_add_test(variant_bool_toUInt8,"Test converting a bool variant to an uint8")
    sahtest_add_test(variant_bool_toUInt16,"Test converting a bool variant to an uint16")
    sahtest_add_test(variant_bool_toUInt32,"Test converting a bool variant to an uint32")
    sahtest_add_test(variant_bool_toUInt64,"Test converting a bool variant to an uint64")
    sahtest_add_test(variant_bool_toBool,"Test converting a bool variant to a bool")
    sahtest_add_test(variant_bool_toFd,"Test converting a bool variant to a file descriptor")
    sahtest_add_test(variant_bool_toDouble,"Test converting a bool variant to a double")
    sahtest_add_test(variant_bool_toList,"Test converting a bool variant to a list")
    sahtest_add_test(variant_bool_toMap,"Test converting a bool variant to a map")
sahtest_group_end()

#endif // BOOL_VARIANT_CONVERSION_H
