/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef LIST_VARIANT_CONVERSION_H
#define LIST_VARIANT_CONVERSION_H

void variant_list_conversion_setup();
void variant_list_conversion_teardown();

int variant_list_tostring();
int variant_list_tojson();
int variant_list_toChar();
int variant_list_toInt8();
int variant_list_toInt16();
int variant_list_toInt32();
int variant_list_toInt64();
int variant_list_toUInt8();
int variant_list_toUInt16();
int variant_list_toUInt32();
int variant_list_toUInt64();
int variant_list_toBool();
int variant_list_toFd();
int variant_list_toDouble();
int variant_list_toList();
int variant_list_toMap();

sahtest_group_begin(list_conversion,variant_list_conversion_setup,variant_list_conversion_teardown)
    sahtest_add_test(variant_list_tostring,"Test converting a list variant to a string")
    sahtest_add_test(variant_list_tojson,"Test converting a list variant to a json string")
    sahtest_add_test(variant_list_toChar,"Test converting a list variant to a char pointer")
    sahtest_add_test(variant_list_toInt8,"Test converting a list variant to an int8")
    sahtest_add_test(variant_list_toInt16,"Test converting a list variant to an int16")
    sahtest_add_test(variant_list_toInt32,"Test converting a list variant to an int32")
    sahtest_add_test(variant_list_toInt64,"Test converting a list variant to an int64")
    sahtest_add_test(variant_list_toUInt8,"Test converting a list variant to an uint8")
    sahtest_add_test(variant_list_toUInt16,"Test converting a list variant to an uint16")
    sahtest_add_test(variant_list_toUInt32,"Test converting a list variant to an uint32")
    sahtest_add_test(variant_list_toUInt64,"Test converting a list variant to an uint64")
    sahtest_add_test(variant_list_toBool,"Test converting a list variant to a bool")
    sahtest_add_test(variant_list_toFd,"Test converting a list variant to a file descriptor")
    sahtest_add_test(variant_list_toDouble,"Test converting a list variant to a double")
    sahtest_add_test(variant_list_toList,"Test converting a list variant to a list")
    sahtest_add_test(variant_list_toMap,"Test converting a list variant to a map")
sahtest_group_end()

#endif // LIST_VARIANT_CONVERSION_H
