/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef VARIANT_TOSTRING_CONVERSIONS_H
#define VARIANT_TOSTRING_CONVERSIONS_H

void variant_string_conversion_setup();
void variant_string_conversion_teardown();

int variant_string_tostring();
int variant_string_tojson();
int variant_string_toChar();
int variant_string_toInt8();
int variant_string_toInt16();
int variant_string_toInt32();
int variant_string_toInt64();
int variant_string_toUInt8();
int variant_string_toUInt16();
int variant_string_toUInt32();
int variant_string_toUInt64();
int variant_string_toBool();
int variant_string_toFd();
int variant_string_toDouble();
int variant_string_toList();
int variant_string_toMap();

sahtest_group_begin(string_conversion,variant_string_conversion_setup,variant_string_conversion_teardown)
    sahtest_add_test(variant_string_tostring,"Test converting a string variant to a string")
    sahtest_add_test(variant_string_tojson,"Test converting a string variant to a json string")
    sahtest_add_test(variant_string_toChar,"Test converting a string variant to a char pointer")
    sahtest_add_test(variant_string_toInt8,"Test converting a string variant to an int8")
    sahtest_add_test(variant_string_toInt16,"Test converting a string variant to an int16")
    sahtest_add_test(variant_string_toInt32,"Test converting a string variant to an int32")
    sahtest_add_test(variant_string_toInt64,"Test converting a string variant to an int64")
    sahtest_add_test(variant_string_toUInt8,"Test converting a string variant to an uint8")
    sahtest_add_test(variant_string_toUInt16,"Test converting a string variant to an uint16")
    sahtest_add_test(variant_string_toUInt32,"Test converting a string variant to an uint32")
    sahtest_add_test(variant_string_toUInt64,"Test converting a string variant to an uint64")
    sahtest_add_test(variant_string_toBool,"Test converting a string variant to a bool")
    sahtest_add_test(variant_string_toFd,"Test converting a string variant to a file descriptor")
    sahtest_add_test(variant_string_toDouble,"Test converting a string variant to a double")
    sahtest_add_test(variant_string_toList,"Test converting a string variant to a list")
    sahtest_add_test(variant_string_toMap,"Test converting a string variant to a map")
sahtest_group_end()

#endif // VARIANT_TOSTRING_CONVERSIONS_H
