/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef TEST_VARIANT_H
#define TEST_VARIANT_H

#include "variant/variant_init.h"
#include "variant/string_variant_conversion.h"
#include "variant/int8_variant_conversion.h"
#include "variant/int16_variant_conversion.h"
#include "variant/int32_variant_conversion.h"
#include "variant/int64_variant_conversion.h"
#include "variant/uint8_variant_conversion.h"
#include "variant/uint16_variant_conversion.h"
#include "variant/uint32_variant_conversion.h"
#include "variant/uint64_variant_conversion.h"
#include "variant/bool_variant_conversion.h"
#include "variant/null_unknown_variant_conversion.h"
#include "variant/variant_copy.h"
#include "variant/variant_da.h"
#include "variant/variant_compare.h"
#include "variant/list_variant_conversion.h"

sahtest_group_begin(variant,NULL,NULL)
    sahtest_add_group(var_init_cleanup, "Test initializing a variant in all different posibilities")
    sahtest_add_group(string_conversion, "Test string variant coversions to other types")
    sahtest_add_group(int8_conversion, "Test int8 variant coversions to other types")
    sahtest_add_group(int16_conversion, "Test int16 variant coversions to other types")
    sahtest_add_group(int32_conversion, "Test int32 variant coversions to other types")
    sahtest_add_group(int64_conversion, "Test int64 variant coversions to other types")
    sahtest_add_group(uint8_conversion, "Test uint8 variant coversions to other types")
    sahtest_add_group(uint16_conversion, "Test uint16 variant coversions to other types")
    sahtest_add_group(uint32_conversion, "Test uint32 variant coversions to other types")
    sahtest_add_group(uint64_conversion, "Test uint64 variant coversions to other types")
    sahtest_add_group(bool_conversion, "Test bool variant coversions to other types")
    sahtest_add_group(null_unknown_conversion, "Test null or unknown variant coversions to other types")
    sahtest_add_group(var_copy, "Test variant copy function")
    sahtest_add_group(direct_access, "Test variant direct access functions")
    sahtest_add_group(var_compare, "Test variant compare")
    sahtest_add_group(list_conversion, "Test list variant conversions to other types")
sahtest_group_end()

#endif // TEST_VARIANT_H
