/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef VARIANT_COMPARE_H
#define VARIANT_COMPARE_H

void variant_compare_setup();
void variant_compare_teardown();

int variant_compare_null_null();
int variant_compare_null_variant();
int variant_compare_variant_null();

int variant_compare_unknown_unknown();
int variant_compare_unknown_variant();

int variant_compare_int8_unknown();
int variant_compare_int8_null();
int variant_compare_int8_smaller_variant();
int variant_compare_int8_equal_variant();
int variant_compare_int8_bigger_variant();

int variant_compare_int16_unknown();
int variant_compare_int16_null();
int variant_compare_int16_smaller_variant();
int variant_compare_int16_equal_variant();
int variant_compare_int16_bigger_variant();

int variant_compare_int32_unknown();
int variant_compare_int32_null();
int variant_compare_int32_smaller_variant();
int variant_compare_int32_equal_variant();
int variant_compare_int32_bigger_variant();

int variant_compare_int64_unknown();
int variant_compare_int64_null();
int variant_compare_int64_smaller_variant();
int variant_compare_int64_equal_variant();
int variant_compare_int64_bigger_variant();

int variant_compare_uint8_unknown();
int variant_compare_uint8_null();
int variant_compare_uint8_smaller_variant();
int variant_compare_uint8_equal_variant();
int variant_compare_uint8_bigger_variant();

int variant_compare_uint16_unknown();
int variant_compare_uint16_null();
int variant_compare_uint16_smaller_variant();
int variant_compare_uint16_equal_variant();
int variant_compare_uint16_bigger_variant();

int variant_compare_uint32_unknown();
int variant_compare_uint32_null();
int variant_compare_uint32_smaller_variant();
int variant_compare_uint32_equal_variant();
int variant_compare_uint32_bigger_variant();

int variant_compare_uint64_unknown();
int variant_compare_uint64_null();
int variant_compare_uint64_smaller_variant();
int variant_compare_uint64_equal_variant();
int variant_compare_uint64_bigger_variant();

int variant_compare_char_unknown();
int variant_compare_char_null();
int variant_compare_char_smaller_variant();
int variant_compare_char_equal_variant();
int variant_compare_char_bigger_variant();

int variant_compare_initialized_string_initialized_string();

sahtest_group_begin(var_compare,variant_compare_setup,variant_compare_teardown)
    sahtest_add_test(variant_compare_null_null,"Compare NULL with NULL")
    sahtest_add_test(variant_compare_null_variant,"Compare NULL with variant")
    sahtest_add_test(variant_compare_variant_null,"Compare variant with NULL")
    sahtest_add_test(variant_compare_unknown_unknown,"Compare unknown variant with unknown variant")
    sahtest_add_test(variant_compare_unknown_variant,"Compare unknwon with variant")
    sahtest_add_test(variant_compare_int8_unknown,"Compare int8 with unknown")
    sahtest_add_test(variant_compare_int8_null,"Compare int8 with NULL")
    sahtest_add_test(variant_compare_int8_smaller_variant,"Compare int8 with smaler variant")
    sahtest_add_test(variant_compare_int8_equal_variant,"Compare int8 with equal variant")
    sahtest_add_test(variant_compare_int8_bigger_variant,"Compare int8 with bigger variant")
    sahtest_add_test(variant_compare_int16_unknown,"Compare int16 with unknown")
    sahtest_add_test(variant_compare_int16_null,"Compare int16 with NULL")
    sahtest_add_test(variant_compare_int16_smaller_variant,"Compare int16 with smaler variant")
    sahtest_add_test(variant_compare_int16_equal_variant,"Compare int16 with equal variant")
    sahtest_add_test(variant_compare_int16_bigger_variant,"Compare int16 with bigger variant")
    sahtest_add_test(variant_compare_int32_unknown,"Compare int32 with unknown")
    sahtest_add_test(variant_compare_int32_null,"Compare int32 with NULL")
    sahtest_add_test(variant_compare_int32_smaller_variant,"Compare int32 with smaler variant")
    sahtest_add_test(variant_compare_int32_equal_variant,"Compare int32 with equal variant")
    sahtest_add_test(variant_compare_int32_bigger_variant,"Compare int32 with bigger variant")
    sahtest_add_test(variant_compare_int64_unknown,"Compare int64 with unknown")
    sahtest_add_test(variant_compare_int64_null,"Compare int64 with NULL")
    sahtest_add_test(variant_compare_int64_smaller_variant,"Compare int64 with smaler variant")
    sahtest_add_test(variant_compare_int64_equal_variant,"Compare int64 with equal variant")
    sahtest_add_test(variant_compare_int64_bigger_variant,"Compare int64 with bigger variant")
    sahtest_add_test(variant_compare_uint8_unknown,"Compare uint8 with unknown")
    sahtest_add_test(variant_compare_uint8_null,"Compare uint8 with NULL")
    sahtest_add_test(variant_compare_uint8_smaller_variant,"Compare uint8 with smaler variant")
    sahtest_add_test(variant_compare_uint8_equal_variant,"Compare uint8 with equal variant")
    sahtest_add_test(variant_compare_uint8_bigger_variant,"Compare uint8 with bigger variant")
    sahtest_add_test(variant_compare_uint16_unknown,"Compare uint16 with unknown")
    sahtest_add_test(variant_compare_uint16_null,"Compare uint16 with NULL")
    sahtest_add_test(variant_compare_uint16_smaller_variant,"Compare uint16 with smaler variant")
    sahtest_add_test(variant_compare_uint16_equal_variant,"Compare uint16 with equal variant")
    sahtest_add_test(variant_compare_uint16_bigger_variant,"Compare uint16 with bigger variant")
    sahtest_add_test(variant_compare_uint32_unknown,"Compare uint32 with unknown")
    sahtest_add_test(variant_compare_uint32_null,"Compare uint32 with NULL")
    sahtest_add_test(variant_compare_uint32_smaller_variant,"Compare uint32 with smaler variant")
    sahtest_add_test(variant_compare_uint32_equal_variant,"Compare uint32 with equal variant")
    sahtest_add_test(variant_compare_uint32_bigger_variant,"Compare uint32 with bigger variant")
    sahtest_add_test(variant_compare_uint64_unknown,"Compare uint64 with unknown")
    sahtest_add_test(variant_compare_uint64_null,"Compare uint64 with NULL")
    sahtest_add_test(variant_compare_uint64_smaller_variant,"Compare uint64 with smaler variant")
    sahtest_add_test(variant_compare_uint64_equal_variant,"Compare uint64 with equal variant")
    sahtest_add_test(variant_compare_uint64_bigger_variant,"Compare uint64 with bigger variant")
    sahtest_add_test(variant_compare_char_unknown,"Compare char with unknown")
    sahtest_add_test(variant_compare_char_null,"Compare char with NULL")
    sahtest_add_test(variant_compare_char_smaller_variant,"Compare char with smaler variant")
    sahtest_add_test(variant_compare_char_equal_variant,"Compare char with equal variant")
    sahtest_add_test(variant_compare_char_bigger_variant,"Compare char with bigger variant")
    sahtest_add_test(variant_compare_initialized_string_initialized_string,"Compare initialized string with initialized string, see bug 33303")
sahtest_group_end()
#endif // VARIANT_COMPARE_H
