/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef VARIANT_COPY_H
#define VARIANT_COPY_H

void variant_copy_setup();
void variant_copy_teardown();

int variant_string_copy();
int variant_int8_copy();
int variant_int16_copy();
int variant_int32_copy();
int variant_int64_copy();
int variant_uint8_copy();
int variant_uint16_copy();
int variant_uint32_copy();
int variant_uint64_copy();
int variant_bool_copy();
int variant_double_copy();
int variant_date_time_copy();
int variant_list_copy();
int variant_map_copy();
int variant_fd_copy();
int variant_byte_array_copy();
int variant_null_copy();

sahtest_group_begin(var_copy,variant_copy_setup,variant_copy_teardown)
    sahtest_add_test(variant_string_copy,"Test copying a string variant")
    sahtest_add_test(variant_int8_copy,"Test copying a int8 variant")
    sahtest_add_test(variant_int16_copy,"Test copying a int16 variant")
    sahtest_add_test(variant_int32_copy,"Test copying a int32 variant")
    sahtest_add_test(variant_int64_copy,"Test copying a int64 variant")
    sahtest_add_test(variant_uint8_copy,"Test copying a uint8 variant")
    sahtest_add_test(variant_uint16_copy,"Test copying a uint16 variant")
    sahtest_add_test(variant_uint32_copy,"Test copying a uint32 variant")
    sahtest_add_test(variant_uint64_copy,"Test copying a uint64 variant")
    sahtest_add_test(variant_bool_copy,"Test copying a bool variant")
    sahtest_add_test(variant_double_copy,"Test copying a double variant")
    sahtest_add_test(variant_date_time_copy,"Test copying a date time variant")
    sahtest_add_test(variant_list_copy,"Test copying a list variant")
    sahtest_add_test(variant_map_copy,"Test copying a map variant")
    sahtest_add_test(variant_fd_copy,"Test copying a file descriptor variant")
    sahtest_add_test(variant_byte_array_copy,"Test copying a byte array variant")
    sahtest_add_test(variant_null_copy,"Test copying with a null variant as source or destination")
sahtest_group_end()

#endif // VARIANT_COPY_H
