/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef VARIANT_DA_H
#define VARIANT_DA_H

void variant_da_setup();
void variant_da_teardown();

int variant_check_da_bytearray();
int variant_check_da_char();
int variant_check_da_datetime();
int variant_check_da_list();
int variant_check_da_map();
int variant_check_da_string();

sahtest_group_begin(direct_access,variant_da_setup,variant_da_teardown)
    sahtest_add_test(variant_check_da_bytearray,"Check direct access to byte array")
    sahtest_add_test(variant_check_da_char,"Check direct access to char pointer")
    sahtest_add_test(variant_check_da_datetime,"Check direct access to date time pointer")
    sahtest_add_test(variant_check_da_list,"Check direct access to variant list pointer")
    sahtest_add_test(variant_check_da_map,"Check direct access to variant map pointer")
    sahtest_add_test(variant_check_da_string,"Check direct access to variant string pointer")
sahtest_group_end()

#endif // VARIANT_DA_H
