/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef VARIANT_INIT_H
#define VARIANT_INIT_H

void variant_init_setup();
void variant_init_teardown();

int variant_init_using_initialize();
int variant_init_setChar();
int variant_init_setString();
int variant_init_setInt8();
int variant_init_setInt16();
int variant_init_setInt32();
int variant_init_setInt64();
int variant_init_setUInt8();
int variant_init_setUInt16();
int variant_init_setUInt32();
int variant_init_setUInt64();
int variant_init_setBool();
int variant_init_setDouble();
int variant_init_setDateTime();
int variant_init_setListMove();
int variant_init_setListCopy();
int variant_init_setMapMove();
int variant_init_setMapCopy();
int variant_init_setFd();
int variant_init_setByteArray();

sahtest_group_begin(var_init_cleanup,variant_init_setup,variant_init_teardown)
    sahtest_add_test(variant_init_using_initialize,"Test initializing a variant using variant_initialize")
    sahtest_add_test(variant_init_setChar,"Test initializing a variant using variant_setChar")
    sahtest_add_test(variant_init_setString,"Test initializing a variant using variant_setString")
    sahtest_add_test(variant_init_setInt8,"Test initializing a variant using variant_setInt8")
    sahtest_add_test(variant_init_setInt16,"Test initializing a variant using variant_setInt16")
    sahtest_add_test(variant_init_setInt32,"Test initializing a variant using variant_setInt32")
    sahtest_add_test(variant_init_setInt64,"Test initializing a variant using variant_setInt64")
    sahtest_add_test(variant_init_setUInt8,"Test initializing a variant using variant_setUInt8")
    sahtest_add_test(variant_init_setUInt16,"Test initializing a variant using variant_setInt16")
    sahtest_add_test(variant_init_setUInt32,"Test initializing a variant using variant_setInt32")
    sahtest_add_test(variant_init_setUInt64,"Test initializing a variant using variant_setInt64")
    sahtest_add_test(variant_init_setBool,"Test initializing a variant using variant_setBool")
    sahtest_add_test(variant_init_setDouble,"Test initializing a variant using variant_setDouble")
    sahtest_add_test(variant_init_setDateTime,"Test initializing a variant using variant_setDateTime")
    sahtest_add_test(variant_init_setListMove,"Test initializing a variant using variant_setListMove")
    sahtest_add_test(variant_init_setListCopy,"Test initializing a variant using variant_setListCopy")
    sahtest_add_test(variant_init_setMapMove,"Test initializing a variant using variant_setMapMove")
    sahtest_add_test(variant_init_setMapCopy,"Test initializing a variant using variant_setMapCopy")
    sahtest_add_test(variant_init_setFd,"Test initializing a variant using variant_setFd")
    sahtest_add_test(variant_init_setByteArray,"Test initializing a variant using variant_setByteArray")
sahtest_group_end()

#endif // VARIANT_INIT_H
