/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef TEST_VARIANT_LIST_H
#define TEST_VARIANT_LIST_H

#include "variant_list/variant_list_init.h"
#include "variant_list/variant_list_it.h"
#include "variant_list/variant_list_add.h"
#include "variant_list/variant_list_iterating.h"
#include "variant_list/variant_list_append.h"
#include "variant_list/variant_list_prepend.h"
#include "variant_list/variant_list_insert_indexed.h"
#include "variant_list/variant_list_contains.h"
#include "variant_list/variant_list_remove.h"

sahtest_group_begin(var_list,NULL,NULL)
    sahtest_add_group(vl_init_cleanup, "Test initializing and cleaning up variant lists")
    sahtest_add_group(vl_iterators, "Test creation of variant list iterators")
    sahtest_add_group(vl_add, "Test adding different type to a variant list")
    sahtest_add_group(vl_iterating, "Test iterating over a variant list")
    sahtest_add_group(vl_append, "Test appending to a variant list")
    sahtest_add_group(vl_prepend, "Test prepending to a variant list")
    sahtest_add_group(vl_insert_indexed, "Test inserting elements using index")
    sahtest_add_group(vl_contains, "Test variant list contains")
    sahtest_add_group(vl_remove, "Test variant list take")
sahtest_group_end()

#endif // TEST_VARIANT_LIST_H
