/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef VARIANT_LIST_ADD_H
#define VARIANT_LIST_ADD_H

void variant_list_add_setup();
void variant_list_add_teardown();

int variant_list_add_variant();
int variant_list_add_char();
int variant_list_add_string();
int variant_list_add_int8();
int variant_list_add_int16();
int variant_list_add_int32();
int variant_list_add_int64();
int variant_list_add_uint8();
int variant_list_add_uint16();
int variant_list_add_uint32();
int variant_list_add_uint64();
int variant_list_add_bool();
int variant_list_add_double();
int variant_list_add_date_time();
int variant_list_add_list_move();
int variant_list_add_list_copy();
int variant_list_add_map_move();
int variant_list_add_map_copy();

sahtest_group_begin(vl_add,variant_list_add_setup,variant_list_add_teardown)
    sahtest_add_test(variant_list_add_variant,"Test adding a variant")
    sahtest_add_test(variant_list_add_char,"Test cadding a const char pointer")
    sahtest_add_test(variant_list_add_string,"Test adding string_t")
    sahtest_add_test(variant_list_add_int8,"Test adding from int8")
    sahtest_add_test(variant_list_add_int16,"Test adding int16")
    sahtest_add_test(variant_list_add_int32,"Test adding int32")
    sahtest_add_test(variant_list_add_int64,"Test adding int64")
    sahtest_add_test(variant_list_add_uint8,"Test adding uint8")
    sahtest_add_test(variant_list_add_uint16,"Test adding uint16")
    sahtest_add_test(variant_list_add_uint32,"Test adding uint32")
    sahtest_add_test(variant_list_add_uint64,"Test adding uint64")
    sahtest_add_test(variant_list_add_bool,"Test adding bool")
    sahtest_add_test(variant_list_add_double,"Test adding double")
    sahtest_add_test(variant_list_add_date_time,"Test adding struct tm")
    sahtest_add_test(variant_list_add_list_move,"Test adding variant list, moving the elements")
    sahtest_add_test(variant_list_add_list_copy,"Test adding variant list, copying the elements")
    sahtest_add_test(variant_list_add_map_move,"Test adding variant map, moving the elements")
    sahtest_add_test(variant_list_add_map_copy,"Test adding variant map, copying the elements")
sahtest_group_end()

#endif // VARIANT_LIST_ADD_H
