/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef VARIANT_LIST_PREPEND_H
#define VARIANT_LIST_PREPEND_H

void variant_list_prepend_setup();
void variant_list_prepend_teardown();

int variant_list_prepend_null_list();
int variant_list_prepend_null_it();
int variant_list_prepend_orphan();
int variant_list_prepend_iterator_twice();
int variant_list_prepend_multiple();

sahtest_group_begin(vl_prepend,variant_list_prepend_setup,variant_list_prepend_teardown)
    sahtest_add_test(variant_list_prepend_null_list,"Test appending iterator to null list")
    sahtest_add_test(variant_list_prepend_null_it,"Test appending null iterator to list")
    sahtest_add_test(variant_list_prepend_orphan,"Test appending a valid iterator")
    sahtest_add_test(variant_list_prepend_iterator_twice,"Test appending the same iterator twice")
    sahtest_add_test(variant_list_prepend_multiple,"Test appending multiple iterators after each other")
sahtest_group_end()

#endif // VARIANT_LIST_PREPEND_H
