/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef TEST_VARIANT_MAP_H
#define TEST_VARIANT_MAP_H

#include "variant_map/variant_map_init.h"
#include "variant_map/variant_map_it.h"
#include "variant_map/variant_map_add.h"
#include "variant_map/variant_map_iterating.h"
#include "variant_map/variant_map_append.h"
#include "variant_map/variant_map_prepend.h"
#include "variant_map/variant_map_insert_indexed.h"
#include "variant_map/variant_map_contains.h"
#include "variant_map/variant_map_remove.h"

sahtest_group_begin(var_map,NULL,NULL)
    sahtest_add_group(vm_init_cleanup, "Test initializing and cleaning up variant map")
    sahtest_add_group(vm_iterators, "Test creation of variant map iterators")
    sahtest_add_group(vm_add, "Test adding different type to a variant map")
    sahtest_add_group(vm_iterating, "Test iterating over a variant map")
    sahtest_add_group(vm_append, "Test appending to a variant map")
    sahtest_add_group(vm_prepend, "Test prepending to a variant map")
    sahtest_add_group(vm_insert_indexed, "Test inserting elements using index")
    sahtest_add_group(vm_contains, "Test variant map contains")
    sahtest_add_group(vm_remove, "Test variant map take")
sahtest_group_end()

#endif // TEST_VARIANT_MAP_H
