/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef VARIANT_MAP_APPEND_H
#define VARIANT_MAP_APPEND_H

void variant_map_append_setup();
void variant_map_append_teardown();

int variant_map_append_null_map();
int variant_map_append_null_it();
int variant_map_append_orphan();
int variant_map_append_iterator_twice();
int variant_map_append_multiple();

sahtest_group_begin(vm_append,variant_map_append_setup,variant_map_append_teardown)
    sahtest_add_test(variant_map_append_null_map,"Test appending iterator to null map")
    sahtest_add_test(variant_map_append_null_it,"Test appending null iterator to map")
    sahtest_add_test(variant_map_append_orphan,"Test appending a valid iterator")
    sahtest_add_test(variant_map_append_iterator_twice,"Test appending the same iterator twice")
    sahtest_add_test(variant_map_append_multiple,"Test appending multiple iterators after each other")
sahtest_group_end()

#endif // VARIANT_MAP_APPEND_H
