/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#include <sahtest/sahtest.h>
#include <pcb/utils/variant_map.h>

static variant_map_t map;

void variant_map_contains_setup() {
    variant_map_initialize(&map);
    variant_map_addInt16(&map,"1",-300);
    variant_map_addInt16(&map,"2",-200);
    variant_map_addInt16(&map,"3",-100);
    variant_map_addInt16(&map,"4",0);
    variant_map_addInt16(&map,"5",100);
    variant_map_addInt16(&map,"6",200);
    variant_map_addInt16(&map,"7",300);
}

void variant_map_contains_teardown() {
    variant_map_cleanup(&map);
}

int variant_map_contains_search_valid_item() {
    assert_bool(variant_map_contains(&map,"5") == true);

    sahtest_success();
}

int variant_map_contains_search_invalid_item() {
    assert_bool(variant_map_contains(&map,"8") == false);

    sahtest_success();
}

int variant_map_contains_null_key() {
    assert_bool(variant_map_contains(&map,NULL) == false);

    sahtest_success();
}

int variant_map_contains_using_null_map() {
    assert_bool(variant_map_contains(NULL,"3") == false);

    sahtest_success();
}

