/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef VARIANT_MAP_INSERT_INDEXED_H
#define VARIANT_MAP_INSERT_INDEXED_H

void variant_map_insert_build_map_setup();
void variant_map_insert_build_map_teardown();

int variant_map_insert_indexed_null_map();
int variant_map_insert_indexed_empty_map_index_0();
int variant_map_insert_indexed_empty_map_index_2();
int variant_map_insert_indexed_map_index_out_of_boundry();
int variant_map_insert_indexed_map_index_0();
int variant_map_insert_indexed_map_index_2();
int variant_map_insert_indexed_map_index_last();

sahtest_group_begin(vm_insert_indexed,variant_map_insert_build_map_setup,variant_map_insert_build_map_teardown)
    sahtest_add_test(variant_map_insert_indexed_null_map,"Test inserting in a null map using index")
    sahtest_add_test(variant_map_insert_indexed_empty_map_index_0,"Test inserting in a empty map with index 0")
    sahtest_add_test(variant_map_insert_indexed_empty_map_index_2,"Test inserting in a empty map with index 2")
    sahtest_add_test(variant_map_insert_indexed_map_index_out_of_boundry,"Test inserting in a map with index higher then size of map")
    sahtest_add_test(variant_map_insert_indexed_map_index_0,"Test inserting in a map with index 0")
    sahtest_add_test(variant_map_insert_indexed_map_index_2,"Test inserting with index set to 2")
    sahtest_add_test(variant_map_insert_indexed_map_index_last,"Test inserting with index set to last item")
sahtest_group_end()


#endif // VARIANT_MAP_INSERT_INDEXED_H
