/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef VARIANT_MAP_IT_H
#define VARIANT_MAP_IT_H

void variant_map_it_setup();
void variant_map_it_teardown();

int variant_map_it_create();
int variant_map_it_create_char();
int variant_map_it_create_string();
int variant_map_it_create_int8();
int variant_map_it_create_int16();
int variant_map_it_create_int32();
int variant_map_it_create_int64();
int variant_map_it_create_uint8();
int variant_map_it_create_uint16();
int variant_map_it_create_uint32();
int variant_map_it_create_uint64();
int variant_map_it_create_bool();
int variant_map_it_create_double();
int variant_map_it_create_date_time();
int variant_map_it_create_list_move();
int variant_map_it_create_list_copy();
int variant_map_it_create_map_move();
int variant_map_it_create_map_copy();

sahtest_group_begin(vm_iterators,variant_map_it_setup,variant_map_it_teardown)
    sahtest_add_test(variant_map_it_create,"Test create map iterator from variant")
    sahtest_add_test(variant_map_it_create_char,"Test create map iterator from const char pointer")
    sahtest_add_test(variant_map_it_create_string,"Test create map iterator from string_t")
    sahtest_add_test(variant_map_it_create_int8,"Test create map iterator from int8")
    sahtest_add_test(variant_map_it_create_int16,"Test create map iterator from int16")
    sahtest_add_test(variant_map_it_create_int32,"Test create map iterator from int32")
    sahtest_add_test(variant_map_it_create_int64,"Test create map iterator from int64")
    sahtest_add_test(variant_map_it_create_uint8,"Test create map iterator from uint8")
    sahtest_add_test(variant_map_it_create_uint16,"Test create map iterator from uint16")
    sahtest_add_test(variant_map_it_create_uint32,"Test create map iterator from uint32")
    sahtest_add_test(variant_map_it_create_uint64,"Test create map iterator from uint64")
    sahtest_add_test(variant_map_it_create_bool,"Test create map iterator from bool")
    sahtest_add_test(variant_map_it_create_double,"Test create map iterator from double")
    sahtest_add_test(variant_map_it_create_date_time,"Test create map iterator from struct tm")
    sahtest_add_test(variant_map_it_create_list_move,"Test create map iterator from a variant list, moving the elements")
    sahtest_add_test(variant_map_it_create_list_copy,"Test create map iterator from a variant list, copying the elements")
    sahtest_add_test(variant_map_it_create_map_move,"Test create map iterator from a variant map, moving the elements")
    sahtest_add_test(variant_map_it_create_map_copy,"Test create map iterator from a variant map, copying the elements")
sahtest_group_end()


#endif // VARIANT_MAP_IT_H
