/****************************************************************************
**
** Copyright (C) 2011 SoftAtHome. All rights reserved.
**
** SoftAtHome reserves all rights not expressly granted herein.
**
** - DISCLAIMER OF WARRANTY -
**
** THIS FILE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
** EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE.
**
** THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE
** CODE IS WITH YOU. SHOULD THE SOURCE CODE PROVE DEFECTIVE, YOU
** ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
**
** - LIMITATION OF LIABILITY -
**
** IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
** WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
** AND/OR DISTRIBUTES THE SOURCE CODE, BE LIABLE TO YOU FOR DAMAGES,
** INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
** ARISING OUT OF THE USE OR INABILITY TO USE THE SOURCE CODE
** (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED
** INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE
** OF THE SOURCE CODE TO OPERATE WITH ANY OTHER PROGRAM), EVEN IF SUCH
** HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
** DAMAGES.
**
****************************************************************************/

#ifndef VARIANT_MAP_REMOVE_H
#define VARIANT_MAP_REMOVE_H

void variant_map_remove_setup();
void variant_map_remove_teardown();

int variant_map_remove_take_first_null();
int variant_map_remove_take_last_null();
int variant_map_remove_take_first_empty_map();
int variant_map_remove_take_last_empty_map();
int variant_map_remove_take_first();
int variant_map_remove_take_last();
int variant_map_remove_take_null();

sahtest_group_begin(vm_remove,variant_map_remove_setup,variant_map_remove_teardown)
    sahtest_add_test(variant_map_remove_take_first_null,"Test removing first item from null pointer map")
    sahtest_add_test(variant_map_remove_take_last_null,"Test removing last item from null pointer map")
    sahtest_add_test(variant_map_remove_take_first_empty_map,"Test removing first item from empty map")
    sahtest_add_test(variant_map_remove_take_last_empty_map,"Test removing last item from null pointer map")
    sahtest_add_test(variant_map_remove_take_first,"Test removing first item from map")
    sahtest_add_test(variant_map_remove_take_last,"Test removing last item from map")
    sahtest_add_test(variant_map_remove_take_null,"Test removing null item from a map")
sahtest_group_end()

#endif // VARIANT_MAP_REMOVE_H
