include $(STAGINGDIR)/components.config

SDL_TTF_CONFIGURATION := --with-sdl-prefix=$(STAGINGDIR)

ifeq ($(notdir $(CC)),gcc)
  SDL-TTF_CONFIGURATION_CFLAGS:=-ggdb3 -O0
	SDL_TTF_CONFIGURATION += --prefix=/
else
  SDL-TTF_CONFIGURATION_CFLAGS:=-g -O2
	SDL_TTF_CONFIGURATION += --host=mips-linux --prefix=/ --build=i686
endif

SDL-TTF_CONFIGURATION_CFLAGS += -I$(STAGINGDIR)/include/SDL -L$(STAGINGDIR)/lib

SDL_IMAGE-VERSION := SDL_image-1.2.12

all: sdl-ttf-all

install :
	@echo "Installing to: " $(STAGINGDIR)
	$(MAKE) -C $(SDL_IMAGE-VERSION) install DESTDIR=$(STAGINGDIR)
	$(INSTALL) -d $(PKG_CONFIG_LIBDIR)
	$(INSTALL) -m 0755 SDL_image.pc $(PKG_CONFIG_LIBDIR)/

release:
	@echo "Releasing to: " $(ROOT_FS_DIR)
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 0644 $(STAGINGDIR)/lib/libSDL_image.so $(ROOT_FS_DIR)/lib
	(cd $(ROOT_FS_DIR)/lib; ln -sf libSDL_image.so libSDL_image-1.2.so.0)
	(cd $(ROOT_FS_DIR)/lib; ln -sf libSDL_image.so libSDL_image-1.2.so.0.8.4)

clean:
	if [ -e $(SDL_IMAGE-VERSION)/Makefile ]; then $(MAKE) -C $(SDL_IMAGE-VERSION) distclean; fi;
	rm -rf $(SDL_IMAGE-VERSION)/Makefile

sdl-ttf-all: $(SDL_IMAGE-VERSION)/Makefile
	$(MAKE) -C $(SDL_IMAGE-VERSION) all

$(SDL_IMAGE-VERSION)/Makefile:
	cd $(SDL_IMAGE-VERSION) ; \
	./configure $(SDL_TTF_CONFIGURATION) CFLAGS="$(SDL-TTF_CONFIGURATION_CFLAGS)"


.PHONY: all install release clean
