include $(STAGINGDIR)/components.config

ifeq ($(notdir $(CC)),gcc)
  SDL_CONFIGURATION_FLAGS:=CFLAGS="-ggdb3 -O0"
	SDL_CONFIGURATION := --prefix=/ \
                       --enable-video-x11 \
                       --enable-x11-shared \
                       --disable-video-dummy \
                       --enable-video \
                       --disable-audio \
                       --disable-joystick \
                       --disable-cdrom  \
                       --disable-dga \
                       --disable-video-dga \
                       --disable-video-x11-dgamouse \
                       --disable-video-x11-vm \
                       --disable-video-x11-xv \
                       --disable-video-x11-xinerama \
                       --disable-video-x11-xme  \
                       --disable-video-x11-xrandr \
                       --disable-video-photon \
                       --disable-video-cocoa \
                       --disable-video-directfb \
                       --disable-video-ps2gs \
                       --disable-video-ps3 \
                       --disable-video-ggi \
                       --disable-video-svga \
                       --disable-video-vgl \
                       --disable-video-wscons \
                       --disable-video-fbcon \
                       --enable-clock_gettime \
                       --disable-video-opengl
else
  SDL_CONFIGURATION_FLAGS:=CFLAGS="-g -O2"
	SDL_CONFIGURATION := --host=mips-linux --prefix=/ --build=i686 \
                       --disable-video-x11 \
                       --disable-x11-shared \
                       --disable-video-dummy \
                       --enable-video \
                       --disable-audio \
                       --disable-joystick \
                       --disable-cdrom  \
                       --disable-dga \
                       --disable-video-dga \
                       --disable-video-x11-dgamouse \
                       --disable-video-x11-vm \
                       --disable-video-x11-xv \
                       --disable-video-x11-xinerama \
                       --disable-video-x11-xme  \
                       --disable-video-x11-xrandr \
                       --disable-video-photon \
                       --disable-video-cocoa \
                       --disable-video-directfb \
                       --disable-video-ps2gs \
                       --disable-video-ps3 \
                       --disable-video-ggi \
                       --disable-video-svga \
                       --disable-video-vgl \
                       --disable-video-wscons \
                       --enable-video-fbcon \
                       --enable-clock_gettime \
                       --disable-video-opengl
endif

ifneq ($(CONFIG_SAH_LIB_SDL_USE_THREADS), y)
	SDL_USE_THREADS := --disable-threads
endif

SDL-VERSION := SDL-1.2.15

all: sdl-all

install :
	@echo "Installing to: " $(STAGINGDIR)
	$(MAKE) -C $(SDL-VERSION) install DESTDIR=$(STAGINGDIR)
	$(INSTALL) -d $(PKG_CONFIG_LIBDIR)
	$(INSTALL) -m 0755 sdl.pc $(PKG_CONFIG_LIBDIR)/
ifeq ($(CONFIG_SAH_LIB_SDL_BUILD_TESTS), y)
	- cd $(SDL-VERSION)/test && \
        ./configure --prefix=$(STAGINGDIR)  --with-sdl-prefix=$(STAGINGDIR) CFLAGS="-I$(STAGINGDIR)/include/SDL -L$(STAGINGDIR)/lib" && \
        $(MAKE) clean && \
        $(MAKE)
endif

release:
	@echo "Releasing to: " $(ROOT_FS_DIR)
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 0644 $(STAGINGDIR)/lib/libSDL.so $(ROOT_FS_DIR)/lib
	(cd $(ROOT_FS_DIR)/lib; ln -sf libSDL.so libSDL-1.2.so.0)
	(cd $(ROOT_FS_DIR)/lib; ln -sf libSDL.so libSDL-1.2.so.0.11.4)

clean:
	if [ -e $(SDL-VERSION)/Makefile ]; then $(MAKE) -C $(SDL-VERSION) distclean; fi;
	rm -rf $(SDL-VERSION)/Makefile

sdl-all: $(SDL-VERSION)/Makefile
	$(MAKE) -C $(SDL-VERSION) all

$(SDL-VERSION)/Makefile:
	cd $(SDL-VERSION) ; \
	./configure $(SDL_CONFIGURATION) $(SDL_CONFIGURATION_FLAGS) $(SDL_USE_THREADS)


.PHONY: all install release clean
