CFLAGS += -Os
CFLAGS += -g
CFLAGS += -I$(STAGINGDIR)/include

LDFLAGS += -L$(STAGINGDIR)/lib

OBJS= $(SRCS:.c=.o)

ifneq ($(notdir $(CC)),gcc)
  HOST=--host=mips-linux
endif

SONAME=libusb-1.0.so.0.1.0
LINKS=libusb-1.0.so libusb.so

all: Makefile
	make

Makefile:
	./configure $(HOST) --prefix= \
    --with-gnu-ld       \
    --enable-shared     \
    --disable-static    \
    --enable-udev       \
    --enable-system-log \
	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" STRIP="$(STRIP)" CC="$(CC)" CXX="$(CXX)" INSTALL="$(INSTALL) -p"

clean:
	if [ -f Makefile ]; then make distclean; fi

install:
	@echo "Installing to: " $(STAGINGDIR)
	make DESTDIR=$(STAGINGDIR) install

release:
	@echo "make a release in: " $(ROOT_FS_DIR)
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 644 $(STAGINGDIR)/lib/$(SONAME) $(ROOT_FS_DIR)/lib/
	$(STRIP) $(ROOT_FS_DIR)/lib/$(SONAME)
	cd $(ROOT_FS_DIR)/lib && (for i in $(LINKS); do ln -fs $(SONAME) $$i; done)

.PHONY: all clean install release
