# include components.config 
-include $(STAGINGDIR)/components.config

VERSION="$(notdir $(realpath .))"
DOCDIR ?= doc

export VERSION DOCDIR

all:
	$(MAKE) -C src
ifeq ($(CONFIG_SAH_LIB_USERMNGT_HASHING_TOOL),y)
	$(MAKE) -C tools
endif

clean:
	$(MAKE) -C src clean
	$(MAKE) -C tools clean

install:	
	$(INSTALL) -d $(STAGINGDIR)/lib \
		      $(STAGINGDIR)/include/usermngt $(PKG_CONFIG_LIBDIR)
	$(INSTALL) -m 755 src/libusermngt.a $(STAGINGDIR)/lib
	$(INSTALL) -m 755 src/libusermngt-auth.a $(STAGINGDIR)/lib
	$(INSTALL) -m 644 -p include/usermngt/usermngt.h $(STAGINGDIR)/include/usermngt
	$(INSTALL) -m 644 -p include/usermngt/auth.h $(STAGINGDIR)/include/usermngt
	$(INSTALL) -m 644 usermngt.pc $(PKG_CONFIG_LIBDIR)
	$(INSTALL) -m 644 usermngt-auth.pc $(PKG_CONFIG_LIBDIR)
ifeq ($(CONFIG_SAH_LIB_USERMNGT_HASHING_TOOL),y)
	$(INSTALL) -d $(STAGINGDIR)/bin
	$(INSTALL) -m 755 tools/libusermngt_app $(STAGINGDIR)/bin
endif

release:
ifeq ($(CONFIG_SAH_LIB_USERMNGT_HASHING_TOOL),y)
	$(INSTALL) -d $(ROOT_FS_DIR)/bin
	$(INSTALL) -m 755 $(STAGINGDIR)/bin/libusermngt_app $(ROOT_FS_DIR)/bin
	$(STRIP) $(ROOT_FS_DIR)/bin/libusermngt_app
endif

test:

doc:
	doxygen doc/libusermngt.doxy


.PHONY: test release install clean doc all
