ifdef STAGINGDIR
include $(STAGINGDIR)/components.config
endif

VERSION=1.2.5
PROGRAM=libz.so.$(VERSION)

#ifeq ($(notdir $(CC)),gcc)
#	CFG:=--host=i386-linux --enable-shared --with-gnu-ld
#else
#	CFG:=--build=i386-linux --host=mips-linux
#endif

ifeq ($(CONFIG_SAH_LIB_ZLIB_MINIUNZ),y)
	MINIZIP_PATH=contrib/minizip
	LIBMINIUNZ=libminiunz.so
	LIBMINIUNZ_INSTALL=libminiunz.so.install
	LIBMINIUNZ_RELEASE=libminiunz.so.release

$(LIBMINIUNZ): $(PROGRAM)
	$(MAKE) -C $(MINIZIP_PATH) CPPFLAGS=$(CONFIG_CROSS_COMPILE_CPPFLAGS) CFLAGS=$(CONFIG_CROSS_COMPILE_CFLAGS) LDFLAGS=-L$(PWD) $@
endif

z.pc: z.pc.m4 $(STAGINGDIR)/components.config
	cat $(STAGINGDIR)/components.config.m4 $< | m4 > $@

$(PROGRAM):
	./configure $(CFG) --prefix=$(STAGINGDIR)
	make

all: $(PROGRAM) $(LIBMINIUNZ)

clean:
	-make distclean

install: all z.pc
	@echo " ##   Installing $(PROGRAM)"
	#make install
	$(INSTALL) -d $(STAGINGDIR)/include
	$(INSTALL) -p *.h $(STAGINGDIR)/include
	$(INSTALL) -d $(STAGINGDIR)/lib
	$(INSTALL) -m 755 libz.so.$(VERSION) $(STAGINGDIR)/lib/
	cd $(STAGINGDIR)/lib ; ln -sf libz.so.$(VERSION) libz.so.1
	cd $(STAGINGDIR)/lib ; ln -sf libz.so.$(VERSION) libz.so
	$(INSTALL) -D -m 0644 z.pc $(PKG_CONFIG_LIBDIR)/z.pc
	$(INSTALL) -D -m 0644 z.pc $(PKG_CONFIG_LIBDIR)/zlib.pc
ifeq ($(CONFIG_SAH_LIB_ZLIB_MINIUNZ),y)
	$(INSTALL) -d $(STAGINGDIR)/usr/include
	$(INSTALL) -d $(STAGINGDIR)/usr/lib
	$(INSTALL) -m 755 $(MINIZIP_PATH)/libminiunz.so $(STAGINGDIR)/usr/lib
	$(INSTALL) $(MINIZIP_PATH)/ioapi.h $(STAGINGDIR)/usr/include
	$(INSTALL) $(MINIZIP_PATH)/unzip.h $(STAGINGDIR)/usr/include
endif


release:
	@echo " ##   Releasing $(PROGRAM)"
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 755 $(STAGINGDIR)/lib/libz.so.$(VERSION) $(ROOT_FS_DIR)/lib/
	$(STRIP) $(ROOT_FS_DIR)/lib/libz.so.$(VERSION)
	cd $(ROOT_FS_DIR)/lib ; ln -sf libz.so.$(VERSION) libz.so.1
	cd $(ROOT_FS_DIR)/lib ; ln -sf libz.so.$(VERSION) libz.so
ifeq ($(CONFIG_SAH_LIB_ZLIB_MINIUNZ),y)
	$(INSTALL) -d $(ROOT_FS_DIR)/usr/lib
	$(INSTALL) -m 755 $(STAGINGDIR)/usr/lib/libminiunz.so $(ROOT_FS_DIR)/usr/lib
endif

doc:

.PHONY: all install release clean doc

