include $(STAGINGDIR)/sahcommon.mk
ifeq ($(notdir $(CC)),gcc)
	# When building for x86 target, the option --disable-dbus can be removed if you install package libdbus-1-dev
	CFG:=--host=i386-linux --enable-shared --with-gnu-ld --disable-mono --disable-monodoc --disable-dbus
	PKG_CONFIG_PATH := $(PKG_CONFIG_LIBDIR):/usr/lib/pkgconfig:/usr/share/pkgconfig
else
	CFG:=--build=i386-linux --host=mips-linux --disable-dbus 
	PKG_CONFIG_PATH := $(PKG_CONFIG_LIBDIR)
endif

all: avahi-daemon/avahi-daemon

avahi-daemon/avahi-daemon:
	LDFLAGS="-L$(STAGINGDIR)/lib -L$(STAGINGDIR)/usr/lib -ldaemon -Wl,--gc-sections" \
	CFLAGS="-I${STAGINGDIR}/include/expat/ -I${STAGINGDIR}/include/ -I${STAGINGDIR}/usr/include -ffunction-sections -fdata-sections -Os" \
	LIBDAEMON_CFLAGS=-I${STAGINGDIR}/include/libdaemon \
	LIBDAEMON_LIBS=-L${STAGINGDIR}/lib \
	PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) \
	INSTALL="$(INSTALL) -p" \
	./configure $(CFG) --prefix="" --with-distro=none --disable-glib --disable-gobject --disable-qt3 --disable-qt4 --disable-gtk --with-xml=expat --disable-gtk3 --disable-gdbm --disable-xmltoman --disable-manpages --disable-autoipd --disable-python --disable-pygtk --disable-python-dbus --disable-stack-protector --disable-doxygen-doc --with-avahi-user=avahi --with-avahi-group=avahi 
	make 

clean:
	@echo " ##   Clean avahi"
	-make distclean

install:
	@echo " ##   Installing avahi"
	make DESTDIR=${STAGINGDIR} install
	$(INSTALL) -d ${STAGINGDIR}/sbin/
	$(INSTALL) -m 755 avahi-daemon/.libs/avahi-daemon ${STAGINGDIR}/sbin
	$(INSTALL) -m 755 avahi-dnsconfd/.libs/avahi-dnsconfd ${STAGINGDIR}/sbin
	$(INSTALL) -d ${STAGINGDIR}/lib/
	$(INSTALL) -m 755 avahi-common/.libs/libavahi-common.so.3.5.2 $(STAGINGDIR)/lib
	cd $(STAGINGDIR)/lib ; ln -sf libavahi-common.so.3.5.2 libavahi-common.so.3
	cd $(STAGINGDIR)/lib ; ln -sf libavahi-common.so.3.5.2 libavahi-common.so
	$(INSTALL) -m 755 avahi-core/.libs/libavahi-core.so.7.0.0 $(STAGINGDIR)/lib
	cd $(STAGINGDIR)/lib ; ln -fs libavahi-core.so.7.0.0 libavahi-core.so.7
	cd $(STAGINGDIR)/lib ; ln -fs libavahi-core.so.7.0.0 libavahi-core.so	
	$(INSTALL) -d ${STAGINGDIR}/share/avahi/
	$(INSTALL) -m 755 avahi-daemon/avahi-service.dtd $(STAGINGDIR)/share/avahi
ifeq ($(CONFIG_ETC_READONLY),y)
	$(INSTALL) -d $(STAGINGDIR)/etc/avahi
	$(INSTALL) -d $(STAGINGDIR)/usr/lib/avahi
	$(INSTALL) -d $(STAGINGDIR)/usr/lib/avahi/services
	$(INSTALL) -m 755 avahi-daemon/avahi-daemon.conf $(STAGINGDIR)/usr/lib/avahi
	$(INSTALL) -m 755 avahi-daemon/hosts $(STAGINGDIR)/usr/lib/avahi
	$(INSTALL) -m 755 scripts/http.service $(STAGINGDIR)/usr/lib/avahi/services
else
	$(INSTALL) -d $(STAGINGDIR)/etc/avahi/services
	$(INSTALL) -m 755 avahi-daemon/avahi-daemon.conf $(STAGINGDIR)/etc/avahi
	$(INSTALL) -m 755 avahi-daemon/hosts $(STAGINGDIR)/etc/avahi
	$(INSTALL) -m 755 scripts/http.service $(STAGINGDIR)/etc/avahi/services
endif
	m4 -DSTAGINGDIR=$(STAGINGDIR) ./scripts/avahi.sh.m4 > ./scripts/avahi.sh
	$(call install_init,scripts/avahi.sh,98,)
	# fix for bug 13956
	$(INSTALL) -m 755 avahi-common/.libs/libavahi-common.a $(STAGINGDIR)/lib
	$(INSTALL) -m 755 avahi-core/.libs/libavahi-core.a $(STAGINGDIR)/lib
	
release:
	@echo " ##   Releasing avahi"
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 755 ${STAGINGDIR}/lib/libavahi-common.so.3.5.2 $(ROOT_FS_DIR)/lib
	$(STRIP) $(ROOT_FS_DIR)/lib/libavahi-common.so.3.5.2
	cd $(ROOT_FS_DIR)/lib ; ln -sf libavahi-common.so.3.5.2 libavahi-common.so.3
	cd $(ROOT_FS_DIR)/lib ; ln -sf libavahi-common.so.3.5.2 libavahi-common.so
	$(INSTALL) -m 755 ${STAGINGDIR}/lib/libavahi-core.so.7.0.0 $(ROOT_FS_DIR)/lib
	$(STRIP) $(ROOT_FS_DIR)/lib/libavahi-core.so.7.0.0
	cd $(ROOT_FS_DIR)/lib ;	ln -sf libavahi-core.so.7.0.0 libavahi-core.so.7
	cd $(ROOT_FS_DIR)/lib ;	ln -sf libavahi-core.so.7.0.0 libavahi-core.so
	$(INSTALL) -d $(ROOT_FS_DIR)/sbin
	$(INSTALL) -m 755 ${STAGINGDIR}/sbin/avahi-daemon $(ROOT_FS_DIR)/sbin
	$(STRIP) $(ROOT_FS_DIR)/sbin/avahi-daemon
	$(INSTALL) -m 755 ${STAGINGDIR}/sbin/avahi-dnsconfd $(ROOT_FS_DIR)/sbin
	$(STRIP) $(ROOT_FS_DIR)/sbin/avahi-dnsconfd
	$(call install_init_release,scripts/avahi.sh,98,)
ifeq ($(CONFIG_ETC_READONLY),y)
	$(INSTALL) -d $(ROOT_FS_DIR)/etc/
	ln -sf $(CONFIG_RWDATAPATH)/avahi $(ROOT_FS_DIR)/etc/avahi
	$(INSTALL) -d $(ROOT_FS_DIR)/usr/lib/avahi/services
	$(INSTALL) -m 755 $(STAGINGDIR)/usr/lib/avahi/services/http.service $(ROOT_FS_DIR)/usr/lib/avahi/services
else
	$(INSTALL) -d $(ROOT_FS_DIR)/etc_ro_fs/avahi/services
	$(INSTALL) -m 755 $(STAGINGDIR)/etc/avahi/services/http.service $(ROOT_FS_DIR)/etc_ro_fs/avahi/services
endif

doc:

.PHONY: all install release clean doc 

