ifdef STAGINGDIR
include $(STAGINGDIR)/components.config
endif

#do silent make
Q=@

PROGNAME=brctl

CFLAGS += -I$(HARDCO_KERNEL_DIR)/include
ifeq ($(CONFIG_INCLUDE_BRIDGE_PORT_GROUPING), y)
CFLAGS += -DINCLUDE_BRIDGE_PORT_GROUPING
endif
export CFLAGS Q

all: brctl/$(PROGNAME)

release:
	@echo [RELEASE] $(PROGNAME)
	$(INSTALL) -d $(ROOT_FS_DIR)/bin/
	$(INSTALL) -m 755 $(STAGINGDIR)/bin/$(PROGNAME) $(ROOT_FS_DIR)/bin/
	$(Q)$(STRIP) $(ROOT_FS_DIR)/bin/$(PROGNAME)

install: brctl/brctl.c brctl/brctl.h brctl/brctl_cmd.c brctl/brctl_disp.c libbridge/libbridge.a libbridge/libbridge.h
	@echo [INSTALL] $(PROGNAME)
	$(Q)make -C brctl dynamic
	$(Q)$(INSTALL) -d $(STAGINGDIR)/bin/
	$(Q)$(INSTALL) -m 755 brctl/$(PROGNAME) $(STAGINGDIR)/bin
	$(Q)$(INSTALL) -d $(STAGINGDIR)/include/libbridge/
	$(Q)$(INSTALL) -m 555 libbridge/libbridge.h $(STAGINGDIR)/include/libbridge

dynamic: install

static: brctl/brctl.c brctl/brctl.h brctl/brctl_cmd.c brctl/brctl_disp.c libbridge/libbridge.a libbridge/libbridge.h
	$(Q)make -C brctl static

clean:
	@echo [CLEAN] $(PROGNAME)
	$(Q)make -C brctl clean
	$(Q)make -C libbridge clean
	$(Q)rm -f *~ *.a

brctl/brctl: brctl/brctl.c brctl/brctl.h brctl/brctl_cmd.c brctl/brctl_disp.c libbridge/libbridge.a libbridge/libbridge.h
	$(Q)make -C brctl

brctl/brctld: brctl/brctld.c brctl/brctl.h brctl/brctl_cmd.c brctl/brctl_disp.c libbridge/libbridge.a libbridge/libbridge.h
	$(Q)make -C brctl

libbridge/libbridge.a: libbridge/if_index.c libbridge/libbridge.h libbridge/libbridge_compat.c libbridge/libbridge_devif.c libbridge/libbridge_if.c libbridge/libbridge_init.c libbridge/libbridge_misc.c libbridge/libbridge_private.h
	$(Q)make -C libbridge

misc/bidi: misc/bidi.c
	make -C misc

misc/tap: misc/tap.c
	make -C misc
