



all:
	@echo "###Configuring CUPS"
	ac_cv_search_getaddrinfo=no ./configure \
		--prefix=/usr \
		--host=mips-linux-uclibc \
		--build=i386-linux \
		--enable-browsing \
		--disable-openssl \
		--disable-tiff \
		--disable-threads \
		--disable-gssapi \
		--without-php \
		--without-perl \
		--without-python \
		--without-java \
		--with-cachedir=/tmp/cups  \
		--localstatedir=/var \
		--enable-raw-printing \
		--disable-gnutls \
		--disable-dbus \
		--with-printcap=/var/tmp/cups/printcap \
		--disable-debug \
		CFLAGS="-ffunction-sections -fdata-sections" \
		LDFLAGS="-Wl,--gc-sections" INSTALL="$(INSTALL) -p"

	@echo "Building CUPS"
	make -C cups-plugin all
	make all


clean:
	@echo "###Cleaning CUPS"
	make -C cups-plugin clean
	make clean

install:
	@echo "###Installing cups to " $(STAGINGDIR)
	make -C cups-plugin install
	make install

uninstall:
	@echo "###Installing cups to " $(STAGINGDIR)
	make uninstall

release:
	@echo "###Releasing cups to " $(ROOT_FS_DIR)
	make -C cups-plugin release
	make rel

build_package:
	make -f Component.mk release ROOT_FS_DIR=$(COMP_PACKAGE_DIR)

release_package:
	cp -af $(COMP_PACKAGE_DIR)/* $(ROOT_FS_DIR)

.PHONY: clean all install uninstall release check build_package release_package
