include $(STAGINGDIR)/components.config 

#get the target cpu endianess
TARGET_CPU_ENDIAN=$(shell ./getendian.sh )

ifdef TARGET_MACHINE
	TYPE = --host=$(shell echo $(TARGET_MACHINE) | tr '[:upper:]' '[:lower:]')-linux
endif

ifeq ($(TARGET_CPU_ENDIAN),big)
CFLAGS="-I$(STAGINGDIR)/include/expat -I$(STAGINGDIR)/usr/include -DG_BYTE_ORDER=G_BIG_ENDIAN -DSTREAM_FILE -DCONFIG_SAH_SERVICES_FUSEPLUGINS_WDFS_WRITECACHESIZE=$(CONFIG_SAH_SERVICES_FUSEPLUGINS_WDFS_WRITECACHESIZE) -DCONFIG_SAH_SERVICES_FUSEPLUGINS_WDFS_READCACHESIZE=$(CONFIG_SAH_SERVICES_FUSEPLUGINS_WDFS_READCACHESIZE) -D_FILE_OFFSET_BITS=64"
else
CFLAGS="-I$(STAGINGDIR)/include/expat -I$(STAGINGDIR)/usr/include -DG_BYTE_ORDER=G_LITTLE_ENDIAN -DSTREAM_FILE -DCONFIG_SAH_SERVICES_FUSEPLUGINS_WDFS_WRITECACHESIZE=$(CONFIG_SAH_SERVICES_FUSEPLUGINS_WDFS_WRITECACHESIZE) -DCONFIG_SAH_SERVICES_FUSEPLUGINS_WDFS_READCACHESIZE=$(CONFIG_SAH_SERVICES_FUSEPLUGINS_WDFS_READCACHESIZE) -D_FILE_OFFSET_BITS=64"
endif
PKG_LIBS=$(shell pkg-config --libs openssl libcrypto neon)
LDFLAGS=$(PKG_LIBS)
src/Makefile:
	./configure --prefix=/ $(TYPE) --build=i386-linux \
	CFLAGS=$(CFLAGS) \
	LDFLAGS="$(PKG_LIBS) -ldl -L$(STAGINGDIR)/lib -L$(STAGINGDIR)/usr/lib -L../../neon-0.28.5/src/.libs/ " \
	WDFS_CFLAGS="-I$(STAGINGDIR)/include -I$(STAGINGDIR)/include/fuse -I$(STAGINGDIR)/include/libneon" \
	WDFS_LIBS="$(PKG_LIBS) -lpthread -lfuse"

all: src/Makefile
	@echo "-------------------------------------------------------------"
	@echo "- building wdfs"
	@echo "-------------------------------------------------------------"
	make all

clean:
	@echo "-------------------------------------------------------------"
	@echo "- cleaning wdfs"
	@echo "-------------------------------------------------------------"
	make distclean	

install: src/Makefile
	@echo "-------------------------------------------------------------"
	@echo "- installing wdfs to: " $(STAGINGDIR)
	@echo "-------------------------------------------------------------"
	make install DESTDIR=$(STAGINGDIR)

release:
	@echo "-------------------------------------------------------------"
	@echo "- make a wdfs release in: " $(ROOT_FS_DIR)
	@echo "-------------------------------------------------------------"
	$(INSTALL) -d $(ROOT_FS_DIR)/bin
	cp -dp $(STAGINGDIR)/bin/wdfs $(ROOT_FS_DIR)/bin
	$(STRIP) $(ROOT_FS_DIR)/bin/wdfs


package: src/Makefile
	@echo "-------------------------------------------------------------"
	@echo "- make a wdfs package in: " $(ROOT_FS_DIR)
	@echo "-------------------------------------------------------------"
	@if test -e "Makefile" ; \
	then \
	make -f Component.mk clean; \
	fi
	tar  -pczf $(ROOT_FS_DIR)/../sah_wdfs.tar.gz `find * | grep -v 'Component' | grep -v getendian`

.PHONY: clean all install release package
