/*
#############################################################################
#
# Copyright (c) Orange / France Telecom
# December 2012
# All rights reserved
#
# Author:
#   Frederic LEROY <frederic1.leroy@orange.com> - FT/SCE/G2S/NRS/IT LABS/UOGO/SFP/ARMOR
#   For Orange Labs - FT/OLNC/OLN/WTC/WHS/MAG
#
# Name:     DHCP L2 relay
# Release:  1
# Date:     26/12/2012
#
#############################################################################
*/
#ifndef _EBT_DHCP_RELAY_TARGET_H
#define _EBT_DHCP_RELAY_TARGET_H

#define OPT82_MAX 256

#define EBT_DHCP_RELAY_MODE 0x01
#define EBT_DHCP_RELAY_CID  0x02
#define EBT_DHCP_RELAY_RID  0x04
#define EBT_DHCP_RELAY_SID  0x08

struct xt_dhcp_relay_target_info {
	#define FORWARD 0
	#define REPLACE 1
	#define DISCARD 2
	#define STRIP   3
	uint8_t mode;
	uint8_t cid[OPT82_MAX]; /* suboption 1 - hsid */
	uint8_t cid_len;
	uint8_t rid[OPT82_MAX];  /* suboption 2 - cuid */
	uint8_t rid_len;
	uint8_t sid[OPT82_MAX];  /* suboption 6 - sid */
	uint8_t sid_len;
	uint8_t bitmask;
	void *data;
};

#define DHCP_CHADDR_MAX  16
#define DHCP_MAGIC_COOKIE

struct dhcp_packet {
	uint8_t op, htype, hlen, hops;
	uint32_t xid;
	uint16_t secs, flags;
	uint32_t ciaddr, yiaddr, siaddr, giaddr;
	uint8_t chaddr[DHCP_CHADDR_MAX], servername[64], bootfile[128];
	uint32_t magic_cookie;
	uint8_t data[0];
};

struct tlv_header {
	uint8_t type;
	uint8_t len;
} __attribute__((packed));


#endif /*_EBT_DHCP_RELAY_TARGET_H */
