include $(STAGINGDIR)/components.config
all:
ifeq ($(CONFIG_SAH_SERVICES_MTD_UBIFS_TOOLS),y)
	$(MAKE) BUILDDIR="." CC=$(CONFIG_CROSS_COMPILE)gcc WITHOUT_XATTR=0 MTD_UBIFS_TOOLS=1
else
	$(MAKE) BUILDDIR="." CC=$(CONFIG_CROSS_COMPILE)gcc WITHOUT_XATTR=0 MTD_UBIFS_TOOLS=0
endif

clean:
	$(MAKE) clean
	-rm -f *.o
	-rm -rf *.dep

install:
	$(INSTALL) -d $(STAGINGDIR)/usr/sbin
	$(INSTALL) -m 0755 flash_eraseall $(STAGINGDIR)/usr/sbin/eraseall
ifeq ($(CONFIG_SAH_SERVICES_MTD_TEST_TOOLS),y)
	$(INSTALL) -m 0755 mtd_debug $(STAGINGDIR)/usr/sbin/
	$(INSTALL) -m 0755 nanddump $(STAGINGDIR)/usr/sbin/
	$(INSTALL) -m 0755 nandtest $(STAGINGDIR)/usr/sbin/
	$(INSTALL) -m 0755 nandwrite $(STAGINGDIR)/usr/sbin/
	$(INSTALL) -m 0755 mtd_test_script.sh $(STAGINGDIR)/usr/sbin/
endif
ifeq ($(CONFIG_SAH_SERVICES_MTD_UBIFS_TOOLS),y)
	$(INSTALL) -m 0755 ubi-utils/ubi-utils/ubiattach $(STAGINGDIR)/usr/sbin/
	$(INSTALL) -m 0755 ubi-utils/ubi-utils/ubicrc32 $(STAGINGDIR)/usr/sbin/
	$(INSTALL) -m 0755 ubi-utils/ubi-utils/ubidetach $(STAGINGDIR)/usr/sbin/
	$(INSTALL) -m 0755 ubi-utils/ubi-utils/ubiformat $(STAGINGDIR)/usr/sbin/
	$(INSTALL) -m 0755 ubi-utils/ubi-utils/ubimkvol $(STAGINGDIR)/usr/sbin/
	$(INSTALL) -m 0755 ubi-utils/ubi-utils/ubinfo $(STAGINGDIR)/usr/sbin/
	$(INSTALL) -m 0755 ubi-utils/ubi-utils/ubinize $(STAGINGDIR)/usr/sbin/
	$(INSTALL) -m 0755 ubi-utils/ubi-utils/ubirename $(STAGINGDIR)/usr/sbin/
	$(INSTALL) -m 0755 ubi-utils/ubi-utils/ubirmvol $(STAGINGDIR)/usr/sbin/
	$(INSTALL) -m 0755 ubi-utils/ubi-utils/ubiupdatevol $(STAGINGDIR)/usr/sbin/
endif

release:
	$(INSTALL) -d $(ROOT_FS_DIR)/usr/sbin
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/eraseall $(ROOT_FS_DIR)/usr/sbin/
	$(STRIP) $(ROOT_FS_DIR)/usr/sbin/eraseall
ifeq ($(CONFIG_SAH_SERVICES_MTD_TEST_TOOLS),y)
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/mtd_debug $(ROOT_FS_DIR)/usr/sbin/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/nanddump $(ROOT_FS_DIR)/usr/sbin/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/nandtest $(ROOT_FS_DIR)/usr/sbin/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/nandwrite $(ROOT_FS_DIR)/usr/sbin/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/mtd_test_script.sh $(ROOT_FS_DIR)/usr/sbin/
endif
ifeq ($(CONFIG_SAH_SERVICES_MTD_UBIFS_TOOLS),y)
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/ubiattach $(ROOT_FS_DIR)/usr/sbin/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/ubicrc32 $(ROOT_FS_DIR)/usr/sbin/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/ubidetach $(ROOT_FS_DIR)/usr/sbin/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/ubiformat $(ROOT_FS_DIR)/usr/sbin/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/ubimkvol $(ROOT_FS_DIR)/usr/sbin/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/ubinfo $(ROOT_FS_DIR)/usr/sbin/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/ubinize $(ROOT_FS_DIR)/usr/sbin/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/ubirename $(ROOT_FS_DIR)/usr/sbin/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/ubirmvol $(ROOT_FS_DIR)/usr/sbin/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/sbin/ubiupdatevol $(ROOT_FS_DIR)/usr/sbin/
endif

.PHONY: clean install release all


