include $(STAGINGDIR)/components.config

ifeq ($(notdir $(CC)),gcc)
  NDISC6_FULL_CONFIGURATION:=
else
  NDISC6_FULL_CONFIGURATION:=--host=mips-linux --build=i686
endif


export NDISC6_FULL_CONFIGURATION

CFLAGS += -std=c99
export CFLAGS LDFLAGS

NDISC6-VERSION := ndisc6-1.0.1

all: ndisc6-all

clean:
	- [ -f $(NDISC6-VERSION)/Makefile ] && \
	  $(MAKE) -C $(NDISC6-VERSION) clean
	- find $(NDISC6-VERSION) -name .deps -exec rm -rf '{}' \;
	find $(NDISC6-VERSION) -name .dirstamp -exec rm '{}' \;
	find $(NDISC6-VERSION) -name "stamp-h?" -exec rm '{}' \;
	find $(NDISC6-VERSION) -name "Makefile" -exec rm '{}' \;
	rm -f $(NDISC6-VERSION)/autoconfig.h
	rm -f $(NDISC6-VERSION)/config.log
	rm -f $(NDISC6-VERSION)/config.status
	rm -f $(NDISC6-VERSION)/config.h
	rm -f $(NDISC6-VERSION)/*.pc
	rm -f $(NDISC6-VERSION)/po/POTFILES
	rm -f $(NDISC6-VERSION)/po/Makefile.in
	rm -rf $(NDISC6-VERSION)/autom4te.cache

install:
	$(INSTALL) -d $(STAGINGDIR)/usr/bin/
ifeq ($(CONFIG_SAH_SERVICES_NDISC6_NAME2ADDR), y)
	$(INSTALL) -m 0755 $(NDISC6-VERSION)/src/addr2name $(STAGINGDIR)/usr/bin/
	$(INSTALL) -m 0755 $(NDISC6-VERSION)/src/name2addr $(STAGINGDIR)/usr/bin/
endif
ifeq ($(CONFIG_SAH_SERVICES_NDISC6_NDISC6), y)
	$(INSTALL) -m 0755 $(NDISC6-VERSION)/src/ndisc6 $(STAGINGDIR)/usr/bin/
endif
ifeq ($(CONFIG_SAH_SERVICES_NDISC6_RDISC6), y)
	$(INSTALL) -m 0755 $(NDISC6-VERSION)/src/rdisc6 $(STAGINGDIR)/usr/bin/
endif
ifeq ($(CONFIG_SAH_SERVICES_NDISC6_TRACEROUTE6), y)
	$(INSTALL) -m 0755 $(NDISC6-VERSION)/src/rltraceroute6 $(STAGINGDIR)/usr/bin/
	$(INSTALL) -m 0755 $(NDISC6-VERSION)/src/tcptraceroute6 $(STAGINGDIR)/usr/bin/
	$(INSTALL) -m 0755 $(NDISC6-VERSION)/src/tracert6 $(STAGINGDIR)/usr/bin/
endif
ifeq ($(CONFIG_SAH_SERVICES_NDISC6_TCPSPRAY6), y)
	$(INSTALL) -m 0755 $(NDISC6-VERSION)/src/tcpspray $(STAGINGDIR)/usr/bin/
	$(INSTALL) -m 0755 $(NDISC6-VERSION)/src/tcpspray6 $(STAGINGDIR)/usr/bin/
endif

release:
	$(INSTALL) -d $(ROOT_FS_DIR)/usr/bin
ifeq ($(CONFIG_SAH_SERVICES_NDISC6_NAME2ADDR), y)
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/bin/addr2name $(ROOT_FS_DIR)/usr/bin/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/bin/name2addr $(ROOT_FS_DIR)/usr/bin/
	$(STRIP) $(ROOT_FS_DIR)/usr/bin/name2addr
endif
ifeq ($(CONFIG_SAH_SERVICES_NDISC6_NDISC6), y)
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/bin/ndisc6 $(ROOT_FS_DIR)/usr/bin/
	$(STRIP) $(ROOT_FS_DIR)/usr/bin/ndisc6
endif
ifeq ($(CONFIG_SAH_SERVICES_NDISC6_TRACEROUTE6), y)
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/bin/rdisc6 $(ROOT_FS_DIR)/usr/bin/
	$(STRIP) $(ROOT_FS_DIR)/usr/bin/rdisc6
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/bin/tcptraceroute6 $(ROOT_FS_DIR)/usr/bin/
	$(STRIP) $(ROOT_FS_DIR)/usr/bin/tcptraceroute6
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/bin/tracert6 $(ROOT_FS_DIR)/usr/bin/
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/bin/rltraceroute6 $(ROOT_FS_DIR)/usr/bin/
	$(STRIP) $(ROOT_FS_DIR)/usr/bin/rltraceroute6
endif
ifeq ($(CONFIG_SAH_SERVICES_NDISC6_TCPSPRAY6), y)
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/bin/tcpspray $(ROOT_FS_DIR)/usr/bin/
	$(STRIP) $(ROOT_FS_DIR)/usr/bin/tcpspray
	$(INSTALL) -m 0755 $(STAGINGDIR)/usr/bin/tcpspray6 $(ROOT_FS_DIR)/usr/bin/
endif

$(NDISC6-VERSION)/Makefile:
	cd $(NDISC6-VERSION); \
	./configure $(NDISC6_FULL_CONFIGURATION)

ndisc6-all: $(NDISC6-VERSION)/Makefile
	make -C $(NDISC6-VERSION) all

.PHONY: all clean install release
