################################################################
# project.lst build flags
#
# SAH_DEBUG..........: No optimalization, trace level set to 500
# SAH_DEBUG_NO_STRIP.: No stripping during release step
#
################################################################

ifndef STAGINGDIR
  $(error STAGINGDIR not defined, stopping build)
endif

include $(STAGINGDIR)/sahcommon.mk

INSTALL ?= install
STRIP ?= strip

export CFLAGS += -fPIC

all:
	$(MAKE) -C src all

clean:
	$(MAKE) -C src clean

install:
	$(INSTALL) -D -m 0755 src/libpcb_serialize_odl.so $(STAGINGDIR)/usr/lib/pcb/libpcb_serialize_odl.so

release:
	$(INSTALL) -D -m 755 $(STAGINGDIR)/usr/lib/pcb/libpcb_serialize_odl.so $(ROOT_FS_DIR)/usr/lib/pcb/libpcb_serialize_odl.so
ifndef SAH_DEBUG_NO_STRIP
	$(STRIP) $(ROOT_FS_DIR)/usr/lib/pcb/libpcb_serialize_odl.so
endif

.PHONY: all clean install release

