include $(STAGINGDIR)/components.config
include $(STAGINGDIR)/install_scripts.mk

LIBUSB_CFLAGS = -I$(STAGINGDIR)/include
LIBUSB_LIBS = -L$(STAGINGDIR)/lib -lusb

CONFIG_SAH_SERVICES_PCSCLITE_BOOTORDER ?= 05

all: Makefile
	make

Makefile:
	./configure --host=$(AUTOCONF_HOST) \
	  --prefix=$(STAGINGDIR) \
 	  --enable-usbdropdir=/lib/pcsc/drivers/ \
    --with-gnu-ld     \
    --enable-shared   \
    --disable-static  \
    --disable-serial  \
    --enable-libudev  \
    --enable-usb      \
    --disable-libusb
#    --enable-embedded \

clean:
	if [ -f Makefile ]; then make distclean ; fi

install: Makefile
	make install
	$(call install_init,scripts/pcscd,$(CONFIG_SAH_SERVICES_PCSCLITE_BOOTORDER),$(CONFIG_SAH_SERVICES_PCSCLITE_SHUTDOWNORDER))

release:
	$(INSTALL) -d $(ROOT_FS_DIR)/lib
	$(INSTALL) -d $(ROOT_FS_DIR)/sbin
	$(INSTALL) -m 755 $(STAGINGDIR)/sbin/pcscd $(ROOT_FS_DIR)/sbin
	$(STRIP) $(ROOT_FS_DIR)/sbin/pcscd
	$(INSTALL) -m 644 $(STAGINGDIR)/lib/libpcsclite.so.1.0.0 $(ROOT_FS_DIR)/lib/libpcsclite.so
	$(STRIP) $(ROOT_FS_DIR)/lib/libpcsclite.so
	$(call install_init_release,scripts/pcscd,$(CONFIG_SAH_SERVICES_PCSCLITE_BOOTORDER),$(CONFIG_SAH_SERVICES_PCSCLITE_SHUTDOWNORDER))

.PHONY: clean install release
