-include $(STAGINGDIR)/components.config

ifeq ($(notdir $(CC)),gcc)
  SAMBA_FULL_CONFIGURATION:=$(SAMBA_FULL_CONFIGURATION) --host=i386-linux --enable-shared --with-gnu-ld
  CONFIG_SITE=
else
  SAMBA_FULL_CONFIGURATION:=$(SAMBA_FULL_CONFIGURATION) --build=i386-linux --host=mips-linux
  CONFIG_SITE=../config.hgw
endif

ifdef CONFIG_SAH_SERVICES_SAMBA_CHROOT
SAMBA_FULL_CONFIGURATION += --with-chroot=$(CONFIG_SAH_SERVICES_SAMBA_CHROOT)
endif

ifdef CONFIG_SAH_SERVICES_SAMBA_USER
SAMBA_FULL_CONFIGURATION += --with-user=$(CONFIG_SAH_SERVICES_SAMBA_USER)
endif

export SAMBA_FULL_CONFIGURATION

SAMBA_SOURCE=source

all: samba

$(SAMBA_SOURCE)/include/stamp-h: $(STAGINGDIR)/components.config
	cd $(SAMBA_SOURCE) && \
		CONFIG_SITE=$(CONFIG_SITE) ./configure --prefix=/usr \
							  --with-privatedir=/var/etc/samba \
							  --with-lockdir=/var/etc/samba \
							  --with-piddir=/var/etc/samba $(SAMBA_FULL_CONFIGURATION) \
							  --with-configdir=/var/etc/samba \
							  --disable-cups \
							  --disable-iprint \
							  --disable-pie \
							  --disable-fam \
							  --without-ldap \
					  		  --without-libaddns \
							  --without-cifsmount \
							  --without-sendfile-support \
							  CFLAGS="$(CFLAGS) -Os -DSAH_NO_PRINTING -D_FILE_OFFSET_BITS=64 -ffunction-sections -fdata-sections" \
							  LDFLAGS="$(LDFLAGS) -Wl,--gc-sections"


samba: $(SAMBA_SOURCE)/include/stamp-h
	make -C $(SAMBA_SOURCE) bin/nmbd
	make -C $(SAMBA_SOURCE) bin/smbd
ifeq ($(CONFIG_SAH_SERVICES_SAMBA_CLIENT_ENABLE),y)
	make -C $(SAMBA_SOURCE) bin/smbclient
endif

clean:
	make -C $(SAMBA_SOURCE) distclean

install:
	echo "Install SAMBA to: " $(STAGINGDIR)
	$(INSTALL) -d $(STAGINGDIR)/sbin
ifeq ($(CONFIG_SAH_SERVICES_SAMBA_DEFAULT_ENABLE),y)
	$(INSTALL) -m 755 ./source/bin/smbd $(STAGINGDIR)/sbin
	$(INSTALL) -m 755 ./source/bin/nmbd $(STAGINGDIR)/sbin
endif
ifeq ($(CONFIG_SAH_SERVICES_SAMBA_CLIENT_ENABLE),y)
	$(INSTALL) -m 755 ./source/bin/smbclient $(STAGINGDIR)/sbin
endif


release:
	echo "Release SAMBA to: $(ROOT_FS_DIR)"
	$(INSTALL) -d 0755 $(ROOT_FS_DIR)/sbin
ifeq ($(CONFIG_SAH_SERVICES_SAMBA_DEFAULT_ENABLE),y)
	$(INSTALL) -m 0755 $(STAGINGDIR)/sbin/nmbd $(ROOT_FS_DIR)/sbin/nmbd
	$(STRIP) $(ROOT_FS_DIR)/sbin/nmbd
	$(INSTALL) -m 0755 $(STAGINGDIR)/sbin/smbd $(ROOT_FS_DIR)/sbin/smbd
	$(STRIP) $(ROOT_FS_DIR)/sbin/smbd
	$(INSTALL) -d 0755 $(ROOT_FS_DIR)/var/samba
endif
ifeq ($(CONFIG_SAH_SERVICES_SAMBA_CLIENT_ENABLE),y)
	$(INSTALL) -m 755  $(STAGINGDIR)/sbin/smbclient $(ROOT_FS_DIR)/sbin/smbclient
	$(STRIP) $(ROOT_FS_DIR)/sbin/smbclient
endif

.PHONY: all samba clean install release


