-include $(STAGINGDIR)/components.config

export PKG_CONFIG_PATH=$(STAGINGDIR)/usr/lib/pkgconfig

CONFIG_FLAGS=--prefix=/ --build=i386-linux --host=mips-linux \
				--disable-extras --disable-introspection --libexecdir=/lib/udev --sysconfdir=/lib/udev/etc\
				CFLAGS="-Wall -g -Os"

ifeq ($(CONFIG_SAH_SERVICE_UDEV_DEBUG),y)
CONFIG_FLAGS+=--enable-debug
endif

EXTRAS=scsi_id usb_id

all: Makefile
	make all

Makefile:
	./configure $(CONFIG_FLAGS)

install:
	$(INSTALL) -d $(STAGINGDIR)/sbin
	$(INSTALL) -d $(STAGINGDIR)/lib/udev/rules.d
	$(INSTALL) -d $(PKG_CONFIG_LIBDIR)
	$(INSTALL) -m 0755 ./udev/udevd $(STAGINGDIR)/sbin/udevd
	$(INSTALL) -m 0755 ./udev/udevadm $(STAGINGDIR)/sbin/udevadm
	$(INSTALL) -m 0755 ./libudev/.libs/libudev.so $(STAGINGDIR)/lib
	$(foreach extra,$(EXTRAS), $(INSTALL) -m 0755 ./extras/$(extra)/$(extra) $(STAGINGDIR)/lib/udev;)
	$(INSTALL) -m 0755 ./libudev/libudev.pc $(PKG_CONFIG_LIBDIR)
	$(INSTALL) -m 0755 ./udev/udev.pc $(PKG_CONFIG_LIBDIR)
	$(INSTALL) -m 0644 ./rules/sah/* $(STAGINGDIR)/lib/udev/rules.d
	$(INSTALL) -m 0644 ./libudev/libudev.h $(STAGINGDIR)/include


release:
	$(INSTALL) -d $(ROOT_FS_DIR)/sbin
	$(INSTALL) -d $(ROOT_FS_DIR)/lib/udev/rules.d
	$(INSTALL) -d $(ROOT_FS_DIR)/lib/udev/devices/pts
	$(INSTALL) -d $(ROOT_FS_DIR)/lib/udev/devices/net
	$(INSTALL) -m 0755 $(STAGINGDIR)/sbin/udevd $(ROOT_FS_DIR)/sbin/udevd
	$(INSTALL) -m 0755 $(STAGINGDIR)/sbin/udevadm $(ROOT_FS_DIR)/sbin/udevadm
	$(INSTALL) -m 0755 $(STAGINGDIR)/lib/libudev.so* $(ROOT_FS_DIR)/lib
	$(INSTALL) -m 0644 $(STAGINGDIR)/lib/udev/rules.d/* $(ROOT_FS_DIR)/lib/udev/rules.d
	$(foreach extra,$(EXTRAS), $(INSTALL) -m 0755 $(STAGINGDIR)/lib/udev/$(extra) $(ROOT_FS_DIR)/lib/udev;)
	$(foreach extra,$(EXTRAS), $(STRIP) $(ROOT_FS_DIR)/lib/udev/$(extra);)
	$(STRIP) $(ROOT_FS_DIR)/sbin/udevd
	$(STRIP) $(ROOT_FS_DIR)/sbin/udevadm
	$(STRIP) $(ROOT_FS_DIR)/lib/libudev.so
	mknod $(ROOT_FS_DIR)/lib/udev/devices/null -m 0600 c 1 3
	mknod $(ROOT_FS_DIR)/lib/udev/devices/console -m 0600 c 5 1
	mknod $(ROOT_FS_DIR)/lib/udev/devices/net/tun -m 0600 c 10 200


clean:
	test -e Makefile || make distclean

